# Colors

| **Documentation**                       | **Build Status**                          | **Code Coverage**               |
|:---------------------------------------:|:-----------------------------------------:|:-------------------------------:|
| [![][docs-stable-img]][docs-stable-url] | [![Build Status][action-img]][action-url] | [![][codecov-img]][codecov-url] |
| [![][docs-dev-img]][docs-dev-url]       | [![PkgEval][pkgeval-img]][pkgeval-url]    |                                 |

This library provides a wide array of functions for dealing with color. This
includes conversion between colorspaces, measuring distance between colors,
simulating color blindness, parsing colors, and generating color scales for graphics.

The core color types, along with some simple utilities, are defined and documented in [ColorTypes](https://github.com/JuliaGraphics/ColorTypes.jl).
You can use ColorTypes as a standalone package if you do not need the more extensive color-manipulation utilities defined here.

Basic color arithmetic is available with `using ColorVectorSpace`; see [its documentation](https://github.com/JuliaGraphics/ColorVectorSpace.jl) for why it's a separate package.

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://juliagraphics.github.io/Colors.jl/dev/

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://juliagraphics.github.io/Colors.jl/stable/

[action-img]: https://github.com/JuliaGraphics/Colors.jl/workflows/Unit%20test/badge.svg
[action-url]: https://github.com/JuliaGraphics/Colors.jl/actions

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/C/Colors.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html

[codecov-img]: https://codecov.io/gh/JuliaGraphics/Colors.jl/branch/master/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaGraphics/Colors.jl

using Test, Colors

@testset "Colormaps" begin
    @testset "distinguishable_colors" begin
        cols = distinguishable_colors(10)
        @test isconcretetype(eltype(cols))

        mindiff = Inf
        for i = 1:10, j = i+1:10
            mindiff = min(mindiff, colordiff(cols[i], cols[j]))
        end
        @test mindiff > 8

        seed = distinguishable_colors(1)
        @test colordiff(distinguishable_colors(1, seed)[1], seed[1]) == 0.0
        @test colordiff(distinguishable_colors(1, seed; dropseed=true)[1], seed[1]) > 50

        cols_i = distinguishable_colors(4, LCHab(60, 50, 40), transform=identity,
                                        lchoices=[40, 60], cchoices=[50], hchoices=[40, 140])
        cols_p = distinguishable_colors(4, LCHab(60, 50, 40), transform=protanopic,
                                        lchoices=[40, 60], cchoices=[50], hchoices=[40, 140])
        @test cols_i[2] ≈ LCHab(40, 50, 140) atol=1f-3 # green
        @test cols_p[2] ≈ LCHab(40, 50,  40) atol=1f-3 # red
    end

    @test length(colormap("RdBu", 100)) == 100

    @test isconcretetype(eltype(colormap("Grays")))

    @test_throws ArgumentError colormap("Grays", N=10) # optional arguments, not keyword

    # not return values to check here, just checking that keywords can be used
    # Sequential
    default_blues = colormap("Blues", 10)
    @test_throws ArgumentError colormap("Blues", 10; mid=0.9) # `mid` is for diverging colormaps only (issue #300)
    @test colormap("Blues", 10; logscale=true) != default_blues
    @test colormap("Blues", 10; h=0.5) != default_blues
    @test colormap("Blues", 10; w=0.5) != default_blues
    @test colormap("Blues", 10; d=0.5) != default_blues
    @test colormap("Blues", 10; c=0.5) != default_blues
    @test colormap("Blues", 10; s=0.5) != default_blues
    @test colormap("Blues", 10; b=0.5) != default_blues
    @test colormap("Blues", 10; wcolor=colorant"white") != default_blues
    @test colormap("Blues", 10; dcolor=colorant"black") != default_blues
    @test_throws ArgumentError colormap("Blues", 10; h1=0.5)

    # Diverging
    default_rdbu = colormap("RdBu", 10)
    @test colormap("RdBu", 10; mid=0.9) != default_rdbu
    @test colormap("RdBu", 10; logscale=true) != default_rdbu
    @test colormap("RdBu", 10; h1=0.5) != default_rdbu
    @test colormap("RdBu", 10; h2=0.5) != default_rdbu
    @test colormap("RdBu", 10; w=0.5) != default_rdbu
    @test colormap("RdBu", 10; d1=0.5) != default_rdbu
    @test colormap("RdBu", 10; d2=0.5) != default_rdbu
    @test colormap("RdBu", 10; c=0.5) != default_rdbu
    @test colormap("RdBu", 10; s=0.5) != default_rdbu
    @test colormap("RdBu", 10; b=0.5) != default_rdbu
    @test colormap("RdBu", 10; wcolor=colorant"white") != default_rdbu
    @test colormap("RdBu", 10; dcolor1=colorant"black") != default_rdbu
    # `dcolor2` is disabled by the default `d2`(=0)
    @test colormap("RdBu", 10; dcolor2=colorant"black", d2=1) != default_rdbu
    @test_throws ArgumentError colormap("RdBu", 10; h=0.5)

    # The outputs of `colormap()` were slightly affected by the bug fix of
    # `MSC(h)` (issue #349).
    # The following were generated by `colormap()` in Colors.jl v0.9.6.
    blues_old   = (0xF4FDFF, 0xB3E3F4, 0x65B9E7, 0x2978BE, 0x0B2857)
    greens_old  = (0xFAFFF7, 0xB6EEA0, 0x75C769, 0x308B40, 0x00391A)
    grays_old   = (0xFFFFFF, 0xDCDCDC, 0xA9A9A9, 0x626262, 0x000000)
    oranges_old = (0xFFFBF6, 0xFFD6B4, 0xFF9D5F, 0xE2500D, 0x732108)
    purples_old = (0xFBFBFB, 0xDBD7F6, 0xAFA7E6, 0x7666BF, 0x3C0468)
    reds_old    = (0xFFF1EE, 0xFFC4B9, 0xFF8576, 0xE72823, 0x6D0B0C)
    rdbu_old    = (0x610102, 0xFF8D7B, 0xF9F8F9, 0x76B4E8, 0x092C58)

    to_rgb(s) = reinterpret(RGB24, s)
    max_colordiff(a1, a2) = maximum(colordiff.(a1, a2))
    @test max_colordiff(colormap("Blues", 5), to_rgb.(blues_old)) < 1
    @test max_colordiff(colormap("Greens", 5), to_rgb.(greens_old)) < 1
    @test max_colordiff(colormap("Grays", 5), to_rgb.(grays_old)) < 1
    @test max_colordiff(colormap("Oranges", 5), to_rgb.(oranges_old)) < 1
    @test max_colordiff(colormap("Purples", 5), to_rgb.(purples_old)) < 1
    @test max_colordiff(colormap("Reds", 5), to_rgb.(reds_old)) < 1
    @test max_colordiff(colormap("RdBu", 5), to_rgb.(rdbu_old)) < 1

    cyans = sequential_palette(192, w=1.0, d=1.0, wcolor=RGB(1,1,1), dcolor=RGB(0,0,0))
    @test all(c -> isapprox(green(c), blue(c), atol=1e-3), cyans)

    ryr = diverging_palette(0.0, 359.999, 45, w=0.9, c=0.7, dcolor1=RGB(0,0,1))
    @test all(c -> isapprox(c[1], c[2], atol=1e-3), zip(ryr, reverse(ryr)))
end

module PNG16x16

using Colors
using Base64

export write_png_as_data, write_png

function write_png_as_data(io::IO, cs::AbstractMatrix{<:Color})
    write(io, "data:image/png;base64,")
    b64enc = Base64EncodePipe(io)
    write_png(b64enc, cs)
    close(b64enc)
end

function write_png(io::IO, cs::AbstractMatrix{<:Color})
    buf = IOBuffer() # to calculate chunk CRCs
    n = 16 # 16 x 16
    u8(x) = write(buf, UInt8(x & 0xFF))
    u16(x) = (u8((x & 0xFFFF)>>8); u8(x))
    u32(x) = (u16((x & 0xFFFFFFFF)>>16); u16(x))
    b(bstr) = write(buf, bstr)
    function palette(c::Color)
        rgb24 = convert(RGB24,c)
        u8(rgb24.color>>16); u8(rgb24.color>>8); u8(rgb24.color)
    end
    crct(x) = (for i = 1:8; x = x & 1==1 ? 0xEDB88320 ⊻ (x>>1) : x>>1 end; x)
    table = UInt32[crct(i) for i = 0x00:0xFF]
    function crc32()
        seekstart(buf)
        crc = 0xFFFFFFFF
        while !eof(buf)
            crc = (crc>>8) ⊻ table[(crc&0xFF) ⊻ read(buf, UInt8) + 1]
        end
        u32(crc ⊻ 0xFFFFFFFF)
    end
    flush() = write(io, take!(seekstart(buf)))

    # The following is a pre-encoded 256-indexed-color PNG with size of 16x16.
    # We only rewrite "pallets".
    b(b"\x89PNG\x0D\x0A\x1A\x0A")
    # Image header
    u32(13); flush(); b(b"IHDR"); u32(n); u32(n); u8(8); u8(3); u8(0); u8(0); u8(0); crc32()
    # Palette
    u32(n * n * 3); flush();
    b(b"PLTE")
    for y = 1:n, x = 1:n
        palette(cs[y,x])
    end
    crc32()
    # Image data
    u32(58); flush(); b(b"IDAT")
    b(b"\x78\xDA\x63\x64\x60\x44\x03\x02\xE8\x02\x0A\xE8\x02\x06\xE8\x02")
    b(b"\x0E\xE8\x02\x01\xE8\x02\x09\xE8\x02\x05\xE8\x02\x0D\xE8\x02\x13")
    b(b"\xD0\x05\x16\xA0\x0B\x6C\x40\x17\x38\x80\x2E\x70\x01\x5D\xE0\x01")
    b(b"\xBA\xC0\x07\x34\x3E\x00\x54\x4D\x08\x81"); crc32()
    # Image trailer
    u32(0); flush(); b(b"IEND"); crc32()
    flush()
end

"""
# Image data
using CodecZlib
raw = IOBuffer()
for y = 0:15
    write(raw, UInt8(1)) # filter: SUB
    write(raw, UInt8(y*16)) # line head
    write(raw, UInt8[1 for i=1:15]) # left + 1
end
flush(raw)
cd = ZlibCompressorStream(raw,level=9)
flush(cd)
seekstart(cd)
@show read(cd) # UInt8[0x78, 0xda, 0x63, 0x64, ...
"""

end # module

# Define an abstract type to represent color difference metrics
abstract type DifferenceMetric end

abstract type EuclideanDifferenceMetric{T<:Color3} <: DifferenceMetric end

# TODO?: make the DifferenMetrics parametric, to preserve type-stability

struct DE_2000 <: DifferenceMetric
    kl::Float64
    kc::Float64
    kh::Float64
    DE_2000(kl=1, kc=1, kh=1) = new(kl, kc, kh)
end
"""
    DE_2000(kl=1, kc=1, kh=1)

Construct a metric of the CIE Delta E 2000 recommendation, with weighting
parameters `kl`, `kc` and `kh` as provided for in the recommendation. When not
provided, these parameters default to `1`.
"""
DE_2000()


struct DE_94 <: DifferenceMetric
    kl::Float64
    kc::Float64
    kh::Float64
    k1::Float64
    k2::Float64
    DE_94(kl=1, kc=1, kh=1, k1=0.045, k2=0.015) = new(kl, kc, kh, k1, k2)
end
"""
    DE_94(kl=1, kc=1, kh=1, k1=0.045, k2=0.015)

Construct a metric of CIE Delta E 94 recommendation (1994), with weighting
parameters `kl`, `kc`, `kh`, `k1`, and `k2` as provided for in the
recommendation. The `kl`, `k1`, and `k2` depend on the application:

|    |Graphic Arts|Textiles|
|:--:|:-----------|:-------|
|`kl`|`1`         |`2`     |
|`k1`|`0.045`     |`0.048` |
|`k2`|`0.015`     |`0.014` |

and the default values are for graphic arts. The `kc` and `kh` default to `1`.

The `DE_94` is more perceptually uniform than the [`DE_AB`](@ref), but has some
non-uniformities resolved by the [`DE_2000`](@ref).

!!! note
    The `DE_94` is a quasimetric, i.e. violates symmetry. Therefore,
    `colordiff(a, b, metric=DE_94())` may not equal to
    `colordiff(b, a, metric=DE_94())`.
    The first argument of `colordiff` is taken as the reference (standard)
    color.
"""
DE_94()


struct DE_JPC79 <: DifferenceMetric

end
"""
    DE_JPC79()

Construct a metric using McDonald's "JP Coates Thread Company" color difference
formula.
"""
DE_JPC79()


struct DE_CMC <: DifferenceMetric
    kl::Float64
    kc::Float64
    DE_CMC(kl=1, kc=1) = new(kl, kc)
end
"""
    DE_CMC(kl=1, kc=1)

Construct a metric using the CMC equation (CMC l:c), with weighting parameters
`kl` and `kc`. When not provided, these parameters default to `1`.

!!! note
    The `DE_CMC` is a quasimetric, i.e. violates symmetry. Therefore,
    `colordiff(a, b, metric=DE_CMC())` may not equal to
    `colordiff(b, a, metric=DE_CMC())`.
    The first argument of `colordiff` is taken as the reference (standard)
    color.
"""
DE_CMC()


struct DE_BFD <: DifferenceMetric
    wp::XYZ{Float64}
    kl::Float64
    kc::Float64
    DE_BFD(wp::XYZ, kl=1, kc=1) = new(wp, kl, kc)
end
"""
    DE_BFD([wp,] kl=1, kc=1)

Construct a metric using the BFD equation, with weighting parameters `kl` and
`kc`. Additionally, a whitepoint `wp` can be specified, because the BFD equation
must convert between `XYZ` and `Lab` during the computation. When not provided,
`kl` and `kc` default to `1`, and `wp` defaults to CIE D65 (`Colors.WP_D65`).
"""
DE_BFD(kl=1, kc=1) = DE_BFD(WP_DEFAULT, kl, kc)

struct DE_AB <: EuclideanDifferenceMetric{Lab}

end
"""
    DE_AB()

Construct a metric of the original CIE Delta E equation (ΔE*ab), or Euclidean
color difference equation in the `Lab` (CIELAB) colorspace.
"""
DE_AB()

struct DE_DIN99 <: EuclideanDifferenceMetric{DIN99}

end
"""
    DE_DIN99()

Construct a metric using Euclidean color difference equation applied in the
`DIN99` colorspace.
"""
DE_DIN99()

struct DE_DIN99d <: EuclideanDifferenceMetric{DIN99d}

end
"""
    DE_DIN99d()

Construct a metric using Euclidean color difference equation applied in the
`DIN99d` colorspace.
"""
DE_DIN99d()

struct DE_DIN99o <: EuclideanDifferenceMetric{DIN99o}

end
"""
    DE_DIN99o()

Construct a metric using Euclidean color difference equation applied in the
`DIN99o` colorspace.
"""
DE_DIN99o()

# Color difference metrics
# ------------------------

# Evaluate the CIEDE2000 color difference formula, implemented according to:
#   Klaus Witt, CIE Color Difference Metrics, Colorimetry: Understanding the CIE
#   System. 2007
#
# Args:
#   a, b: Any two colors.
#
# Returns:
#   The CIEDE2000 color difference metric evaluated between a and b.
#


# Delta E 2000
# Ensure that the input values are in L*a*b* space
function _colordiff(a::Color, b::Color, m::DE_2000)
    _colordiff(promote(convert(Lab, a), convert(Lab, b))..., m)
end
function _colordiff(a_lab::Lab{T}, b_lab::Lab{T}, m::DE_2000) where T
    F = typeof(0.5f0 * zero(T)) === Float32 ? Float32 : promote_type(Float64, T)
    _sqrt(x) = @fastmath(sqrt(x))

    # Calculate some necessary factors from the L*a*b* values
    mco7 = pow7((chroma(a_lab) + chroma(b_lab)) * F(0.5 / 25))
    g = F(0.5) - F(0.5) * F(_sqrt(mco7 / (mco7 + 1)))

    a = Lab{F}(a_lab.l, muladd(a_lab.a, g, a_lab.a), a_lab.b)
    b = Lab{F}(b_lab.l, muladd(b_lab.a, g, b_lab.a), b_lab.b)

    # Calculate the delta values for each channel
    dl, dc, dh = b.l - a.l, delta_c(b, a), delta_h(b, a)

    # Calculate mean L*, C* and hue values
    ml, mc, mh = (a.l + b.l) * F(0.5), (chroma(a) + chroma(b)) * F(0.5), mean_hue(a, b)

    # lightness weight
    mls = (ml - 50)^2
    sl = muladd(F(0.015), mls / _sqrt(20 + mls), 1)

    # chroma weight
    sc = muladd(F(0.045), mc, 1)

    # hue weight
    sh = muladd(F(0.015), mc * _de2000_t(mh), 1)

    # rotation term
    mc7 = pow7(mc * F(1 / 25))
    rt = -2 * F(_sqrt(mc7 / (mc7 + 1))) * _de2000_rot(mh)

    # Final calculation
    kl, kc, kh = F(m.kl), F(m.kc), F(m.kh)
    dsl, dsc, dsh = dl / (kl * sl), dc / (kc * sc), dh / (kh * sh)
    F(_sqrt(dsl^2 + dsc^2 + dsh^2 + rt * dsc * dsh))
end

@inline function _de2000_t(mh::F) where F
    h2 = mh < F(180) ? mh : mh - F(180)
    h3 = mh < F(120) ? mh : mh - F(240)
    h4 = h2 < F( 90) ? h2 : h2 - F(90)
    c = F(-17) * cos(muladd(π/F(180), mh, deg2rad(F(-30)))) +
        F( 24) * cos(  h2 * π/F( 90)) +
        F( 32) * cos(muladd(π/F( 60), h3, deg2rad(F(6)))) +
        F(-20) * cos(muladd(π/F( 45), h4, deg2rad(F(-63))))
    muladd(1/F(100), c, 1)
end
function _de2000_t(mh::Float32)
    if mh < 64.0f0
        return @evalpoly((mh - 32.0f0) * (1.0f0/64),
            0.78425723f0, -0.71428823f0, 1.0606939f0, -0.3320813f0, -1.6548954f0, 1.4866706f0,
            1.0461172f0, -0.9630005f0, -0.35182664f0, 0.2700254f0, 0.06314228f0)
    elseif mh < 128.0f0
        return @evalpoly((mh - 96.0f0) * (1.0f0/64),
            0.6708259f0, 0.7022065f0, 1.4496115f0, -0.091134265f0, -2.14522f0, -0.81226975f0,
            1.5013183f0, 0.60370386f0, -0.5584273f0, -0.1776522f0, 0.11164045f0)
    elseif mh < 192.0f0
        return @evalpoly((mh - 160.0f0) * (1.0f0/64),
            1.2647604f0, -0.9152141f0, -1.0652254f0, 3.0960295f0, 1.8619311f0, -2.6234343f0,
            -1.4259213f0, 1.0765249f0, 0.55065846f0, -0.2422152f0, -0.11089423f0)
    elseif mh < 236.0f0
        return @evalpoly((mh - 214.0f0) * (1.0f0/64),
            1.2999026f0, 1.364039f0, -0.30168927f0, -4.335773f0, -0.34714356f0, 3.8063064f0,
            0.43577778f0, -1.6205053f0, -0.19063109f0, 0.3946184f0, 0.0470799f0)
    elseif mh < 268.0f0
        return @evalpoly((mh - 252.0f0) * (1.0f0/64),
            1.3113983f0, -1.7916181f0, -2.341132f0, 3.733874f0, 3.4045563f0, -2.9195895f0,
            -1.9971917f0, 1.2059773f0, 0.6468915f0, -0.2969976f0, -0.1274673f0)
    elseif mh < 320.0f0
        return @evalpoly((mh - 294.0f0) * (1.0f0/64),
            0.37643716f0, 0.47334087f0, 3.8213744f0, -1.4942352f0, -4.5954514f0, 1.4621881f0,
            2.4966235f0, -0.71292526f0, -0.78470963f0, 0.18798664f0, 0.1509905f0)
    else
        return @evalpoly((mh - 340.0f0) * (1.0f0/64),
            1.4223951f0, 0.5289211f0, -3.0410407f0, -0.09073099f0, 3.824369f0, -0.80474544f0,
            -2.16635f0, 0.59577477f0, 0.70546037f0, -0.18656555f0, -0.1424503f0)
    end
end

@inline _de2000_rot(mh::F) where {F} = sin(π/F(3) * exp(-((mh - 275) * F(1/25))^2))

const DE2000_SINEXP_F32 = [Float32(π/3 * exp(-i)) for i = 0.0:0.25:87.25]
@inline function _de2000_rot(mh::Float32)
    dh2 = ((mh - 275.0f0) * (1.0f0 / 25))^2
    di = reinterpret(UInt32, dh2 + Float32(0x3p20))
    i = di % UInt16 # round(UInt16, dh2 * 4.0)
    i >= UInt16(350) && return 0.0f0 # avoid subnormal numbers
    t = (reinterpret(Float32, di) - Float32(0x3p20)) - dh2 # |t| <= 0.125
    sinexp = @inbounds DE2000_SINEXP_F32[i + 1] # π/3 * exp(-dh2) = (π/3 * exp(-i/4)) * exp(t)
    em1 = @evalpoly(t, 1.0f0, 0.49999988f0, 0.16666684f0, 0.041693877f0, 0.008323605f0) * t
    ex = muladd(sinexp, em1, sinexp)
    ex < eps(0.5f0) && return ex
    sn = @evalpoly(ex^2, -0.16666667f0, 0.008333333f0, -0.00019841234f0, 2.7550889f-6, -2.4529042f-8)
    return muladd(sn * ex, ex^2, ex)
end

# Delta E94
function _colordiff(a::Color, b::Color, m::DE_94)
    _colordiff(promote(convert(Lab, a), convert(Lab, b))..., m)
end
function _colordiff(a::C, b::C, m::DE_94) where {T, C <: Union{Lab{T}, LCHab{T}}}
    F = typeof(0.5f0 * zero(T)) === Float32 ? Float32 : promote_type(Float64, T)

    # Calculate the delta values for each channel
    dl, dc, dh = b.l - a.l, delta_c(b, a), delta_h(b, a)

    # Lightness, hue, chroma correction terms
    # sl = 1
    sc = muladd(F(m.k1), chroma(a), 1)
    sh = muladd(F(m.k2), chroma(a), 1)

    sqrt((dl/F(m.kl))^2 + (dc/(F(m.kc)*sc))^2 + (dh/(F(m.kh)*sh))^2)
end

# Metric form of jpc79 color difference equation (mostly obsolete)
function _colordiff(a::Color, b::Color, m::DE_JPC79)
    _colordiff(promote(convert(Lab, a), convert(Lab, b))..., m)
end
function _colordiff(a::C, b::C, ::DE_JPC79) where {T, C <: Union{Lab{T}, LCHab{T}}}
    F = typeof(0.5f0 * zero(T)) === Float32 ? Float32 : promote_type(Float64, T)

    # Calculate deltas in each direction
    dl, dc, dh = b.l - a.l, delta_c(b, a), delta_h(b, a)

    # Calculate mean lightness, chroma and hue
    ml, mc, mh = (a.l + b.l) * F(0.5), (chroma(a) + chroma(b)) * F(0.5), mean_hue(a, b)

    # L* adjustment term
    sl = F(0.08195) * ml / muladd(F(0.01765), ml, 1)

    # C* adjustment term
    sc = F(0.638) + F(0.0638) * mc / muladd(F(0.0131), mc, 1)

    # H* adjustment term
    if mc < F(0.38)
        sh = sc
    elseif mh >= 164 && mh <= 345
        sh = sc * muladd(F(0.2), abs(cosd(mh + 168)), F(0.56))
    else
        sh = sc * muladd(F(0.4), abs(cosd(mh +  35)), F(0.38))
    end

    # Calculate the final difference
    sqrt((dl/sl)^2 + (dc/sc)^2 + (dh/sh)^2)
end


# Metric form of the cmc color difference
function _colordiff(a::Color, b::Color, m::DE_CMC)
    _colordiff(promote(convert(Lab, a), convert(Lab, b))..., m)
end
function _colordiff(a::C, b::C, m::DE_CMC) where {T, C <: Union{Lab{T}, LCHab{T}}}
    F = typeof(0.5f0 * zero(T)) === Float32 ? Float32 : promote_type(Float64, T)

    ac, ah = chroma(a), hue(a)

    # Calculate deltas in each direction
    dl, dc, dh = b.l - a.l, delta_c(b, a), delta_h(b, a)

    # L* adjustment term
    if a.l < 16
        sl = F(0.511)
    else
        sl = F(0.040975) * a.l / muladd(F(0.01765), a.l, 1)
    end

    # C* adjustment term
    sc = F(0.0638) * ac / muladd(F(0.0131), ac, 1) + F(0.638)

    f = sqrt(ac^4 / (ac^4 + 1900))

    if 164 <= ah <= 345
        t = muladd(F(0.2), abs(cosd(ah + 168)), F(0.56))
    else
        t = muladd(F(0.4), abs(cosd(ah +  35)), F(0.36))
    end

    # H* adjustment term
    sh = sc * muladd(t, f, 1 - f)

    # Calculate the final difference
    sqrt((dl/(F(m.kl)*sl))^2 + (dc/(F(m.kc)*sc))^2 + (dh/sh)^2)
end

# The BFD color difference equation
function _colordiff(a::Color, b::Color, m::DE_BFD)
    # We have to start back in XYZ because BFD uses a different L equation
    # Currently, support for the `wp` argument of `convert` is limited.
    function to_xyz(c::Color{T}, wp) where T
        F = typeof(0.5f0 * zero(T)) === Float32 ? Float32 : promote_type(Float64, T)
        c isa XYZ && return c
        (c isa xyY || c isa LMS) && return convert(XYZ, c)
        wpf = XYZ{F}(wp)
        (c isa Lab || c isa Luv) && return convert(XYZ, c, wpf)
        c isa LCHuv && return convert(XYZ, convert(Luv, c), wpf)
        convert(XYZ, convert(Lab, c), wpf)
    end
    _colordiff(promote(to_xyz(a, m.wp), to_xyz(b, m.wp))..., m)
end
function _colordiff(a_xyz::XYZ{T}, b_xyz::XYZ{T}, m::DE_BFD) where T
    F = typeof(0.5f0 * zero(T)) === Float32 ? Float32 : promote_type(Float64, T)

    l_bfd(y) = muladd(F(54.6), log10(y + F(1.5)), F(-9.6))
    la, lb = l_bfd.((a_xyz.y, b_xyz.y))

    # Convert into Lab with the proper white point
    wpf = XYZ{F}(m.wp)
    a_lab = convert(Lab, a_xyz, wpf)
    b_lab = convert(Lab, b_xyz, wpf)

    # Substitute the different L values
    a = Lab(la, a_lab.a, a_lab.b)
    b = Lab(lb, b_lab.a, b_lab.b)

    # Calculate deltas in each direction
    dl, dc, dh = b.l - a.l, delta_c(b, a), delta_h(b, a)

    # Find the mean value of the inputs to use as the "standard"
    mc, mh = (chroma(a) + chroma(b)) * F(0.5), mean_hue(a, b)

    # Correction terms for a variety of nonlinearities in CIELAB.
    g = sqrt(mc^4 / (mc^4 + 14000))

    t_cos = F( 55) * cosd( mh - 245) +
            F(-40) * cosd(2mh - 136) +
            F( 70) * cosd(3mh -  32) +
            F( 49) * cosd(4mh + 114) +
            F(-15) * cosd(5mh + 103)
    t = muladd(F(1/1000), t_cos, F(0.627))

    rc = sqrt(mc^6 / (mc^6 + F(7e7)))

    rh = F(-0.260) * cosd( mh - 308) +
         F(-0.379) * cosd(2mh - 160) +
         F(-0.636) * cosd(3mh - 254) +
         F( 0.226) * cosd(4mh + 140) +
         F(-0.194) * cosd(5mh + 280)

    dcc = muladd(F(0.035), mc / muladd(F(0.00365), mc, 1) , F(0.521))
    dhh = dcc * muladd(g, t, 1 - g)
    rt = rc * rh

    # Final calculation
    sqrt((dl/F(m.kl))^2 + (dc/(F(m.kc)*dcc))^2 + (dh/dhh)^2 + rt*((dc*dh)/(dcc*dhh)))
end

function _colordiff(ai::Color, bi::Color,
                    m::EuclideanDifferenceMetric{T}) where {T <: Color3}
    a, b = convert(T, ai), convert(T, bi)

    d1, d2, d3 = comp1(a) - comp1(b), comp2(a) - comp2(b), comp3(a) - comp3(b)

    sqrt(d1^2 + d2^2 + d3^2)
end

# Default to Delta E 2000
"""
    colordiff(a, b; metric=DE_2000())

Compute an approximate measure of the perceptual difference between colors `a`
and `b`. Optionally, a `metric` may be supplied, chosen among [`DE_2000`](@ref)
(the default), [`DE_94`](@ref), [`DE_JPC79`](@ref), [`DE_CMC`](@ref),
[`DE_BFD`](@ref), [`DE_AB`](@ref), [`DE_DIN99`](@ref), [`DE_DIN99d`](@ref) and
[`DE_DIN99o`](@ref).

The return value is a non-negative number in a type depending on the colors and
metric.

!!! note
    The supported metrics measure the difference within `Lab` or its variant
    colorspaces. When the input colors are not in the colorspace internally used
    by the metric, the colors (e.g. in `RGB`) are converted with the default
    whitepoint CIE D65 (`Colors.WP_D65`). If you want to use another whitepoint,
    convert the colors into the colorspace used by metric (e.g. `Lab` for
    [`DE_2000`](@ref)) in advance.
"""
colordiff(ai::Union{Number, Color},
          bi::Union{Number, Color};
          metric::DifferenceMetric=DE_2000()) = _colordiff(ai, bi, metric)
@deprecate colordiff(ai::Color, bi::Color, metric::DifferenceMetric) colordiff(ai, bi; metric=metric)

function colordiff(ai::Colorant, bi::Colorant; metric::DifferenceMetric=DE_2000())
    alpha(ai) == 1 && alpha(bi) == 1 && return _colordiff(color(ai), color(bi), metric)
    throw(ArgumentError("""
        cannot evaluate the difference in transparent colors.
          Their appearance depends on the backdrop."""))
end

_colordiff(ai::AbstractGray, bi::Number, metric::DifferenceMetric) = _colordiff(ai, Gray(bi), metric)
_colordiff(ai::Number, bi::AbstractGray, metric::DifferenceMetric) = _colordiff(Gray(ai), bi, metric)
_colordiff(ai::Number, bi::Number, metric::DifferenceMetric) = _colordiff(Gray(ai), Gray(bi), metric)

# Helper data for CIE observer functions
include("cie_data.jl")

# readonly static 3x3 matrix
struct Mat3x3{T} <: AbstractMatrix{T}
    e::NTuple{9, T}
end
Mat3x3(mat::Matrix{T}) where {T} = Mat3x3{T}(Tuple(mat))
Base.IndexStyle(::Type{<:Mat3x3}) = IndexLinear()
Base.size(::Mat3x3) = (3, 3)
Base.getindex(M::Mat3x3{T}, i::Int) where {T} = M.e[i]

macro mul3x3(C, M, c1, c2, c3)
    esc(quote
        F = typeof(0.5f0 * $c1) === Float32 ? Float32 : eltype($M)
        if $c1 isa N0f8 && $c2 isa N0f8 && $c3 isa N0f8
            s = 0xffffff
            c1x = Int32(reinterpret($c1)) * 0x10101
            c2x = Int32(reinterpret($c2)) * 0x10101
            c3x = Int32(reinterpret($c3)) * 0x10101
        else
            s = true
            c1x, c2x, c3x = $c1, $c2, $c3
        end
        @inbounds ret = $C(
            muladd(F($M[1,1] / s), c1x, muladd(F($M[1,2] / s), c2x, F($M[1,3] / s) * c3x)),
            muladd(F($M[2,1] / s), c1x, muladd(F($M[2,2] / s), c2x, F($M[2,3] / s) * c3x)),
            muladd(F($M[3,1] / s), c1x, muladd(F($M[3,2] / s), c2x, F($M[3,3] / s) * c3x)))
        ret
    end)
end

# for optimization
div60(x) = x / 60
_div60(x::T) where T = muladd(x, T(1/960), x * T(0x1p-6))
if reduce(max, _div60.((90.0f0,))) == 1.5f0
    div60(x::T) where T <: Union{Float32, Float64} = _div60(x)
else
    # force two-step multiplication
    div60(x::T) where T <: Union{Float32, Float64} = x * T(0x1p-6) + x * T(1/960)
end

# mod6 supports the input `x` in [-2^28, 2^29]
mod6(::Type{T}, x::Int32) where T = unsafe_trunc(T, x - 6 * ((widemul(x, 0x2aaaaaaa) + Int64(0x20000000)) >> 0x20))

# Approximation of the reciprocal of the cube root, x^(-1/3).
# assuming that x > 0.003, the conditional branches are omitted.
@inline function rcbrt(x::Float64)
    ix = reinterpret(UInt64, x)
    e0 = (ix >> 0x34) % UInt32
    ed = e0 ÷ 0x3
    er = e0 - ed * 0x3
    a = 0x000b_f2d7 - 0x0005_5718 * er
    e = (UInt32(1363) - ed) << 0x14 | a
    t1 = reinterpret(Float64, UInt64(e) << 0x20)
    h1 = muladd(t1^2, -x * t1, 1.0)
    t2 = muladd(@evalpoly(h1, 1/3, 2/9, 14/81), h1 * t1, t1)
    h2 = muladd(t2^2, -x * t2, 1.0)
    t3 = muladd(muladd(2/9, h2, 1/3), h2 * t2, t2)
    reinterpret(Float64, reinterpret(UInt64, t3) & 0xffff_ffff_8000_0000)
end
@inline function rcbrt(x::Float32)
    ix = reinterpret(UInt32, x)
    e0 = ix >> 0x17 + 0x2
    ed = e0 ÷ 0x3
    er = e0 - ed * 0x3
    a = 0x005f_9cbe - 0x002a_bd7d * er
    t1 = reinterpret(Float32, (UInt32(169) - ed) << 0x17 | a)
    h1 = muladd(t1^2, -x * t1, 1.0f0)
    t2 = muladd(muladd(2/9f0, h1, 1/3f0), h1 * t1, t1)
    h2 = muladd(t2^2, -x * t2, 1.0f0)
    t3 = muladd(1/3f0, h2 * t2, t2)
    reinterpret(Float32, reinterpret(UInt32, t3) & 0xffff_f000)
end

cbrt01(x) = cbrt(x)
@inline function cbrt01(x::Float64)
    r = rcbrt(x) # x^(-1/3)
    h = muladd(r^2, -x * r, 1.0)
    e = muladd(2/9, h, 1/3) * h * r
    muladd(r, x * r, x * e * (r + r + e)) # x * x^(-2/3)
end
@inline function cbrt01(x::Float32)
    r = Float64(rcbrt(x)) # x^(-1/3)
    h = muladd(r^2, -Float64(x) * r, 1.0)
    e = muladd(muladd(14/81, h, 2/9), h, 1/3) * h
    Float32(1 / muladd(r, e, r))
end

pow3_4(x) = (y = @fastmath(sqrt(x)); y*@fastmath(sqrt(y))) # x^(3/4)

# `pow5_12` is called from `srgb_compand`.
pow5_12(x) = pow3_4(x) / cbrt(x) # 5/12 == 1/2 + 1/4 - 1/3 == 3/4 - 1/3
@inline function pow5_12(x::Float64)
    p3_4 = pow3_4(x)
    # x^(-1/6)
    if x < 0.02
        t0 = @evalpoly(x, 3.1366722556806232,
            -221.51395962221136, 19788.889459114234, -905934.6541469148, 1.5928561711645417e7)
    elseif x < 0.12
        t0 = @evalpoly(x, 2.3135905865468644,
            -26.43664640894651, 385.0146581045545, -2890.0920682466267, 8366.343115590817)
    elseif x < 1.2
        t0 = @evalpoly(x, 1.7047813285940905, -3.1261253501167308,
            7.498744828350077, -10.100319516746419, 6.820601476522508, -1.7978894213531524)
    else
        return p3_4 / cbrt01(x)
    end
    # x^(-1/3)
    t1 = t0 * t0
    h1 = muladd(t1^2, -x * t1, 1.0)
    t2 = muladd(h1, 1/3 * t1, t1)
    h2 = muladd(t2^2, -x * t2, 1.0)
    t2h = @evalpoly(h2, 1/3, 2/9, 14/81) * h2 * t2 # Taylor series of (1-h)^(-1/3)
    # x^(3/4) * x^(-1/3)
    muladd(p3_4, t2, p3_4 * t2h)
end
@inline function pow5_12(x::Float32)
    # x^(-1/3)
    rc = rcbrt(x)
    rcx = -rc * x
    rch = muladd(muladd(rc, x, rcx), -rc^2, muladd(rc^2, rcx, 1.0f0)) # 1 - x * rc^3
    rce = muladd(2/9f0, rch, 1/3f0) * rch * rc
    # x^(3/4)
    p3_4_f64 = pow3_4(Float64(x))
    p3_4r = reinterpret(Float64, reinterpret(UInt64, p3_4_f64) & 0xffffffff_e0000000)
    p3_4 = Float32(p3_4r)
    p3_4e = Float32(p3_4_f64 - p3_4r)
    # x^(3/4) * x^(-1/3)
    muladd(p3_4, rc, muladd(p3_4, rce, p3_4e * rc))
end

# `pow12_5` is called from `invert_srgb_compand`.
pow12_5(x) = pow12_5(Float64(x))
pow12_5(x::BigFloat) = x^big"2.4"
@inline function pow12_5(x::Float64)
    # x^0.4
    t1 = @evalpoly(@fastmath(min(x, 1.75)), 0.24295462640373672,
        1.7489099720303518, -1.9919942887850166, 1.3197188815160004, -0.3257258790067756)
    t2 = muladd(2/5, muladd(x / t1^2, @fastmath(sqrt(t1)), -t1), t1) # Newton's method
    t3 = muladd(2/5, muladd(x / t2^2, @fastmath(sqrt(t2)), -t2), t2)
    t4 = muladd(2/5, muladd(x / t3^2, @fastmath(sqrt(t3)), -t3), t3)
    # x^0.4 * x^2
    rx = reinterpret(Float64, reinterpret(UInt64, x) & 0xffffffff_f8000000) # hi
    e = x - rx # lo
    muladd(t4, rx^2, t4 * (rx + rx + e) * e)
end

pow7(x) = (y = x*x*x; y*y*x)

# TODO: migrate to ColorTypes.jl
@inline function atan360_kernel(t::Float64)
    @evalpoly(t^2,
        0.8952465548919112,  -0.2984155182972285,   0.1790493109637673,   -0.12789236387151418,
        0.09947179554077099, -0.08138502549008089,  0.06884985860325084,  -0.059532134551367105,
        0.05164982834653973, -0.042514874197367984, 0.028600080170923112, -0.011001809246782802)
end
@inline function atan360_kernel(t::Float32)
    @evalpoly(t^2,
        0.89524657f0, -0.2984143f0, 0.17899014f0, -0.12683357f0, 0.090689056f0, -0.045563098f0)
end

# a variant of `atand` returning the angle in the range of [0, 360]
atan360(y, x) = (a = atand(y, x); signbit(a) ? oftype(a, a + 360) : a)
@inline function atan360(y::T, x::T) where T <: Union{Float32, Float64}
    (isnan(x) | isnan(y)) && return T(NaN)
    ax, ay = abs(x), abs(y)
    n, m = minmax(ax, ay)
    if m == T(Inf)
        d0 = n == T(Inf) ? T(45) : T(0)
    else
        m = m == T(0) ? T(0.5) : m
        ta = (n + n) > m ? T(0.5) : T(0) # 1-step CORDIC
        # ro=(n + n) > m ? T(atand(0.5) / 64) : T(0)
        ro = max(T(0), ta - T(0.5 - 0.4150789246418436))
        n1 = n - ta * m
        m1 = m + ta * n
        t = n1 / m1 # in [0, 0.5]
        p = atan360_kernel(t)
        d0 = muladd(t, p, ro) * T(64)
    end
    b1 = T( 90) + flipsign(T( -90), x)
    b2 = T(180) + flipsign(T(-180), y)
    d1 = ay > ax ? T(90) - d0 : d0
    d2 = b1 + flipsign(d1, x) # signbit(x) ? T(180) - d1 : d1
    dd = b2 + flipsign(d2, y) # signbit(y) ? T(360) - d2 : d2
    return dd
end

# override only the `Lab`, `Luv`, and `Oklab` versions just for now
@inline ColorTypes.hue(c::Lab) = atan360(c.b, c.a)
@inline ColorTypes.hue(c::Luv) = atan360(c.v, c.u)
@inline ColorTypes.hue(c::Oklab) = atan360(c.b, c.a)

@inline function sin_kernel(x::Float64)
    x * @evalpoly(x^2,
        1.117010721276371, -0.23228479064016105, 0.014491237085286733, -0.00043049771889962576,
        7.460244157055791e-6, -8.462038405688494e-8, 6.767827147797153e-10, -3.987482394639226e-12)
end
@inline function sin_kernel(x::Float32)
    y = @evalpoly(x^2, 0.11701072f0, -0.23228478f0, 0.014491233f0, -0.0004304645f0, 7.368049f-6)
    muladd(x, y, x)
end
@inline function cos_kernel(x::Float64)
    @evalpoly(x^2, 1.0,
        -0.6238564757231793, 0.06486615038362423, -0.002697811198135598, 6.010882091788964e-5,
        -8.333171603045294e-7, 7.876495580576226e-9, -5.351642293798961e-11)
end
@inline function cos_kernel(x::Float32)
    @evalpoly(x^2, 1.0f0, -0.6238565f0,0.06486606f0,-0.002697325f0, 5.904168f-5)
end

sincos360(x) = sincos(deg2rad(x))
@inline function sincos360(x::T) where T <: Union{Float32, Float64}
    isfinite(x) || return T(NaN), T(NaN)
    t = x - round(x * T(1/360)) * 360 # [-180, 180]
    a0 = @fastmath abs(t)              # [0, 180]
    a1 = a0 <= 90 ? a0 : 180 - a0      # [0, 90]
    a2 = a1 <= 45 ? a1 : 90 - a1       # [0, 45]
    ax = a2 * T(1/64)
    sn, cs  = sin_kernel(ax), cos_kernel(ax)
    sn1, cs1 = a1 === a2 ? (sn, cs) : (cs, sn)
    return @fastmath flipsign(sn1, t), flipsign(cs1, 90 - a0)
end

"""
    x, y = polar_to_cartesian(r, theta)

Convert a polar coordinate of radius `r` and angle `theta` (in degrees) to a
Cartesian coordinate.
"""
@inline function polar_to_cartesian(r, theta)
    y, x = r .* sincos360(theta)
    return x, y
end

# Linear interpolation in [a, b] where x is in [0,1],
# or coerced to be if not.
function lerp(x, a, b)
    a + (b - a) * max(min(x, one(x)), zero(x))
end

clamp01(v::T) where {T<:Fractional} = ifelse(v < zero(T), zero(T), ifelse(v > oneunit(T), oneunit(T), v))
clamp01(v::T) where {T<:Union{Bool,N0f8,N0f16,N0f32,N0f64}} = v

"""
    HexNotation{C, A, N}

This is a private type for specifying the style of hex notations. It is not
recommended to use this type and its derived types in user scripts or other
packages, since they may change in the future without notice.

# Arguments
- `C`: a base colorant type.
- `A`: a symbol (`:upper` or `:lower`) to specify the letter casing.
- `N`: a total number of digits.
"""
abstract type HexNotation{C, A, N} end
abstract type HexAuto <: HexNotation{Colorant,:upper,0} end
abstract type HexShort{A} <: HexNotation{Colorant,A,0} end

"""
    hex(c::Colorant)
    hex(c::Colorant, style::Symbol)

Convert a color to a hexadecimal string, optionally specifying its style.

# Arguments
- `c`: a target color.
- `style`: a symbol to specify the hexadecimal notation. Specifying the
  uppercase symbols means the return values are in uppercase. The following
  symbols are available:
  - `:AUTO`: notation automatically selected according to the type of `c`
  - `:RRGGBB`/`:rrggbb`: 6-digit opaque notation
  - `:AARRGGBB`/`:aarrggbb`: 8-digit notation with alpha at the head
  - `:RRGGBBAA`/`:rrggbbaa`: 8-digit notation with alpha at the tail
  - `:RGB`/`:rgb`/`:ARGB`/`:argb`/`:RGBA`/`:rgba`: 3-digit or 4-digit noatation
  - `:S`/`:s`: short notation if available

# Examples
```jldoctest; setup = :(using Colors)
julia> hex(RGB(1,0.5,0))
"FF8000"

julia> hex(ARGB(1,0.5,0,0.25))
"40FF8000"

julia> hex(HSV(30,1.0,1.0), :AARRGGBB)
"FFFF8000"

julia> hex(ARGB(1,0.533,0,0.267), :rrggbbaa)
"ff880044"

julia> hex(ARGB(1,0.533,0,0.267), :rgba)
"f804"

julia> hex(ARGB(1,0.533,0,0.267), :S)
"4F80"
```

!!! compat "Colors v0.12"
    `style` requires at least Colors v0.12.
"""
hex(c::Colorant) = _hex(HexAuto, c) # there is no need to search the dictionary
hex(c::Colorant, style::Symbol) = _hex(get(_hex_styles, style, HexAuto), c)

const _hex_styles = Dict{Symbol, Type}(
    :AUTO => HexAuto,
    :S => HexShort{:upper}, :s => HexShort{:lower},
    :RGB => HexNotation{RGB,:upper,3}, :rgb => HexNotation{RGB,:lower,3},
    :ARGB => HexNotation{ARGB,:upper,4}, :argb => HexNotation{ARGB,:lower,4},
    :RGBA => HexNotation{RGBA,:upper,4}, :rgba => HexNotation{RGBA,:lower,4},
    :RRGGBB => HexNotation{RGB,:upper,6}, :rrggbb => HexNotation{RGB,:lower,6},
    :AARRGGBB => HexNotation{ARGB,:upper,8}, :aarrggbb => HexNotation{ARGB,:lower,8},
    :RRGGBBAA => HexNotation{RGBA,:upper,8}, :rrggbbaa => HexNotation{RGBA,:lower,8},
)
@inline function _hexstring(::Type{T}, u::U, itr) where {C, T <: HexNotation{C,:upper}, U <: Unsigned}
    s = UInt8(8sizeof(u) - 4)
    @inbounds String([b"0123456789ABCDEF"[((u << i) >> s) + 1] for i in itr])
end
@inline function _hexstring(::Type{T}, u::U, itr) where {C, T <: HexNotation{C,:lower}, U <: Unsigned}
    s = UInt8(8sizeof(u) - 4)
    @inbounds String([b"0123456789abcdef"[((u << i) >> s) + 1] for i in itr])
end

_to_uint32(c::Colorant) = reinterpret(UInt32, ARGB32(c))
_to_uint32(c::TransparentColor) = reinterpret(UInt32, alphacolor(RGB24(c), clamp01(alpha(c))))
_to_uint32(c::C) where C <: Union{AbstractRGB, TransparentRGB} =
    reinterpret(UInt32, ARGB32(correct_gamut(c)))
_to_uint32(c::C) where C <: Union{AbstractGray, TransparentGray} =
    reinterpret(UInt32, AGray32(clamp01(gray(c)), clamp01(alpha(c))))

_hex(t::Type, c::Colorant) = _hex(t, _to_uint32(c))

_hex(::Type{HexAuto}, c::Color) = _hex(HexNotation{RGB,:upper,6}, c)
_hex(::Type{HexAuto}, c::AlphaColor) = _hex(HexNotation{ARGB,:upper,8}, c)
_hex(::Type{HexAuto}, c::ColorAlpha) = _hex(HexNotation{RGBA,:upper,8}, c)

function _hex(::Type{HexShort{A}}, c::Colorant) where A
    u = _to_uint32(c)
    s = u == (u & 0x0F0F0F0F) * 0x11
    c isa AlphaColor && return _hex(HexNotation{ARGB, A, s ? 4 : 8}, u)
    c isa ColorAlpha && return _hex(HexNotation{RGBA, A, s ? 4 : 8}, u)
    _hex(HexNotation{RGB, A, s ? 3 : 6}, u)
end

# for 3-digit or 4-digit notations
function _hex(t::Type{T}, u::UInt32) where {C <:Union{RGB, ARGB, RGBA}, A, T <: HexNotation{C,A}}
    # To double the number of digits, we multiply each element by 17 (= 0x11).
    # Thus, we divide each element by 17 here, to halve the number of digits.
    u64 = UInt64(u)
    # TODO: use SIMD `move` with zero extension (e.g. vpmovzxbw)
    unpacked = ((u64 & 0xFF00FF00)<<24) | (u64 & 0x00FF00FF) # 0x00AA00GG00RR00BB
    # `all(x -> round(x / 17) == (x * 15 + 135) >> 8, 0:255) == true`
    q = muladd(unpacked, 0xF,  0x0087_0087_0087_0087) # 0x0Aaa0Ggg0Rrr0Bbb
    t <: HexNotation{ARGB} && return _hexstring(t, q, (0x04, 0x24, 0x14, 0x34))
    t <: HexNotation{RGBA} && return _hexstring(t, q, (0x24, 0x14, 0x34, 0x04))
    _hexstring(t, q, (0x24, 0x14, 0x34))
end

# for 6-digit or 8-digit notations
_hex(t::Type{HexNotation{ RGB,A,6}}, u::UInt32) where {A} = _hexstring(t, u, 0x8:0x4:0x1C)
_hex(t::Type{HexNotation{ARGB,A,8}}, u::UInt32) where {A} = _hexstring(t, u, 0x0:0x4:0x1C)
_hex(t::Type{HexNotation{RGBA,A,8}}, u::UInt32) where {A} =
    _hexstring(t, u, (0x8, 0xC, 0x10, 0x14, 0x18, 0x1C, 0x0, 0x4))

"""
    normalize_hue(h::Real)
    normalize_hue(c::Colorant)

Returns a normalized (wrapped-around) hue angle, or a color with the normalized
hue, in degrees, in [0, 360]. The normalization is essentially equivalent to
`mod(h, 360)`, but is faster at the expense of some accuracy.
"""
@fastmath normalize_hue(h::Real) = max(muladd(floor(h / 360), -360, h), zero(h))
@fastmath normalize_hue(h::Float16) = Float16(normalize_hue(Float32(h)))
normalize_hue(c::C) where {C <: Union{HSV, HSL, HSI}} = C(normalize_hue(c.h), c.s, comp3(c))
normalize_hue(c::C) where {Cb <: Union{HSV, HSL, HSI}, C <: Union{AlphaColor{Cb}, ColorAlpha{Cb}}} =
    C(normalize_hue(c.h), c.s, comp3(c), alpha(c))
normalize_hue(c::C) where C <: Union{LCHab, LCHuv, Oklch} = C(c.l, c.c, normalize_hue(c.h))
normalize_hue(c::C) where {Cb <: Union{LCHab, LCHuv, Oklch}, C <: Union{AlphaColor{Cb}, ColorAlpha{Cb}}} =
    C(c.l, c.c, normalize_hue(c.h), c.alpha)

"""
    mean_hue(h1::Real, h2::Real)
    mean_hue(a::C, b::C) where {C <: Colorant}

Compute the mean of two hue angles in degrees.

If the inputs are HSV-like or Lab-like color objects, this will also return a
hue, not a color. If one of the colors is achromatic, i.e. has zero saturation
or chroma, the hue of the other color is returned instead of the mean.

When the hue difference is exactly 180 degrees, which of the two mean hues is
returned depends on the implementation. In other words, it may vary by the color
type and version.
"""
mean_hue(a, b) = _mean_hue(promote(a, b)...)

_mean_hue(a, b) = error("input arguments to `mean_hue` could not promote to valid input types")
function _mean_hue(h1::T, h2::T) where {T <: Real}
    @fastmath hmin, hmax = minmax(h1, h2)
    d = 180 - normalize_hue(hmin - hmax - 180)
    F = typeof(zero(T) / 2)
    mh = muladd(F(0.5), d, hmin)
    return mh < 0 ? mh + 360 : mh
end
@inline function _mean_hue(a::C, b::C) where {Cb <: Union{Lab, Luv, Oklab},
                                     C <: Union{Cb, AlphaColor{Cb}, ColorAlpha{Cb}}}
    a1, b1, a2, b2 = comp2(a), comp3(a), comp2(b), comp3(b)
    c1, c2 = chroma(a), chroma(b)
    k1 = c1 == zero(c1) ? oneunit(c1) : c1
    k2 = c2 == zero(c2) ? oneunit(c2) : c2
    dp = muladd(a1, a2, b1 * b2) # dot product
    dt = b1 * a2 - a1 * b2
    if dp < zero(dp)
        # 90 deg rotations
        a1, b1 = @fastmath flipsign( b1, dt), flipsign(-a1, dt)
        a2, b2 = @fastmath flipsign(-b2, dt), flipsign( a2, dt)
        if dt == zero(dt) && a1 > zero(a1)
            k1, k2 = -k1, -k2
        end
    end
    ma = muladd(k2, a1, k1 * a2)
    mb = muladd(k2, b1, k1 * b2)
    hue(Cb(zero(ma), ma, mb))
end
function _mean_hue(a::C, b::C) where {Cb <: Union{LCHab, LCHuv, Oklch},
                                     C <: Union{Cb, AlphaColor{Cb}, ColorAlpha{Cb}}}
    _mean_hue(a.c == 0 ? b.h : a.h, b.c == 0 ? a.h : b.h)
end
function _mean_hue(a::C, b::C) where {Cb <: Union{HSV, HSL, HSI},
                                     C <: Union{Cb, AlphaColor{Cb}, ColorAlpha{Cb}}}
    _mean_hue(a.s == 0 ? b.h : a.h, b.s == 0 ? a.h : b.h)
end

_delta_h_th(T) = zero(T)
_delta_h_th(::Type{Float32}) = 0.1f0
_delta_h_th(::Type{Float64}) = 6.5e-3

function delta_h(a::C, b::C) where {Cb <: Union{Lab, Luv, Oklab},
                                    C <: Union{Cb, AlphaColor{Cb}, ColorAlpha{Cb}}}
    a1, b1, a2, b2 = comp2(a), comp3(a), comp2(b), comp3(b)
    c1, c2 = chroma(a), chroma(b)
    dp = muladd(a1, a2, b1 * b2) # dot product
    dt = b1 * a2 - a1 * b2
    if _delta_h_th(typeof(dp)) * dp <= abs(dt)
        if dp isa Float32 || dp < 0
            dh = @fastmath sqrt(2 * muladd(c1, c2, -dp))
        else
            da, db, dc = a1 - a2, b1 - b2, c1 - c2
            dh = @fastmath sqrt(max(muladd(dc, -dc, muladd(da, da, db^2)), 0))
        end
        return copysign(dh, dt)
    else
        dtf = muladd(b1, a2, -a1 * b2)
        tn = dtf / dp #    tan(Δh) = Δh +  (1/3)*Δh^3 +   (2/15)*Δh^5 + ...
                      # 2sin(Δh/2) = Δh - (1/24)*Δh^3 + (1/1920)*Δh^5 - ...
                      #            ≈ tan(Δh) - (3/8)*tan(Δh)^3 + (31/128)*tan(Δh)^5
        sn = tn * @evalpoly(tn^2, 1, oftype(tn, -3/8), oftype(tn, 31/128)) # 2sin(Δh/2)
        return @fastmath sqrt(c1 * c2) * sn
    end
end
function delta_h(a::C, b::C) where {Cb <: Union{LCHab, LCHuv, Oklch},
                                    C <: Union{Cb, AlphaColor{Cb}, ColorAlpha{Cb}}}
    dh0 = hue(a) - hue(b)
    sh = muladd(dh0, oftype(dh0, 1 / 360), oftype(dh0, 0.5))
    d =  @fastmath sh - floor(sh) - oftype(sh, 0.5)
    2 * sqrt(chroma(a) * chroma(b)) * sinpi(d)
end
delta_h(a, b) = delta_h(promote(a, b)...)

@inline function delta_c(a::C, b::C) where {Cb <: Union{Lab{Float32}, Luv{Float32}, Oklab{Float32}},
                                    C <: Union{Cb, AlphaColor{Cb}, ColorAlpha{Cb}}}
    n1, m1 = @fastmath minmax(comp2(a)^2, comp3(a)^2)
    n2, m2 = @fastmath minmax(comp2(b)^2, comp3(b)^2)
    ((m1 - m2) + (n1 - n2)) / @fastmath(max(chroma(a) + chroma(b), floatmin(Float32)))
end
delta_c(a, b) = chroma(a) - chroma(b)

"""
    weighted_color_mean(w1, c1, c2)

Returns the color `w1*c1 + (1-w1)*c2` that is the weighted mean of `c1` and
`c2`, where `c1` has a weight 0 ≤ `w1` ≤ 1.
"""
weighted_color_mean(w1::Real, c1::Colorant, c2::Colorant) = _weighted_color_mean(w1, c1, c2)
function weighted_color_mean(w1::Real, c1::C, c2::C) where {Cb <: Union{HSV, HSL, HSI, LCHab, LCHuv, Oklch},
                                                            C <: Union{Cb, AlphaColor{Cb}, ColorAlpha{Cb}}}
    normalize_hue(_weighted_color_mean(w1, c1, c2))
end
function _weighted_color_mean(w1::Real, c1::Colorant{T1}, c2::Colorant{T2}) where {T1,T2}
    @fastmath min(w1, oneunit(w1) - w1) >= zero(w1) || throw(DomainError(w1, "`w1` must be in [0, 1]"))
    w2 = oneunit(w1) - w1
    mapc((x, y) -> convert(promote_type(T1, T2), muladd(w1, x, w2 * y)), c1, c2)
end
function _weighted_color_mean(w1::Integer, c1::C, c2::C) where C <: Colorant
    (w1 & 0b1) === w1 || throw(DomainError(w1, "`w1` must be in [0, 1]"))
    w1 == zero(w1) ? c2 : c1
end

"""
    weighted_color_mean(weights, colors)

Returns the weighted mean of the given collection `colors` with `weights`.
This is semantically equivalent to the calculation of `sum(weights .* colors)`.

# Examples
```jldoctest; setup = :(using Colors, FixedPointNumbers)
julia> rgbs = (RGB(1, 0, 0), RGB(0, 1, 0), RGB(0, 0, 1));

julia> weighted_color_mean([0.2, 0.2, 0.6], rgbs)
RGB{N0f8}(0.2, 0.2, 0.6)

julia> weighted_color_mean(0.5:-0.25:0.0, RGB{Float64}.(rgbs))
RGB{Float64}(0.5, 0.25, 0.0)
```

!!! compat "Colors v0.13"
    `wighted_color_mean` with collection or iterator inputs requires Colors
    v0.13 or later.

!!! note
    In a cylindrical color space such as HSV, a weighted mean of more than three
    colors is generally not meaningful.
"""
function weighted_color_mean(weights, colors)
    if length(weights) != length(colors)
        throw(DimensionMismatch("`weights` and `colors` must be the same length."))
    end
    w1, c1 = first(weights), first(colors)
    acc = mapc(_ -> zero(promote_type(typeof(w1), Float32)), c1)
    for (w, c) in zip(weights, colors)
        acc = mapc((a, v) -> a + w * v, acc, c)
    end
    convert(typeof(c1), acc)
end

"""
    range(start::T; stop::T, length=100) where T<:Colorant
    range(start::T, stop::T; length=100) where T<:Colorant

Generates N (=`length`) >2 colors in a linearly interpolated ramp from `start` to `stop`,
inclusive, returning an `Array` of colors.

!!! compat "Julia 1.1"
    `stop` as a positional argument requires at least Julia 1.1.
"""
function range(start::T; stop::T, length::Integer=100) where T<:Colorant
    return T[weighted_color_mean(w1, start, stop) for w1 in range(1.0,stop=0.0,length=length)]
end

if VERSION >= v"1.1"
    range(start::T, stop::T; kwargs...) where T<:Colorant = range(start; stop=stop, kwargs...)
end

if VERSION < v"1.0.0-"
import Base: linspace
Base.@deprecate linspace(start::Colorant, stop::Colorant, n::Integer=100) range(start, stop=stop, length=n)
end

# Double quadratic Bezier curve
function bezier(t::T, p0::T, p2::T, q0::T, q1::T, q2::T) where T<:Real
    B(t,a,b,c)=a*(1.0-t)^2 + 2.0b*(1.0-t)*t + c*t^2
    if t <= 0.5
        return B(2.0t, p0, q0, q1)
    else #t > 0.5
        return B(2.0(t-0.5), q1, q2, p2)
    end
end

# Inverse double quadratic Bezier curve
function inv_bezier(t::T, p0::T, p2::T, q0::T, q1::T, q2::T) where T<:Real
    invB(t,a,b,c)=(a-b+sqrt(b^2-a*c+(a-2.0b+c)*t))/(a-2.0b+c)
    if t < q1
        return 0.5*invB(t,p0,q0,q1)
    else #t >= q1
        return 0.5*invB(t,q1,q2,p2)+0.5
    end
end

# This file was derived from "docs/src/assets/figures/generate-named-color-charts.jl" (v0.9.6).

module NamedColorCharts

using Colors

struct ColorChartSVG <: Main.SVG
    buf::IOBuffer
end

function ColorChartSVG(colorcategory)
    io = IOBuffer()

    colornames = colordictionary[colorcategory]
    numbercells = length(colornames)
    numbercols = 10
    colwidth = 14.8 #mm
    rowheight = 15 # mm
    swatchheight = 9 # mm
    pagewidth = 150 # mm
    margin = round(pagewidth - colwidth * numbercols) / 2
    numberrows = convert(Int, ceil(numbercells/numbercols))
    headerheight = 15 # mm
    pageheight = headerheight + numberrows * rowheight + margin
    write(io,
        """
        <svg xmlns="http://www.w3.org/2000/svg" version="1.1"
             viewBox="0 0 $pagewidth $pageheight"
             width="$(pagewidth)mm" height="$(pageheight)mm"
             style="width:100%; height:auto;"
             shape-rendering="crispEdges" stroke="none">
        <defs>
            <style><![CDATA[
                @import url('https://fonts.googleapis.com/css?family=IBM+Plex+Sans+Condensed&display=swap');
                g text:last-child {
                    font-size: 2px;
                    fill: #000;
                }
                g text {
                    text-anchor: middle;
                    font-size: 2.5px;
                    font-weight: 500;
                    font-family: 'IBM Plex Sans Condensed', 'Futura Condensed Medium', 'Segoe UI', 'Roboto Condensed', sans-serif;
                    fill: currentColor;
                }
                .header {
                    font-size: 5px;
                    text-anchor: start;
                    font-family: 'Lato', 'Helvetica Neue', 'Arial', sans-serif;
                    font-weight: bold;
                    fill: currentColor;
                }
                .w {
                    fill: #fff !important;
                }
            ]]></style>
        </defs>
        """)
    write(io,
        """
        <text x="$margin" y="10" class="header">$(titlecase(colorcategory))</text>
        <path d="M0,12 h$(pagewidth)" stroke="#888" stroke-width="0.25" />
        """)

    for n = 1:numbercells
        name = colornames[n]
        col = parse(RGB, name)
        x = round(margin + colwidth * ((n - 1) % numbercols), digits=1)
        y = round(headerheight + rowheight * ((n - 1) ÷ numbercols), digits=1)
        cx = round(colwidth / 2, digits=1)

        write(io, """<g transform="translate($x,$y)">""")
        write(io, """<rect y="5" width="$colwidth" height="$swatchheight" fill="#$(hex(col))" />""")
        write(io, "<text>")

        len = length(name)
        if len <= 12
            write(io, """<tspan x="$cx" y="4.2">$name</tspan>""")
        else
            m = match(r"^(dark|pale|light|lemon|medium|blanched|(?:.+(?=white|blue|purple|blush)))(.+)$", name)
            if m !== nothing
                write(io, """<tspan x="$cx" y="2.3">$(m.captures[1])</tspan>""")
                write(io, """<tspan x="$cx" y="4.5">$(m.captures[2])</tspan>""")
            else
                write(io, """<tspan x="$cx" y="2.3">$(name[1:(len÷2)])</tspan>""")
                write(io, """<tspan x="$cx" y="4.5">$(name[(len÷2+1):end])</tspan>""")
            end
        end
        write(io, "</text>")

        vec = string(round(red(col), digits=2), ", ",
                     round(green(col), digits=2), ", ",
                     round(blue(col), digits=2))
        veccol = convert(Lab, col).l > 60 ? "" : " class=\"w\""
        write(io, """<text x="$cx" y="13"$veccol>$vec</text>""")
        write(io, "</g>\n")
    end

    write(io, "</svg>")
    ColorChartSVG(io)
end

function compare_colors(colorname_a, colorname_b)
    # compare two colors, looking just at their LUV luminance values
    luv1 = parse(Luv, colorname_a)
    luv2 = parse(Luv, colorname_b)
    luv1.l == luv2.l ? colorname_a < colorname_b : luv1.l > luv2.l
end

# sort colors into categories
# these are very bikesheddable
function classifycolornames(colornames)
    colorcategories = Dict{String, Array{String, 1}}(
        "whites" => [],
        "pinks" => [],
        "reds" => [],
        "oranges" => [],
        "yellows" => [],
        "greens" => [],
        "cyans" => [],
        "blues" => [],
        "purples" => [],
        "browns" => [],
        "grays" => [])
    for colorname in colornames
        if occursin(r"(^grey)|(^gray)", colorname)
            push!(colorcategories["grays"], colorname)
        elseif occursin(r"turquoise|^aqua$|teal|cyan", colorname)
            push!(colorcategories["cyans"], colorname)
        elseif occursin(r"lemon|khaki|wheat", colorname)
            push!(colorcategories["yellows"], colorname)
        elseif occursin(r"orange", colorname)
            push!(colorcategories["oranges"], colorname)
        elseif occursin(r"chartreuse|olive|marine|lime|green", colorname)
            push!(colorcategories["greens"], colorname)
        elseif occursin(r"maroon|violetred|pink", colorname)
            push!(colorcategories["pinks"], colorname)
        elseif occursin(r"mistyrose|plum|thistle|lavender|violet|orchid|magenta|fuchsia|purple", colorname)
            push!(colorcategories["purples"], colorname)
        elseif occursin(r"azure|gains|slate|navy|indigo|blue", colorname)
            push!(colorcategories["blues"], colorname)
        elseif occursin(r"gold|yellow", colorname)
            push!(colorcategories["yellows"], colorname)
        elseif occursin(r"chocolate|sienna|wood|moccasin|bisque|peru|peach|papaya|almond|tan|brown", colorname)
            push!(colorcategories["browns"], colorname)
        elseif occursin(r"crimson|firebrick|salmon|coral|tomato|red", colorname)
            push!(colorcategories["reds"], colorname)
        elseif occursin(r"honey|mint|beige|linen|corn|sea|silver|lace|ivory|snow|white", colorname)
            push!(colorcategories["whites"], colorname)
        elseif occursin(r"grey|gray|black", colorname)
            push!(colorcategories["grays"], colorname)
        else
            error(colorname)
        end
    end
    # sort the RGB values in Luv.l format
    # TODO perhaps do this conversion just once instead of 1000s of times :)
    for k in keys(colorcategories)
        vals = colorcategories[k]
        sort!(vals, lt = compare_colors)
        colorcategories[k] = vals
    end
    return colorcategories
end

function makecolordictionary()
    colornames = collect(keys(Colors.color_names))
    colordictionary = classifycolornames(colornames)
    checkclassified = String[]
    for category in keys(colordictionary)
        for c in colordictionary[category]
            push!(checkclassified, c)
        end
    end
    stilltodo = setdiff(colornames, checkclassified)
    length(stilltodo) > 0 && error("gotta catch them all!")
    return colordictionary
end

const colordictionary = makecolordictionary()

end

# This file is the successor to "images/GenerateImages.jl" (v0.5.1).
module Colormaps

using Colors

struct ColormapSVG <: Main.SVG
    buf::IOBuffer
end

function ColormapSVG(cm::AbstractVector{T}, w="96mm", h="4mm") where T<:Color
    io = IOBuffer()
    n = length(cm)
    write(io,
        """
        <svg xmlns="http://www.w3.org/2000/svg" version="1.1"
             width="$w" height="$h"
             viewBox="0 0 $n 1" preserveAspectRatio="none"
             shape-rendering="crispEdges" stroke="none">
        """)
    for i in 1:n
        c = hex(cm[i])
        write(io,
            """
            <rect width="$(n+1-i)" height="1" x="$(i-1)" y="0" fill="#$c" />
            """)
    end
    write(io, "</svg>")
    ColormapSVG(io)
end

end

using Pkg
dependents = ["ImageCore"] # direct
idependents = ["WebP"] # indirect
devdir = get(ENV, "JULIA_PKG_DEVDIR", nothing) # backup
workdir = joinpath(@__DIR__, "work")
ENV["JULIA_PKG_DEVDIR"] = workdir
Pkg.activate(workdir)
Pkg.develop(dependents, preserve=PRESERVE_DIRECT)
ENV["JULIA_PKG_DEVDIR"] = devdir # restore
for dep in dependents
    Pkg.activate(joinpath(workdir, dep))
    Pkg.compat("Colors", "< 1")
end
Pkg.activate(@__DIR__) # this project
pkgspecs = [PackageSpec(path=joinpath(workdir, dep)) for dep in dependents]
Pkg.develop(pkgspecs, preserve=PRESERVE_DIRECT)
Pkg.add(idependents)

using Documenter, Colors

abstract type SVG end
function Base.show(io::IO, ::MIME"text/html", svg::SVG)
    write(io, "<html><body>")
    write(io, take!(svg.buf))
    write(io, "</body></html>")
    flush(io)
end
include("png16x16.jl")
include("crosssectionalcharts.jl")
include("colordiffcharts.jl")
include("colormaps.jl")
include("colormapparams.jl")
include("namedcolorcharts.jl")
include("sampleimages.jl")


makedocs(
    clean = false,
    modules = [Colors],
    format = Documenter.HTML(prettyurls = get(ENV, "CI", nothing) == "true",
                             size_threshold = nothing,
                             assets = ["assets/resize_svg.js", "assets/favicon.ico"]),
    checkdocs = :exports,
    sitename = "Colors",
    pages    = Any[
        "Introduction"                => "index.md",
        "Construction and Conversion" => "constructionandconversion.md",
        "Color Differences"           => "colordifferences.md",
        "Colormaps and Colorscales"   => "colormapsandcolorscales.md",
        "Named Colors"                => "namedcolors.md",
        "Advanced Functions"          => "advancedfunctions.md",
        "References"                  => "references.md",
        "Index"                       => "functionindex.md",
        ]
    )

deploydocs(
    repo = "github.com/JuliaGraphics/Colors.jl.git",
    target = "build")


Pkg.rm([idependents; dependents], io=devnull)

using Test, Colors
using FixedPointNumbers

@testset "Parse" begin
    r8(x) = reinterpret(N0f8, x)

    # Color parsing
    # named-color
    redN0f8 = parse(Colorant, "red")
    @test colorant"red" === redN0f8
    @test redN0f8 === RGB{N0f8}(1,0,0)
    @test parse(RGB{Float64}, "red") === RGB{Float64}(1,0,0)
    @test isa(parse(HSV, "blue"), HSV)
    @test_throws ArgumentError parse(Colorant, "p ink")
    @test parse(Colorant, "transparent") === RGBA{N0f8}(0,0,0,0)
    @test parse(Colorant, "\nSeaGreen ") === RGB{N0f8}(r8(0x2E),r8(0x8B),r8(0x57))
    @test parse(Colorant, "sea GREEN") === colorant"seagreen"

    # hex-color
    @test parse(Colorant, "#D0FF58") === RGB(r8(0xD0),r8(0xFF),r8(0x58))
    @test parse(Colorant, "0xd0ff58") === RGB(r8(0xD0),r8(0xFF),r8(0x58))
    @test parse(Colorant, "#FB0") === RGB(r8(0xFF),r8(0xBB),r8(0x00))
    @test parse(Colorant, "#FB0A") === RGBA(r8(0xFF),r8(0xBB),r8(0x00),r8(0xAA))
    @test parse(Colorant, "0xFB0A") === ARGB(r8(0xBB),r8(0x00),r8(0xAA),r8(0xFF))
    @test parse(Colorant, "#FFBB00AA") === RGBA(r8(0xFF),r8(0xBB),r8(0x00),r8(0xAA))
    @test parse(Colorant, "0xFFBB00AA") === ARGB(r8(0xBB),r8(0x00),r8(0xAA),r8(0xFF))
    @test_throws ArgumentError parse(Colorant, "#BAD05")
    @test_throws ArgumentError parse(Colorant, "#BAD0007")
    @test_throws ArgumentError parse(Colorant, "#BAD000009")

    # rgb()
    @test parse(Colorant, "rgb(55,217,127)")      === RGB{N0f8}(r8(0x37),r8(0xd9),r8(0x7f))
    @test colorant"    Rgb(  55.1, 217, 127 )   " === RGB{N0f8}(r8(0x37),r8(0xd9),r8(0x7f))
    @test parse(Colorant, "rgb(22%,85%,50%)")     === RGB{N0f8}(r8(0x38),r8(0xd9),r8(0x80))
    @test parse(Colorant, "rgba(55,217,127,0.5)") === RGBA{N0f8}(r8(0x37),r8(0xd9),r8(0x7f),0.5)
    @test parse(Colorant, "rgb( 55,217,127,50%)") === RGBA{N0f8}(r8(0x37),r8(0xd9),r8(0x7f),0.5) # CSS Color Module Level 4
    @test parse(Colorant, "rgb( 55 217 127 /.5)") === RGBA{N0f8}(r8(0x37),r8(0xd9),r8(0x7f),0.5) # CSS Color Module Level 4
    @test_throws ArgumentError parse(Colorant, "rgb(55, 85%, 50%)") # this is invalid according to CSS spec.
    @test parse(Colorant, "rgb(21.6%,85%,50%)") === RGB{N0f8}(r8(0x37),r8(0xd9),r8(0x80))

    # hsl()
    @test parse(Colorant, "hsl(120, 100%, 50%)")  === HSL{Float32}(120,1.0,.5)
    @test colorant"    Hsl(    120, 100%, 50% ) " === HSL{Float32}(120,1.0,.5)
    @test parse(RGB{N0f8},"hsl(120, 100%, 50%)")  === convert(RGB{N0f8}, HSL{Float32}(120,1.0,.5))
    @test_throws ArgumentError parse(Colorant, "hsl(120, 100, 50)")
    @test_throws ArgumentError parse(Colorant, "hsl(120%,100%,50%)")
    @test parse(Colorant, "hsla(120,50%,7%, .6)") === HSLA{Float32}(120,.5,.07,.6)
    @test parse(Colorant, "hsl( 120,50%,7%,60%)") === HSLA{Float32}(120,.5,.07,.6) # CSS Color Module Level 4
    @test parse(Colorant, "hsl( 120 50% 7% / 1)") === HSLA{Float32}(120,.5,.07, 1) # CSS Color Module Level 4
    @test parse(Colorant, "hsl(         90.0, 100%,   0%)") === HSL{Float32}(90, 1, 0)
    @test parse(Colorant, "hsl(        90Deg, 100%,   0%)") === HSL{Float32}(90, 1, 0)
    @test parse(Colorant, "hsl(     0.25turn, 120%, 0.0%)") === HSL{Float32}(90, 1, 0)
    @test parse(Colorant, "hsl(1.57079633RAD, 100%, -10%)") === HSL{Float32}(90, 1, 0)
    @test parse(Colorant, "hsl(      100grad, 100%, 0e2%)") === HSL{Float32}(90, 1, 0)

    @test parse(Colorant, :red) === colorant"red"
    @test_deprecated parse(Colorant, colorant"red") === colorant"red"

end

module CrossSectionalCharts

using Colors
using Main.PNG16x16

struct CrossSectionalChartSVG <: Main.SVG
    buf::IOBuffer
end

struct Axis
    index::Int # component index
    label::String
    range::AbstractRange
end
Base.first(a::Axis) = first(a.range)
Base.last(a::Axis) = last(a.range)

function crosssection(::Type{C};
                      x::Tuple=(1, "X", 0:1),
                      y::Tuple=(2, "Y", 0:1),
                      z::Tuple=(3, "Z", 0:1)) where C <: Color
    crosssection(C, Axis(x...), Axis(y...), Axis(z...))
end
function crosssection(::Type{C}, x::Axis, y::Axis, z::Axis) where C <: Color
    io = IOBuffer()
    id = String(nameof(C))

    write(io,
        """
        <svg xmlns="http://www.w3.org/2000/svg"
             xmlns:xlink="http://www.w3.org/1999/xlink"
             id="svg_$id" version="1.1"
             viewBox="0 0 40 30" width="27.09mm" height="20.32mm"
             stroke="none" style="display:inline; margin-left:2em; margin-bottom:1em">
        <defs>
        <filter id="filter_g_$id" filterUnits="userSpaceOnUse" x="0" y="-0.5" width="15.5" height="16">
          <feGaussianBlur stdDeviation="0.1" result="blur"/>
          <feMerge>
            <feMergeNode in="SourceGraphic"/>
            <feMergeNode in="blur"/>
          </feMerge>
        </filter>
        <style type="text/css"><![CDATA[
          #svg_$id g, #svg_$id image {
            transition: all 400ms ease 200ms;
          }
          #svg_$id path.b {
            stroke: currentColor;
            stroke-width: 0.5;
            opacity: 0;
            transition: all 200ms ease 0ms;
          }
          #svg_$id image {
            opacity: 0;
            filter:url(#filter_g_$id);
          }
          #svg_$id rect:active ~ image {
            opacity: 1;
            transition: all 200ms ease 0ms;
          }
          #svg_$id rect:hover ~ image {
            opacity: 1;
            transition: all 200ms ease 0ms;
          }
          #svg_$id rect:active ~ path.b {
            opacity: 0.8;
          }
          #svg_$id rect:hover ~ path.b {
            opacity: 0.8;
          }
          #svg_$id text {
            fill: currentColor;
            fill-opacity: 0.8;
            stroke: #aaa;
            stroke-width: 0.2;
            stroke-opacity: 0.4;
            font-size: 3px;
          }
          #svg_$id text.n {
            opacity:0;
          }
          #svg_$id:hover text.n {
            opacity:1;
          }
          #svg_$id:active text.n {
            opacity:1;
          }
        ]]></style>
        </defs>
        """)

    xs = [xv for xv in range(first(x), stop=last(x), length=16)]
    ys = [yv for yv in range(last(y), stop=first(y), length=16)]
    zs = [zv for zv in range(first(z), stop=last(z), length=11)]
    xmidf = (first(x) + last(x)) * 0.5
    ymidf = (first(y) + last(y)) * 0.5
    xmid = isinteger(xmidf) ? Int(xmidf) : xmidf
    ymid = isinteger(ymidf) ? Int(ymidf) : ymidf

    vec = [0.0, 0.0, 0.0]
    function col(xv, yv, zv)
        vec[x.index] = xv
        vec[y.index] = yv
        vec[z.index] = zv
        # TODO: Add more appropriate out-of-gamut color handling
        xyz = convert(XYZ, C(vec...))
        rgb = convert(RGB, XYZ(max(xyz.x,0), max(xyz.y,0), max(xyz.z,0)))
    end

    # add swatches of color bar and planes by layer
    for i = 1:11
        zi = isodd(i) ? 6 - i÷2 : 6 + i÷2 # zigzag order
        plane = [col(xs[xi], ys[yi], zs[zi]) for yi = 1:16, xi = 1:16]
        ccolor = col(xmid, ymid, zs[zi]) # center color (for color bar)
        barh = i == 1 ? 30 : 16.5 - 3*(i÷2)
        op = i == 1 ? "style=\"opacity:1;\"" : ""
        write(io,
            """
            <g>
              <rect fill="#$(hex(ccolor))" width="4" height="$(barh)" x="36" y="$(isodd(i) ? 30 - barh : 0)" />
              <image width="16" height="16" transform="scale(2) translate(-.5,0)" $op xlink:href=\"""")
        write_png_as_data(io, plane)
        write(io, "\" />\n")
        write(io,
            """
              <path d="m35,$(33-3zi) h 5" class="b"/>
            </g>
            """)
    end
    # add labels
    if first(x.range) * last(x.range) < 0
        write(io,
            """
            <path d="M0,15 h30 M15,0 v30" style="stroke:currentColor;stroke-width:0.125"/>
            <text x="29.5" y="14" style="text-anchor:end;">$(x.label)</text>
            <text x="29.5" y="18" style="text-anchor:end;" class="n">$(last(x))</text>
            <text x="16" y="3" style="text-anchor:start;">$(y.label)</text>
            <text x="14" y="3" style="text-anchor:end;" class="n">$(last(y))</text>
            <text x="14" y="18" style="text-anchor:end;" class="n">0</text>
            """)
    else
        write(io,
            """
            <text x="29.5" y="26" style="text-anchor:end;">$(x.label)</text>
            <text x="29.5" y="29" style="text-anchor:end;" class="n">$(last(x))</text>
            <text x="15" y="29" style="text-anchor:middle;" class="n">$xmid</text>
            <text x="6" y="3" style="text-anchor:start;">$(y.label)</text>
            <text x="0.5" y="3" style="text-anchor:start;" class="n">$(last(y))</text>
            <text x="0.5" y="16" style="text-anchor:start;" class="n">$ymid</text>
            <text x="0.5" y="29" style="text-anchor:start;" class="n">0</text>
            """)
    end
    write(io,
        """
        <text style="text-anchor:middle;" transform="translate(35,15) rotate(-90)">$(z.label)</text>
        <text x="36" y="3" style="text-anchor:end;" class="n">$(last(z))</text>
        <text x="36" y="29" style="text-anchor:end;" class="n">$(first(z))</text>
        <text x="2" y="26" style="fill:#fff;fill-opacity:1;text-anchor:start;">$id</text>
        <path d="m0,0 h40 v30 h-40 z" style="fill:none;stroke:none;" />
        </svg>""")
    CrossSectionalChartSVG(io)
end

crosssection(::Type{HSV}) = crosssection(HSV, x=(2, "S", 0:1),
                                              y=(3, "V", 0:1),
                                              z=(1, "H", 0:360))
crosssection(::Type{HSL}) = crosssection(HSL, x=(2, "S", 0:1),
                                              y=(3, "L", 0:1),
                                              z=(1, "H", 0:360))
crosssection(::Type{HSI}) = crosssection(HSI, x=(2, "S", 0:1),
                                              y=(3, "I", 0:1),
                                              z=(1, "H", 0:360))

crosssection(::Type{Lab}) = crosssection(Lab, x=(2, "a*", -100:100),
                                              y=(3, "b*", -100:100),
                                              z=(1, "L*", 0:100))
crosssection(::Type{Luv}) = crosssection(Luv, x=(2, "u*", -100:100),
                                              y=(3, "v*", -100:100),
                                              z=(1, "L*", 0:100))
crosssection(::Type{LCHab}) = crosssection(LCHab, x=(2, "C*", 0:100),
                                                  y=(1, "L*", 0:100),
                                                  z=(3, "H", 0:360))
crosssection(::Type{LCHuv}) = crosssection(LCHuv, x=(2, "C*", 0:100),
                                                  y=(1, "L*", 0:100),
                                                  z=(3, "H", 0:360))
crosssection(::Type{Oklab}) = crosssection(Oklab, x=(2, "a", -0.4:0.01:0.4),
                                                  y=(3, "b", -0.4:0.01:0.4),
                                                  z=(1, "L", 0:1))
crosssection(::Type{Oklch}) = crosssection(Oklch, x=(2, "C", 0:0.01:0.4),
                                                  y=(1, "L", 0:1),
                                                  z=(3, "h", 0:360))

crosssection(::Type{YIQ}) = crosssection(YIQ, x=(2, "I", -1:1),
                                              y=(3, "Q", -1:1),
                                              z=(1, "Y", 0:1))
crosssection(::Type{YCbCr}) = crosssection(YCbCr, x=(2, "Cb", 0:256),
                                                  y=(3, "Cr", 0:256),
                                                  z=(1, "Y", 0:256))
end

using Luxor

function main()
    Drawing(500, 500, "/tmp/colorslogo.png")
    # transparent background
    origin()
    juliacolors = [Luxor.julia_green, Luxor.julia_purple, Luxor.julia_red]
    pts = ngon(O + (0, 30), 110, 3, -pi/2, vertices=true)
    # I don't think I can draw it with compositing modes
    diskradius = 140
    # basic circles
    for (n, p) in enumerate(pts)
        sethue(juliacolors[n])
        circle(pts[mod1(n-1, 3)], diskradius, :fill)
    end
    @layer begin
        for (n, p) in enumerate(pts)
            circle(p, diskradius, :clip)
            sethue(["cyan", "magenta", "yellow"][mod1(n, 3)])
            circle(pts[mod1(n + 1, 3)], diskradius, :fill)
            clipreset()
        end
    end
    # center
    sethue("azure")
    circle(pts[1], diskradius, :clip)
    circle(pts[2], diskradius, :clip)
    circle(pts[3], diskradius, :fill)
    clipreset()
    finish()
    preview()
end

main()

using Colors, FixedPointNumbers
using Test
using ColorTypes: eltype_default

# The filter mechanism should not be removed, as new types may be added in the future.
const supported_p3 = filter(ColorTypes.parametric3) do C
    sym = Symbol(C)
    # NOTE: Add any currently unsupported color types here.
    # sym in (:unsupported1, :unsupported2) && return false
    return true
end
if supported_p3 == ColorTypes.parametric3
    @test supported_p3 == ColorTypes.parametric3
else
    @test_broken supported_p3 == ColorTypes.parametric3
    notsupported = setdiff(ColorTypes.parametric3, supported_p3)
    @warn "The following may not be fully tested: $notsupported"
end

struct C3{T} <: Color{T,3}
    c1::T; c2::T; c3::T;
end
struct C4{T} <: Color{T,4}
    c1::T; c2::T; c3::T; c4::T;
end
function ColorTypes._convert(::Type{Cdest}, ::Type{Odest}, ::Type{Osrc}, c) where {Cdest<:AbstractRGB,Odest,Osrc<:C4}
    Cdest(c.c1 + c.c4, c.c2 + c.c4, c.c3 + c.c4)
end
function ColorTypes._convert(::Type{Cdest}, ::Type{Odest}, ::Type{Osrc}, c) where {Cdest<:C4,Odest,Osrc<:AbstractRGB}
    r, g, b = red(c), green(c), blue(c)
    c4 = min(r, g, b)
    Cdest(r - c4, g - c4, b - c4, c4)
end

@testset "Conversion" begin
    r8(x) = reinterpret(N0f8, x)

    # srgb_compand / invert_srgb_compand
    @test Colors.srgb_compand(0.5) ≈ 0.7353569830524494 atol=eps()
    @test Colors.invert_srgb_compand(0.7353569830524494) ≈ 0.5 atol=eps()
    @test Colors.invert_srgb_compand(0.735357f0) ≈ 0.5f0 atol=eps(Float32)

    fractional_types = (RGB, BGR, XRGB, RGBX)  # types that support Fractional

    redF64 = RGB{Float64}(1,0,0)
    redF32 = RGB{Float32}(1,0,0)
    red24 = reinterpret(RGB24, 0x00ff0000)
    red32 = reinterpret(ARGB32, 0xffff0000)
    @testset "type check: RGB, RGB{$T}" for T in (Float64, Float32, N0f8)
        c = RGB(one(T), zero(T), zero(T))
        @test eltype(c) == T
        @test convert(RGB{Float64}, c) === redF64
        @test convert(RGB{T}, redF64) == c
    end
    @test RGB(1,0,0) == redF64
    @test RGB(UInt8(1), 0, 0) == redF64
    @test RGB(UInt8(1), UInt8(0), UInt8(0)) == redF64 # != colorant"#010000"
    @test convert(RGB, red24) == redF64

    @testset "type check: RGB24-->$Cto" for Cto in supported_p3
        @test typeof(convert(Cto, red24)) == Cto{eltype_default(Cto)}
        @test typeof(convert(Cto{Float64}, red24)) == Cto{Float64}
    end

    @testset "type check: C{Float}-->C{Float}" for Cfrom in supported_p3, Tfrom in (Float32, Float64)
        c = convert(Cfrom{Tfrom}, redF64)
        @test typeof(c) == Cfrom{Tfrom}
        @testset "$Cfrom{$Tfrom}-->$Cto" for Cto in supported_p3
            c1 = convert(Cto, c)
            @test eltype(c1) == Tfrom
        end
        @testset "$Cfrom{$Tfrom}-->$Cto{$Tto}" for Cto in supported_p3, Tto in (Float32, Float64)
            c2 = convert(Cto{Tto}, c)
            @test typeof(c2) == Cto{Tto}
        end
    end

    normed_types = (N0f8, N6f10, N4f12, N2f14, N0f16)
    # Test conversion from Normed types
    @testset "type check: C{Normed}-->C{Float}" for Cfrom in fractional_types, Tfrom in normed_types
        c = convert(Cfrom{Tfrom}, redF64)
        @test typeof(c) == Cfrom{Tfrom}
        @testset "$Cfrom{$Tfrom}-->$Cto" for Cto in supported_p3
            eltype_default(Cto) <: FixedPoint && continue
            c1 = convert(Cto, c)
            @test eltype(c1) == eltype_default(Cto)
        end
        @testset "$Cfrom{$Tfrom}-->$Cto{$Tto}" for Cto in supported_p3, Tto in (Float32, Float64)
            c2 = convert(Cto{Tto}, c)
            @test typeof(c2) == Cto{Tto}
        end
    end

    # Test conversion to Normed types
    @testset "type check: C{Float}-->C{Normed}" for Cfrom in supported_p3, Tfrom in (Float32, Float64)
        c = convert(Cfrom{Tfrom}, redF64)
        @test typeof(c) == Cfrom{Tfrom}
        @testset "$Cfrom{$Tfrom}-->$Cto{$Tto}" for Cto in fractional_types, Tto in normed_types
            c2 = convert(Cto{Tto}, c)
            @test typeof(c2) == Cto{Tto}
        end
    end

    ac = RGBA(redF64)

    @test convert(RGB, ac) == RGB(1,0,0)
    @test convert(RGB{N0f8}, ac) == RGB{N0f8}(1,0,0)
    @test convert(RGBA{N0f8}, ac) == RGBA{N0f8}(1,0,0,1)
    @test convert(HSVA, ac) == HSVA{Float64}(convert(HSV, redF64), 1.0)
    @test convert(HSVA{Float32}, ac) == HSVA{Float32}(convert(HSV{Float32}, redF64), 1.0f0)
    @test convert(RGBA, redF64) == ac

    @test convert(ARGB32, ac) == reinterpret(ARGB32, 0xffff0000)
    @test convert(ARGB32, RGB(1,0,0)) == reinterpret(ARGB32, 0xffff0000)
    ac32 = convert(ARGB32, RGB(1,0,0), 0.5)
    @test ac32 == reinterpret(ARGB32, 0x80ff0000)
    @test convert(ARGB32, ac32) === ac32
    @test convert(ARGB32, BGRA(1,0,0,0.5)) == reinterpret(ARGB32, 0x80ff0000)
    @test reinterpret(UInt32, convert(ARGB32, ac)) == 0xffff0000
    @test convert(RGB24, RGB(r8(0xff),r8(0x00),r8(0x00))) == reinterpret(RGB24, 0x00ff0000)
    @test reinterpret(UInt32, convert(RGB24, RGB(r8(0xff),r8(0x00),r8(0x00)))) == 0x00ff0000
    redhsv = convert(HSV, redF64)
    @test convert(RGB24, red24) === red24
    @test convert(RGB24, redhsv) == reinterpret(RGB24, 0x00ff0000)
    @test_throws ArgumentError convert(RGB24,  RGB(0, 1.1, 0))
    @test_throws ArgumentError convert(ARGB32, RGBA(0, 1.1, 0, 0.8))
    @test_throws ArgumentError convert(ARGB32, RGBA(0, 0.8, 0, 1.1))

    @test convert(RGB{N0f8}, red24) == RGB{N0f8}(1,0,0)
    @test convert(RGBA{N0f8}, red32) == RGBA{N0f8}(1,0,0,1)
    @test convert(HSVA{Float64}, red32) == HSVA{Float64}(0, 1, 1, 1)

    # whitepoint conversions
    @test isa(convert(XYZ, convert(Lab, redF64), Colors.WP_DEFAULT), XYZ{Float64})
    @test isa(convert(XYZ{Float32}, convert(Lab, redF64), Colors.WP_DEFAULT), XYZ{Float32})
    @test isa(convert(XYZ, convert(Luv, redF64), Colors.WP_DEFAULT), XYZ{Float64})
    @test isa(convert(XYZ{Float32}, convert(Luv, redF64), Colors.WP_DEFAULT), XYZ{Float32})
    @test isa(convert(Lab, convert(XYZ, redF64), Colors.WP_DEFAULT), Lab{Float64})
    @test isa(convert(Lab{Float32}, convert(XYZ, redF64), Colors.WP_DEFAULT), Lab{Float32})
    @test isa(convert(Luv, convert(XYZ, redF64), Colors.WP_DEFAULT), Luv{Float64})
    @test isa(convert(Luv{Float32}, convert(XYZ, redF64), Colors.WP_DEFAULT), Luv{Float32})

    #59
    @test Colors.xyz_to_uv(XYZ{Float64}(0.0, 0.0, 0.0)) === (0.0, 0.0)
    @test Colors.xyz_to_uv(XYZ{Float64}(0.0, 1.0, 0.0)) === (0.0, 0.6)
    @test Colors.xyz_to_uv(XYZ{Float64}(0.0, 1.0, 1.0)) === (0.0, 0.5)
    @test Colors.xyz_to_uv(XYZ{Float64}(1.0, 0.0, 1.0)) === (1.0, 0.0)
    @test Colors.xyz_to_uv(XYZ{Float64}(1.0, 0.0, 0.0)) === (4.0, 0.0)

    # ColorTypes.jl issue #40
    @test convert(HSL, RGB{N0f8}(0.678, 0.847, 0.902)) ≈ HSL{Float32}(194.73685f0,0.5327105f0,0.7901961f0) atol=100eps(Float32)

    # YIQ
    @test convert(YIQ, RGB(1, 0, 0)) ≈ YIQ{Float32}(0.299, 0.595716, 0.211456) atol=1e-7
    @test convert(YIQ, RGB(0, 1, 0)) ≈ YIQ{Float32}(0.587, -0.274453, -0.522591) atol=1e-7
    @test convert(YIQ, RGB(0, 0, 1)) ≈ YIQ{Float32}(0.114, -0.321263, 0.311135) atol=1e-7
    @test convert(RGB, YIQ(1.0,0.0,0.0)) == RGB(1,1,1)
    v = 0.595716
    @test convert(RGB, YIQ(0.0,1.0,0.0)) == RGB(0.9563*v,0,0)
    v = -0.522591
    @test convert(RGB, YIQ(0.0,0.0,-1.0)) == RGB(0,-0.6474*v,0)

    # Gray
    @test convert(Gray{N0f8}, Gray{N0f8}(0.1)) == Gray{N0f8}(0.1)
    @test convert(Gray{N0f8}, Gray(0.1))     == Gray{N0f8}(0.1)
    @test convert(Gray{N0f8}, Gray24(0.1))   == Gray{N0f8}(0.1)
    @test convert(Gray24, Gray{N0f8}(0.1))   == Gray24(0.1)

    @test convert(RGB{N0f8}, Gray{N0f8}(0.1)) == RGB{N0f8}(0.1,0.1,0.1)
    @test convert(RGB{N0f8}, Gray24(0.1))   == RGB{N0f8}(0.1,0.1,0.1)

    grayN0f16 = Gray{N0f16}(0.8)
    @test convert(RGB, grayN0f16) == RGB{N0f16}(0.8,0.8,0.8)
    @test convert(RGB{Float32}, grayN0f16) == RGB{Float32}(0.8,0.8,0.8)

    @testset "$C-->Gray" for C in supported_p3
        c = convert(C, RGB(1,1,1))
        g1 = convert(Gray, c)
        @test isa(g1, Gray)
        @test gray(g1) ≈ 1 atol=0.01
        g2 = convert(Gray{Float64}, c)
        @test typeof(g2) == Gray{Float64}
        @test gray(g2) ≈ 1 atol=0.01
    end
    # Issue #377
    @test convert(Gray, RGB24(1,0,0)) === convert(Gray, RGB(1,0,0)) === Gray{N0f8}(0.298)
    @test convert(Gray24, RGB(1,0,0)) === Gray24(0.298)
    # Check for roundoff error
    for N in (N0f8, N0f16, N0f32)
        @test convert(Gray{N}, RGB{N}(1,1,1)) === Gray{N}(1)
    end
    @test gray(convert(Gray{N0f64}, RGB{N0f64}(1,1,1))) ≈ 1.0

    # Images issue #382
    @test convert(Gray, RGBA(1,1,1,1)) == Gray(N0f8(1))

    # https://github.com/timholy/Images.jl/pull/445#issuecomment-189866806
    @test convert(Gray, RGB{N0f8}(0.145,0.145,0.145)) == Gray{N0f8}(0.145)


    # More AbstractRGB
    r4 = RGBX(1,0,0)
    @test convert(RGB, r4) == RGB(1,0,0)
    @test convert(RGB{N0f8}, r4) == RGB{N0f8}(1,0,0)
    @test convert(RGBX{N0f8}, r4) == RGBX{N0f8}(1,0,0)
    @test convert(RGBX{Float32}, r4) == RGBX{Float32}(1,0,0)
    @test convert(BGR{Float32}, r4) == BGR{Float32}(1,0,0)

    # Issue #257
    c = RGB{Float16}(0.9473,0.962,0.9766)
    convert(HSI, c)
    hsi = convert(HSI, c)
    @test hsi.i > 0.96 && hsi.h ≈ 210

    # {HSV, HSL, HSI} --> RGB (issue #379)
    @testset "HSx --> RGB" begin
        @test convert(RGB, HSV{Float32}( 780, 1, 1)) === RGB{Float32}(1,1,0)
        @test convert(RGB, HSV{Float32}(   0, 1, 1)) === RGB{Float32}(1,0,0)
        @test convert(RGB, HSV{Float32}(-780, 1, 1)) === RGB{Float32}(1,0,1)
        @test convert(RGB, HSV{Float32}(30,  2, .5)) === RGB{Float32}(.5,.25,0)
        @test convert(RGB, HSV{Float32}(30, .5, -1)) === RGB{Float32}(0,0,0)
        @test convert(RGB{Float64}, HSV{BigFloat}(-360120, 2, 1)) === RGB{Float64}(0,0,1)

        @test convert(RGB, HSL{Float32}( 780, 1, .5)) === RGB{Float32}(1,1,0)
        @test convert(RGB, HSL{Float32}(   0, 1, .5)) === RGB{Float32}(1,0,0)
        @test convert(RGB, HSL{Float32}(-780, 1, .5)) === RGB{Float32}(1,0,1)
        @test convert(RGB, HSL{Float32}(30,  2, .25)) === RGB{Float32}(.5,.25,0)
        @test convert(RGB, HSL{Float32}(30, .5,  -1)) === RGB{Float32}(0,0,0)
        @test convert(RGB{Float64}, HSL{BigFloat}(-360120, 2, .5)) === RGB{Float64}(0,0,1)

        @test convert(RGB, HSI{Float32}( 780, .5, .5)) ≈ RGB{Float32}(.625,.625,.25)
        @test convert(RGB, HSI{Float32}(   0, .5, .5)) ≈ RGB{Float32}(1,.25,.25)
        @test convert(RGB, HSI{Float32}(-780, .5, .5)) ≈ RGB{Float32}(.625,.25,.625)
        @test convert(RGB, HSI{Float32}(30,  2, .25)) ≈ RGB{Float32}(.5,.25,0)
        @test convert(RGB, HSI{Float32}(30, .5,  -1)) ≈ RGB{Float32}(0,0,0)
        @test convert(RGB{Float64}, HSI{BigFloat}(-360120, .5, .5)) ≈ RGB{Float64}(.25,.25,1)
    end

    # Oklab examples from Björn Ottosson (https://bottosson.github.io/posts/oklab/)
    @testset "Oklab <-> XYZ" begin
        @test convert(Oklab, XYZ{Float32}(0.950, 1.000, 1.089)) ≈ Oklab{Float32}(1.000,  0.000,  0.000) atol=2e-3
        @test convert(Oklab, XYZ{Float32}(1.000, 0.000, 0.000)) ≈ Oklab{Float32}(0.450,  1.236, -0.019) atol=2e-3
        @test convert(Oklab, XYZ{Float32}(0.000, 1.000, 0.000)) ≈ Oklab{Float32}(0.922, -0.671,  0.263) atol=2e-3
        @test convert(Oklab, XYZ{Float32}(0.000, 0.000, 1.000)) ≈ Oklab{Float32}(0.153, -1.415, -0.449) atol=2e-3

        @test convert(XYZ, Oklab{Float32}(1.000,  0.000,  0.000)) ≈ XYZ{Float32}(0.950, 1.000, 1.089) atol=2e-3
        @test convert(XYZ, Oklab{Float32}(0.450,  1.236, -0.019)) ≈ XYZ{Float32}(1.000, 0.000, 0.000) atol=2e-3
        @test convert(XYZ, Oklab{Float32}(0.922, -0.671,  0.263)) ≈ XYZ{Float32}(0.000, 1.000, 0.000) atol=2e-3
        @test convert(XYZ, Oklab{Float32}(0.153, -1.415, -0.449)) ≈ XYZ{Float32}(0.000, 0.000, 1.000) atol=2e-3
    end

    # Selection of Oklch tests from the WPT test suite (https://wpt.fyi/results/css/css-color)
    @testset "Oklch <-> RGB" begin
        @test convert(Oklch, RGB{Float32}(0.00000, 0.00000, 0.00000)) ≈ Oklch{Float32}(0.00, 0.00,   0) rtol=2e-2
        @test convert(Oklch, RGB{Float32}(0.23056, 0.31730, 0.82628)) ≈ Oklch{Float32}(0.50, 0.20, 270) rtol=2e-2
        @test convert(Oklch, RGB{Float32}(0.32022, 0.85805, 0.61147)) ≈ Oklch{Float32}(0.80, 0.15, 160) rtol=2e-2
        @test convert(Oklch, RGB{Float32}(0.67293, 0.27791, 0.52280)) ≈ Oklch{Float32}(0.55, 0.15, 345) rtol=2e-2

        @test convert(RGB, Oklch{Float32}(0.00, 0.00,   0)) ≈ RGB{Float32}(0.00000, 0.00000, 0.00000) rtol=2e-2
        @test convert(RGB, Oklch{Float32}(0.50, 0.20, 270)) ≈ RGB{Float32}(0.23056, 0.31730, 0.82628) rtol=2e-2
        @test convert(RGB, Oklch{Float32}(0.80, 0.15, 160)) ≈ RGB{Float32}(0.32022, 0.85805, 0.61147) rtol=2e-2
        @test convert(RGB, Oklch{Float32}(0.55, 0.15, 345)) ≈ RGB{Float32}(0.67293, 0.27791, 0.52280) rtol=2e-2
    end

    @testset "custom types" begin
        # issue #465
        @test_throws ErrorException convert(RGB,   C3{Float32}(1, 2, 3))
        @test_throws ErrorException convert(RGB24, C3{Float64}(1, 2, 3))
        @test_throws ErrorException convert(Lab,   C3{Float16}(1, 2, 3))

        @test @inferred(convert(RGB,   C4{Float32}(0.1, 0.2, 0.3, 0.4))) ≈ RGB{Float32}(0.5, 0.6, 0.7)
        @test @inferred(convert(RGB24, C4{Float64}(0.1, 0.2, 0.3, 0.4))) ≈ RGB24(0.5, 0.6, 0.7)
        @test @inferred(convert(ALab,  C4{Float16}(0.1, 0.2, 0.3, 0.4))) ≈ ALab{Float16}(62.12, -2.86, -16.25, 1.0)

        @test @inferred(convert(C4, RGB{Float32}(0.5, 0.6, 0.7))) ≈ C4{Float32}(0.0, 0.1, 0.2, 0.5)
        @test @inferred(convert(C4{N0f8}, ARGB32(0.5, 0.6, 0.7))) ≈ C4{N0f16}(0.0, 0.1, 0.2, 0.5)
        @test @inferred(convert(C4, Lab{Float16}(62.12, -2.86, -16.25))) ≈ C4{Float16}(0.0, 0.1, 0.2, 0.5)
    end

    # Test accuracy of conversion
    include("test_conversions.jl")

    # Since `colordiff`(e.g. `DE_2000`) involves a color space conversion, it is
    # not suitable for evaluating the conversion itself. On the other hand,
    # since the tolerance varies from component to component, a homogeneous
    # error evaluation function (e.g. a simple sum of differences) is also not
    # appropriate. Therefore, a series of `diffnorm`, which returns the
    # normalized Euclidean distance, is defined as follows. They are just for
    # testing purposes as the cyclicity of hue is ignored.
    sqd(a, b, s=1.0) = ((float(a) - float(b))/s)^2
    function diffnorm(a::T, b::T) where {T<:Color3} # RGB,XYZ,xyY,LMS
        sqrt(sqd(comp1(a), comp1(b)) + sqd(comp2(a), comp2(b)) + sqd(comp3(a),comp3(b)))/sqrt(3)
    end
    function diffnorm(a::T, b::T) where {T<:Union{HSV,HSL,HSI}}
        sqrt(sqd(a.h, b.h, 360) + sqd(a.s, b.s) + sqd(comp3(a), comp3(b)))/sqrt(3)
    end
    function diffnorm(a::T, b::T) where {T<:Union{Lab,Luv}}
        sqrt(sqd(a.l, b.l, 100) + sqd(comp2(a), comp2(b), 200) + sqd(comp3(a), comp3(b), 200))/sqrt(3)
    end
    function diffnorm(a::T, b::T) where {T<:Oklab}
        sqrt(sqd(a.l, b.l) + sqd(a.a, b.a, 0.4) + sqd(a.b, b.b, 0.4))/sqrt(3)
    end
    function diffnorm(a::T, b::T) where {T<:Union{LCHab,LCHuv}}
        sqrt(sqd(a.l, b.l, 100) + sqd(a.c, b.c, 100) + sqd(a.h, b.h, 360))/sqrt(3)
    end
    function diffnorm(a::T, b::T) where {T<:Oklch}
        sqrt(sqd(a.l, b.l, 1) + sqd(a.c, b.c, 0.4) + sqd(a.h, b.h, 360))/sqrt(3)
    end
    function diffnorm(a::T, b::T) where {T<:Union{DIN99,DIN99d,DIN99o}} # csconv has no DIN99 case
        sqrt(sqd(a.l, b.l, 100) + sqd(a.a, b.a, 100) + sqd(a.b, b.b, 100))/sqrt(3)
    end
    function diffnorm(a::T, b::T) where {T<:YIQ}
        sqrt(sqd(a.y, b.y) + sqd(a.i, b.i, 1.2) + sqd(a.q, b.q, 1.2))/sqrt(3)
    end
    function diffnorm(a::T, b::T) where {T<:YCbCr}
        sqrt(sqd(a.y, b.y, 219) + sqd(a.cb, b.cb, 224) + sqd(a.cr, b.cr, 224))/sqrt(3)
    end

    for C in supported_p3
        y = convert(C, RGB(1.0,1.0,0.0))
        b = convert(C, RGB(0.1,0.1,0.2))
        diffnorm(y, b) < 0.5 && @warn("`diffnorm` for $C may be broken")
    end

    function convcompare(from, to, tol; showfailure::Bool=false)
        errmax = 0.0
        for i in eachindex(from)
            t = to[i]
            f = convert(typeof(t), from[i])
            diff = diffnorm(t, f)
            if showfailure && diff>tol
                original = from[i]
                @show original f t diff
            end
            errmax = max(errmax, diff)
        end
        errmax > tol && @warn("Error on conversions from $(eltype(from)) to $(eltype(to)), relative error = $errmax")
        errmax <= tol
    end

    @testset "accuracy test: $Cfrom-->$Cto" for Cto in keys(csconv), Cfrom in keys(csconv)
        f = csconv[Cfrom]
        t = csconv[Cto]
        @test convcompare(f, t, 2e-3, showfailure=false)
    end
end

using Test, Colors

@testset "Algorithms" begin
    # Test vector space operations
    @testset "$C arithmetic" for C in (LMS, XYZ)
        Cf64 = C{Float64}
        Cf32 = C{Float32}
        @test Cf64(0.125,0.50,0.0) + Cf64(0.25,0.75,0.5) === Cf64(0.375,1.25,0.5)
        @test Cf32(0.375,1.25,0.5) - Cf64(0.25,0.75,0.5) === Cf64(0.125,0.50,0.0)
        @test -Cf32(0.125,0.50,0.0) === Cf32(-0.125,-0.50,-0.0)
        @test 3 * Cf32(0.125,0.5,0.0) === Cf32(0.375,1.5,0.0)
        @test Cf32(0.125,0.5,0.0) * 3.0 === Cf64(0.375,1.5,0.0)
        @test Cf64(0.375,1.5,0.0) / 3 === Cf64(0.125,0.5,0.0)
    end
    @test_throws Exception LMS(1,1,1) - XYZ(1,1,1)

    # issue #349
    msc_h_diff = 0
    for hsv_h in 0:0.1:360
        hsv = HSV(hsv_h, 1.0, 1.0) # most saturated
        lch = convert(LCHuv, hsv)
        msc = MSC(lch.h)
        msc_h_diff = max(msc_h_diff, colordiff(msc, lch))
    end
    @test msc_h_diff < 1

    @test MSC(123.45, 100) ≈ 0
    @test MSC(123.45, 0) ≈ 0

    msc_h_l_sat = 1
    for h = 0:0.1:359.9, l = 1:1:99
        c = MSC(h, l)
        hsv = convert(HSV, LCHuv(l, c, h))
        # When the color is saturated (except black/white), `s` or `v` is 1.
        msc_h_l_sat = min(msc_h_l_sat, max(hsv.s, hsv.v))
    end
    @test msc_h_l_sat > 1 - 1e-4

    # the linear interpolation introduces some approximation errors.(issue #349)
    @test MSC(0, 90, linear=true) > MSC(0, 90)
    @test MSC(280, 50, linear=true) < MSC(280, 50)

    @testset "find_maximum_chroma hsv_h=$hsv_h" for hsv_h in 0:60:300
        hsv = HSV(hsv_h, 1.0, 1.0) # corner
        lchab = convert(LCHab, hsv)
        lchuv = convert(LCHuv, hsv)
        lab = convert(Lab, hsv)
        luv = convert(Luv, hsv)
        @test Colors.find_maximum_chroma(lchab) ≈ lchab.c atol=0.01
        @test Colors.find_maximum_chroma(lchuv) ≈ lchuv.c atol=0.01
        @test Colors.find_maximum_chroma(lab) ≈ lchab.c atol=0.01
        @test Colors.find_maximum_chroma(luv) ≈ lchuv.c atol=0.01
    end

    # yellow in LCHab
    @test Colors.find_maximum_chroma(LCHab(94.2, 0, 100)) ≈ 93.749 atol=0.01
    @test Colors.find_maximum_chroma(LCHab(97.6, 0, 105)) ≈ 68.828 atol=0.01

    # Color vision deficiency simulations at p=0
    rgb = RGB(0.44, 0.26, 0.8)
    @test protanopic(rgb, 0) ≈ rgb
    @test deuteranopic(rgb, 0) ≈ rgb
    @test tritanopic(rgb, 0) ≈ rgb
end

using Test, Colors
using FixedPointNumbers

@testset "Display" begin
    @testset "showable" begin
        @test showable("image/svg+xml", RGB24(1, 0.5, 0))
        @test showable("image/svg+xml", Lab(50.0, 0.0, NaN)) === false
        @test showable("image/svg+xml", colormap("Reds", 4))
        @test showable("image/svg+xml", [HSVA(30, 1, 1, a) for a = 0.0:0.1:1.0])
        @test showable("image/svg+xml", [rand(Gray, 4); Gray(Inf)]) === false
        @test showable("image/svg+xml", rand(RGB, 2, 2))
        @test showable("image/svg+xml", rand(ARGB, 2, 2)) === false
        @test showable("image/svg+xml", rand(HSV, 2, 2, 2)) === false
        @test showable("image/svg+xml", Color[RGB(0, 0, 0) HSV(0, 0, 0);
                                              XYZ(0, 0, 0) Luv(0, 0, 0)])
        @test showable("image/svg+xml", Color[RGB(0, 0, 0) HSV(0, 0, 0);
                                              XYZ(0, 0, 0) Luv(0, 0, NaN)]) === false
    end

    function count_element(pattern::Regex, svg::AbstractString)
        n = 0
        i = firstindex(svg)
        while true
            r = findnext(pattern, svg, i)
            r === nothing && return n
            n += 1
            i = last(r)
        end
    end
    count_filled_rect(svg) =
        count_element(r"<rect[^>]*\sfill=\"#[0-9A-F]{6}\"[^>]+>", svg)
    count_colored_stroke(svg) =
        count_element(r"<path[^>]*\sstroke=\"#[0-9A-F]{6}\"[^>]+>", svg)
    count_transparently_filled(svg) =
        count_element(r"<[^>]*\sfill-opacity=\"[\d.]+\"[^>]+>", svg)

    # test ability to add to previously shown array of colors - issue #328
    a = [colorant"white", colorant"red"]
    buf = IOBuffer()
    show(buf, "image/svg+xml", a)
    take!(buf)
    push!(a, colorant"blue")
    @test length(a) == 3


    # the following tests depend on the constants in "src/display.jl"

    # single `Color`
    # --------------
    show(buf, "image/svg+xml", colorant"hsl(120, 100%, 50%)")
    single = String(take!(buf))
    @test occursin(r"<svg[^>]+\swidth=\"25mm\"", single)
    @test occursin(r"<svg[^>]+\sheight=\"25mm\"", single)
    @test occursin(r"\sfill=\"#00FF00\"", single)
    @test occursin(r"</svg>$", single)


    # vectors of `Color`
    # ------------------
    # square swatches
    v3 = [colorant"red", colorant"green", colorant"blue"]
    show(buf, "image/svg+xml", v3)
    vector3 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"75mm\"", vector3)
    @test occursin(r"<svg[^>]*\sheight=\"25mm\"", vector3)
    @test occursin(r"<rect[^>]*\swidth=\".96\"", vector3) # 0.96 = 24mm/25mm
    @test occursin(r"<rect[^>]*\sheight=\".96\"", vector3) # height = width
    @test occursin(r"<rect[^>]*\sfill=\"#FF0000\"", vector3)
    @test occursin(r"<rect[^>]*\sfill=\"#008000\"", vector3)
    @test occursin(r"<rect[^>]*\sfill=\"#0000FF\"", vector3)
    @test occursin(r"</svg>$", vector3)

    # rectangle swatches
    show(buf, "image/svg+xml", colormap("RdBu", 100))
    vec100 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"180mm\"", vec100) # max_width
    @test occursin(r"<svg[^>]*\sheight=\"25mm\"", vec100)
    @test occursin(r"<rect[^>]*\swidth=\"1\"", vec100) # no padding
    @test occursin(r"<rect[^>]*\sheight=\".96\"", vec100) # 0.96 = 24mm/25mm
    @test count_filled_rect(vec100) == 100

    # issue #317
    # limits max swatches
    # the size warning should be suppressed
    show(buf, MIME"image/svg+xml"(), v3, max_swatches=2) # not string but MIME
    lim_vector3 = String(take!(buf))
    # since `max_swatches`(=2) is less practical,
    # the width/height is greater than `max_swatch_size`
    @test occursin(r"<svg[^>]*\swidth=\"180mm\"", lim_vector3) # max_width
    @test occursin(r"<svg[^>]*\sheight=\"60mm\"", lim_vector3) # 180mm/3 * 1
    # decimation factor `d` should be 2
    # viewBox is based on the original size (=3x1)
    @test occursin(r"<svg[^>]*\sviewBox=\"0 -1 3 1\"", lim_vector3)
    # therefore, each swatch is contrarily enlarged due to the swatch reduction.
    # stroke width is equivalent to swatch height which is equal to `d`(=2)
    @test occursin(r"<svg[^>]*\sstroke-width=\"2\"", lim_vector3)
    # swatch width is equal to `d`(=2)
    @test occursin(r"<path[^>]*\sd=\"[^\"]+h2\"", lim_vector3) # no padding
    # the mean RGB of first 2 elements (red and green)
    @test occursin(r"stroke=\"#804000\"[^/]*/>\s*<path\s", lim_vector3)
    # the RGB of last element (blue)
    @test occursin(r"stroke=\"#0000FF\"[^/]*/>\s*</svg>", lim_vector3)
    @test count_colored_stroke(lim_vector3) == 2 # <= max_swatches


    # m * n matrices of `Color`
    # -------------------------
    # n * max_swatch_size <= max_width &&
    # m * max_swatch_size <= max_height
    # square swatches
    m2x2 = [colorant"white" colorant"blue"
            colorant"black" colorant"cyan"]
    show(buf, "image/svg+xml", m2x2)
    mat2x2 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"50mm\"", mat2x2)
    @test occursin(r"<svg[^>]*\sheight=\"50mm\"", mat2x2)
    @test occursin(r"<rect[^>]*\swidth=\".96\"", mat2x2) # 0.96 = 24mm/25mm
    @test occursin(r"<rect[^>]*\sheight=\".96\"", mat2x2) # height = width
    @test occursin(r"<rect[^>]*\sfill=\"#FFFFFF\"", mat2x2)
    @test occursin(r"<rect[^>]*\sfill=\"#0000FF\"", mat2x2)
    @test occursin(r"<rect[^>]*\sfill=\"#000000\"", mat2x2)
    @test occursin(r"<rect[^>]*\sfill=\"#00FFFF\"", mat2x2)
    @test occursin(r"</svg>$", vector3)

    # n * max_swatch_size > max_width &&
    # m * max_swatch_size <= max_height
    # square swatches
    show(buf, "image/svg+xml", rand(RGB, 2, 9))
    mat2x9 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"180mm\"", mat2x9) # max_width
    @test occursin(r"<svg[^>]*\sheight=\"40mm\"", mat2x9) # 40mm = 180mm/9 * 2
    @test occursin(r"<rect[^>]*\swidth=\".95\"", mat2x9) # 0.95 = 19mm/20mm
    @test occursin(r"<rect[^>]*\sheight=\".95\"", mat2x9) # height = width
    @test count_filled_rect(mat2x9) == 18

    # n * max_swatch_size <= max_width &&
    # m * max_swatch_size > max_height
    # square swatches
    show(buf, "image/svg+xml", rand(RGB, 10, 2))
    mat10x2 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"30mm\"", mat10x2) # 30mm = 150mm/10 * 2
    @test occursin(r"<svg[^>]*\sheight=\"150mm\"", mat10x2) # max_height
    @test occursin(r"<rect[^>]*\swidth=\".93\"", mat10x2) # 0.93 = 14mm/15mm
    @test occursin(r"<rect[^>]*\sheight=\".93\"", mat10x2) # height = width
    @test count_filled_rect(mat10x2) == 20

    # issue #341
    # n * max_swatch_size > max_width &&
    # m * max_swatch_size > max_height &&
    # max_width / n * m >= max_swatch_size
    # square swatches (strokes)
    show(buf, "image/svg+xml", rand(RGB, 28, 181))
    mat28x181 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"180mm\"", mat28x181) # max_width
    @test occursin(r"<svg[^>]*\sheight=\"27.85mm\"", mat28x181) # 180mm/181 * 28
    @test occursin(r"<path[^>]*\sd=\"[^\"]+h1\"", mat28x181) # no padding
    @test count_colored_stroke(mat28x181) == 28*181

    # issue #341
    # n * max_swatch_size > max_width &&
    # m * max_swatch_size > max_height &&
    # max_height / m * n < max_swatch_size
    # square swatches (strokes)
    show(buf, "image/svg+xml", rand(RGB, 200, 28))
    mat200x28 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"21mm\"", mat200x28) # 150mm/200*28
    @test occursin(r"<svg[^>]*\sheight=\"150mm\"", mat200x28) # max_height
    @test occursin(r"<path[^>]*\sd=\"[^\"]+h1\"", mat200x28) # no padding
    @test count_colored_stroke(mat200x28) == 200*28

    # issue #317
    # implicitly limits max swatches (but explicitly warns)
    # m * n > default_max_swatches
    # square swatches (strokes) with reduction
    m184x360 = [HSV(h, s / 183, 0.8) for s = 0:183, h = 0:359]
    # warning of size
    warning = r"the large size \(184×360\)"
    @test_logs (:warn, warning) show(buf, "image/svg+xml", m184x360)
    mat184x360 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"180mm\"", mat184x360) # max_width
    @test occursin(r"<svg[^>]*\sheight=\"92mm\"", mat184x360) # 180mm/360 * 184
    # decimation factor should be 3
    @test occursin(r"<svg[^>]*\sviewBox=\"0 -1.5[0]* 360 184\"", mat184x360)
    @test occursin(r"<svg[^>]*\sstroke-width=\"3\"", mat184x360) # `d`(=3)
    @test occursin(r"<path[^>]*\sd=\"[^\"]+h3\"", mat184x360) # `d`(=3)
    # the mean RGB of 3 (not 9) elements in the bottom-right corner
    # "CC0007" == hex(RGB(0.8, 0.0, (0.12/3 + 0.08/3 + 0.04/3)/3))
    @test occursin(r"stroke=\"#CC0007\"[^/]*/>\s*</svg>", mat184x360)
    @test count_colored_stroke(mat184x360) == ceil(184/3)*ceil(360/3)

    # issue #317
    # limits max swatches
    # the size warning should be suppressed
    show(buf, MIME"image/svg+xml"(), m2x2, max_swatches=3) # not string but MIME
    lim_mat2x2= String(take!(buf))
    # since `max_swatches`(=3) is less practical,
    # the width/height is greater than `max_swatch_size`
    @test occursin(r"<svg[^>]*\swidth=\"150mm\"", lim_mat2x2) # 180mm/2 * 2
    @test occursin(r"<svg[^>]*\sheight=\"150mm\"", lim_mat2x2) # max_height
    # decimation factor `d` should be 2
    @test occursin(r"<svg[^>]*\sviewBox=\"0 -1 2 2\"", lim_mat2x2)
    @test occursin(r"<svg[^>]*\sstroke-width=\"2\"", lim_mat2x2) # `d`(=2)
    @test occursin(r"<path[^>]*\sd=\"[^\"]+h2\"", lim_mat2x2) # `d`(=2)
    # the mean RGB of 2x2 elements
    @test occursin(r"stroke=\"#4080BF\"[^/]*/>\s*</svg>", lim_mat2x2)
    @test count_colored_stroke(lim_mat2x2) == 1 # <= max_swatches


    # single `TransparentColor`
    # -------------------------
    show(buf, "image/svg+xml", colorant"hsla(120, 100%, 50%, 0.2)")
    tp_single = String(take!(buf))
    @test occursin(r"<svg[^>]+\swidth=\"25mm\"", tp_single)
    @test occursin(r"<svg[^>]+\sheight=\"25mm\"", tp_single)
    @test occursin(r"M1,0v1h-1z", tp_single) # triangle
    @test occursin(r"\sfill=\"#00FF00\"", tp_single)
    @test occursin(r"\sfill-opacity=\".2\"", tp_single)
    @test occursin(r"</svg>$", tp_single)
    @test count_transparently_filled(tp_single) == 1

    # vectors of `TransparentColor`
    # -----------------------------
    # square swatches
    tp_v3 = RGBA[colorant"transparent", RGBA(0,0.5,0,0.5), colorant"blue"]
    show(buf, "image/svg+xml", tp_v3)
    tp_vector3 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"75mm\"", tp_vector3)
    @test occursin(r"<svg[^>]*\sheight=\"25mm\"", tp_vector3)
    @test occursin(r"M1,0v1h-1z", tp_vector3) # triangle
    @test occursin(r"\sfill-opacity=\"0\"", tp_vector3)
    @test occursin(r"\sfill-opacity=\".5\"", tp_vector3)
    @test occursin(r"\sfill-opacity=\"1\"", tp_vector3)

    @test count_transparently_filled(tp_vector3) == 3

    # rectangle swatches
    show(buf, "image/svg+xml", LuvA.(colormap("Greens", 100), 0.8))
    tp_vec100 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"180mm\"", tp_vec100) # max_width
    @test occursin(r"<svg[^>]*\sheight=\"25mm\"", tp_vec100)
    # scale = 13.889 = 1 / 0.072
    @test occursin(r"M1,.46V1h-1V.54z", tp_vec100) # 0.5±(0.072/2), trapezoid
    @test count_transparently_filled(tp_vec100) == 100

    # implicitly limits max swatches (but explicitly warns)
    # n > default_max_swatches
    # warning of length
    warning_tpv = r"Last 16 swatches \(of 16400-element Array\) are truncated\."
    tp_vec16400 = [LCHabA(70, 40, i/100, i/16400) for i = 1:128*128+16]
    @test_logs (:warn, warning_tpv) show(buf, "image/svg+xml", tp_vec16400)
    tp_v16400 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"180mm\"", tp_v16400) # max_width
    @test occursin(r"<svg[^>]*\sheight=\"25mm\"", tp_v16400)
    @test count_transparently_filled(tp_v16400) == 128 * 128

    # limits max swatches
    # the length warning should be suppressed
    show(buf, MIME"image/svg+xml"(), tp_v3, max_swatches=2)
    lim_tp_vec3 = String(take!(buf))
    @test occursin(r"<svg[^>]*\swidth=\"75mm\"", lim_tp_vec3)
    @test occursin(r"<svg[^>]*\sheight=\"25mm\"", lim_tp_vec3)
    # viewBox is based on the original length (=3)
    @test occursin(r"<svg[^>]*\sviewBox=\"0 0 3 1\"", lim_tp_vec3)
    @test count_transparently_filled(lim_tp_vec3) == 2 # max_swatches
end

# Arithmetic
#XYZ and LMS are linear vector spaces
const Linear3 = Union{XYZ, LMS}
+(a::Linear3, b::Linear3) = mapc(+, a, b)
-(a::Linear3, b::Linear3) = mapc(-, a, b)
-(a::Linear3) = mapc(-, a)
*(k::Number, a::Linear3) = mapc(v -> k * v, a)
*(a::Linear3, k::Number) = k * a
/(a::Linear3, k::Number) = mapc(v -> v / k, a)

# Algorithms relating to color processing and generation


# Chromatic Adaptation / Whitebalancing
# -------------------------------------

"""
    whitebalance(c, src_white, ref_white)

Whitebalance a color.

Input a source (adopted) and destination (reference) white. For example, if you want a photo
taken under fluorescent lighting to appear correct in regular sunlight, you might do
something like `whitebalance(c, WP_F2, WP_D65)`.

# Arguments

- `c`: An observed color.
- `src_white`: Adopted or source white corresponding to `c`
- `ref_white`: Reference or destination white.

Returns a whitebalanced color.
"""
function whitebalance(c::T, src_white::Color, ref_white::Color) where T <: Color
    c_lms = convert(LMS, c)
    src_wp = convert(LMS, src_white)
    dest_wp = convert(LMS, ref_white)

    # This is sort of simplistic, it sets the degree of adaptation term in
    # CAT02 to 0.
    # Setting the degree of adaptation to 0 is rather odd. Wouldn’t setting
    # it to 1.0 make more sense as a temporary default value?
    ans = LMS(c_lms.l * dest_wp.l / src_wp.l,
              c_lms.m * dest_wp.m / src_wp.m,
              c_lms.s * dest_wp.s / src_wp.s)

    convert(T, ans)
end


# Simulation of color deficiency (color "blindness")
# ----------------------------

# This method is due to:
# Brettel, H., Viénot, F., & Mollon, J. D. (1997).  Computerized simulation of
# color appearance for dichromats. Josa A, 14(10), 2647–2655.
#
# These functions add to Brettel's method a parameter p in [0, 1] giving the
# degree of photopigment loss. At p = 1, the complete loss of a particular
# photopigment is simulated, where 0 < p < 1 represents partial loss.


# This is supposed to be "the brightest possible metamer of an equal-energy
# stimulus". I'm punting a bit and just calling that RGB white.
const default_brettel_neutral = convert(LMS, RGB(1, 1, 1))


# Helper function for Brettel conversions.
function brettel_abc(neutral::LMS, anchor::LMS)
    a = neutral.m * anchor.s - neutral.s * anchor.m
    b = neutral.s * anchor.l - neutral.l * anchor.s
    c = neutral.l * anchor.m - neutral.m * anchor.l
    (a, b, c)
end


"""
    protanopic(c)
    protanopic(c, p)

Convert a color to simulate protanopic color deficiency (lack of the
long-wavelength photopigment). `c` is the input color; the optional
argument `p` is the fraction of photopigment loss, in the range 0 (no
loss) to 1 (complete loss).
"""
function protanopic(q::T, p, neutral::LMS) where T <: Color
    q = convert(LMS, q)
    anchor_wavelen = q.s / q.m < neutral.s / neutral.m ? 575 : 475
    anchor = colormatch(anchor_wavelen)
    anchor = convert(LMS, anchor)
    (a, b, c) = brettel_abc(neutral, anchor)

    q = LMS((one(p) - p) * q.l + p * (-(b*q.m + c*q.s)/a),
            q.m,
            q.s)
    convert(T, q)
end


"""
    deuteranopic(c)
    deuteranopic(c, p)

Convert a color to simulate deuteranopic color deficiency (lack of the
middle-wavelength photopigment). See [`protanopic`](@ref) for detail about the arguments.
"""
function deuteranopic(q::T, p, neutral::LMS) where T <: Color
    q = convert(LMS, q)
    anchor_wavelen = q.s / q.l < neutral.s / neutral.l ? 575 : 475
    anchor = colormatch(anchor_wavelen)
    anchor = convert(LMS, anchor)
    (a, b, c) = brettel_abc(neutral, anchor)

    q = LMS(q.l,
            (one(p) - p) * q.m + p * (-(a*q.l + c*q.s)/b),
            q.s)
    convert(T, q)
end


"""
    tritanopic(c)
    tritanopic(c, p)

Convert a color to simulate tritanopic color deficiency (lack of the
short-wavelength photopigment). See [`protanopic`](@ref) for detail about
the arguments.
"""
function tritanopic(q::T, p, neutral::LMS) where T <: Color
    q = convert(LMS, q)
    anchor_wavelen = q.m / q.l < neutral.m / neutral.l ? 660 : 485
    anchor = colormatch(anchor_wavelen)
    anchor = convert(LMS, anchor)
    (a, b, c) = brettel_abc(neutral, anchor)

    q = LMS(q.l,
            q.m,
            (one(p) - p) * q.s + p * (-(a*q.l + b*q.m)/c))
    convert(T, q)
end


protanopic(c::Color, p)   = protanopic(c, p, default_brettel_neutral)
deuteranopic(c::Color, p) = deuteranopic(c, p, default_brettel_neutral)
tritanopic(c::Color, p)   = tritanopic(c, p, default_brettel_neutral)

protanopic(c::Color)   = protanopic(c, 1.0)
deuteranopic(c::Color) = deuteranopic(c, 1.0)
tritanopic(c::Color)   = tritanopic(c, 1.0)

# MSC - Most Saturated Colorant for given hue h
# ---------------------

const LUV_HUE_R = 12.17397852379156 # hue(convert(Luv, RGB(1.0, 0.0, 0.0)))
const LUV_HUE_Y = 85.87273351614108 # hue(convert(Luv, RGB(1.0, 1.0, 0.0)))
const LUV_HUE_G = 127.72355232980077 # hue(convert(Luv, RGB(0.0, 1.0, 0.0)))
const LUV_HUE_C = 192.17397852379156 # hue(convert(Luv, RGB(0.0, 1.0, 1.0)))
const LUV_HUE_B = 265.8727335161411 # hue(convert(Luv, RGB(0.0, 0.0, 1.0)))
const LUV_HUE_M = 307.7235523298008 # hue(convert(Luv, RGB(1.0, 0.0, 1.0)))
"""
    MSC(h)
    MSC(h, l; linear=false)

Calculate the most saturated color in sRGB gamut for any given hue `h` by
finding the corresponding corner in LCHuv space. Optionally, the lightness `l`
may also be specified.

# Arguments

- `h`: Hue [0,360] in LCHuv space
- `l`: Lightness [0,100] in LCHuv space

# Keyword arguments

- `linear` : If true, the saturation is linearly interpolated between black/
  white and `MSC(h)` as the gamut is approximately triangular in L-C section.

!!! note
    `MSC(h)` returns an `LCHuv` color, but `MSC(h, l)` returns a saturation
    value. This behavior might change in a future release.

"""
MSC(h) = MSC(Float64(h))
function MSC(h::Float64)

    #Wrap h to [0, 360] range
    h = normalize_hue(h)

    #Selecting edge of RGB cube; R=1 G=2 B=3
    # p #variable
    # o #min
    # t #max
    function pt(h)
        h < LUV_HUE_R && return (3, 1)
        h < LUV_HUE_Y && return (2, 1)
        h < LUV_HUE_G && return (1, 2)
        h < LUV_HUE_C && return (3, 2)
        h < LUV_HUE_B && return (2, 3)
        h < LUV_HUE_M && return (1, 3)
        return (3, 1)
    end
    p, t = pt(h)

    beta, alpha = polar_to_cartesian(1.0, -h)

    # un & vn are calculated based on reference white (D65)
    un, vn = xyz_to_uv(WP_DEFAULT)

    m_tx, m_ty, m_tz = @view M_RGB2XYZ[:, t]
    m_px, m_py, m_pz = @view M_RGB2XYZ[:, p]

    f1 = 4alpha*m_px+9beta*m_py
    a1 = 4alpha*m_tx+9beta*m_ty
    f2 = m_px+15m_py+3m_pz
    a2 = m_tx+15m_ty+3m_tz

    cp=((alpha*un+beta*vn)*a2-a1)/(f1-(alpha*un+beta*vn)*f2)
    cpc = clamp01(srgb_compand(cp))

    col = ntuple(i -> i == p ? cpc : Float64(i == t), Val(3))

    return convert(LCHuv{Float64}, RGB{Float64}(col...))
end


# Maximum saturation for given lightness and hue
# ----------------------

# Maximally saturated color for a specific hue and lightness
# is found by looking for the edge of LCHuv space.
function MSC(h, l; linear::Bool=false)
    if linear
        pmid = MSC(h)
        pend_l = l > pmid.l ? 100.0 : 0.0
        return (pend_l - l) / (pend_l - pmid.l) * pmid.c
    end
    return find_maximum_chroma(LCHuv{Float64}(l, 0.0, h))
end

# This function finds the maximum chroma for the lightness `c.l` and hue `c.h`
# by means of the binary search. Even though this requires more than 20
# iterations, somehow, this is fast.
function find_maximum_chroma(c::C) where {T, C<:LCHuv{T}}
    _find_maximum_chroma(c, convert(T, 0), convert(T, 180))
end
function _find_maximum_chroma(c::C, low::T, high::T) where {T, C<:Union{LCHab{T}, LCHuv{T}}}
    err = convert(T, 1e-6)
    l, h = low, high
    while true
        mid = convert(T, (l + h) * oftype(l, 0.5))
        @fastmath min(mid - l, h - mid) < err && break
        lchm = C(c.l, mid, c.h)
        rgbm = xyz_to_linear_rgb(convert(XYZ{T}, lchm))
        clamped = max(red(rgbm), green(rgbm), blue(rgbm)) > 1-err ||
                  min(red(rgbm), green(rgbm), blue(rgbm)) <= 0
        l = clamped ? l : mid
        h = clamped ? mid : h
    end
    return l
end

const LAB_HUE_Y = 102.85123437653252 # hue(convert(Lab, RGB(1.0, 1.0, 0.0)))

function find_maximum_chroma(c::C) where {T, C<:LCHab{T}}
    find_maximum_chroma(c, convert(T, 0), convert(T, 135))
end
function find_maximum_chroma(c::C, low::T, high::T) where {T, C<:LCHab{T}}
    maxc = _find_maximum_chroma(c, low, high)
    # The sRGB gamut in LCHab space has a *hollow* around the yellow corner.
    # Since the following boundary is based on the D65 white point, the values
    # should be modified on other conditions.
    if 97 < c.h < 108 && c.l > 92
        err = convert(T, 1e-6)
        len = 100000
        dh = convert(T, (100 - maxc) / len)
        chroma = maxc
        for i = 1:len
            chroma += dh
            rgb = xyz_to_linear_rgb(convert(XYZ, LCHab(c.l, chroma, c.h)))
            blue(rgb) < -err && continue
            y = c.h < LAB_HUE_Y ? red(rgb) : green(rgb)
            if y < 1+err
                maxc = chroma
            end
        end
    end
    return maxc
end
find_maximum_chroma(c::Lab) = find_maximum_chroma(convert(LCHab, c))
find_maximum_chroma(c::Luv) = find_maximum_chroma(convert(LCHuv, c))

using Colors

function compare_colors(color_a, color_b)
    # compare two colors, looking just at their LUV luminance values
    luv1 = convert(Luv, RGB(color_a[1]/255, color_a[2]/255, color_a[3]/255))
    luv2 = convert(Luv, RGB(color_b[1]/255, color_b[2]/255, color_b[3]/255))
    luv1.l > luv2.l
end

function draw_swatch(colorname, x, y, swatchwidth, swatchheight, color_values)
    r, g, b = color_values
    toplabel = """<text x="$(x)" y="$(y - 3)" fill="black" font-size="5px" font-family="Helvetica-Bold">$colorname</text>\n"""
    bottomlabel = """<text x="$(x)" y="$(y + swatchheight + 3)" font-size="3px" font-family="Helvetica">($r, $g, $b)</text>\n"""
    return  toplabel *
    bottomlabel *
    """<rect rx="2" ry="2" x="$(x)" y="$(y)" width="$(swatchwidth)" height="$(swatchheight)" fill="rgb($r, $g, $b)" /> \n """
end

function draw_synonym(colorname, x, y, swatchwidth, swatchheight)
    # add a synonym below the swatch
    return """<text x="$(x)" y="$(y + swatchheight + 3)" fill="black" font-size="3px" font-family="Helvetica-Bold">$colorname</text>\n"""
end

function make_color_table(image_width, image_height, output_file)
    # prepare synonym lists
    synonyms = Dict{Tuple, Array}()
    for color in Colors.color_names
        col_name  = color[1]
        col_value = color[2]
        if haskey(synonyms, col_value)
            push!(synonyms[col_value], col_name)
        else
            synonyms[col_value] = [col_name]
        end
    end

    # calculate sizes of swatches
    aspect = image_width/image_height
    if aspect > 1
        n_rows = ceil(sqrt(length(synonyms)/aspect))
    else
        n_rows = ceil(sqrt(length(synonyms) * aspect))
    end
    n_cols = ceil(length(synonyms)/n_rows)

    margin = 30
    row_space = 25
    col_space = 15

    swatchwidth  = ((image_width  - margin - margin - (col_space * n_cols )) / n_cols)
    swatchheight = ((image_height - margin - margin - (row_space * n_rows )) / n_rows)

    # send output to file
    f = open(output_file, "w")

    # write svg header
    println(f, """<svg xmlns="http://www.w3.org/2000/svg" version="1.1" width="$(image_width)" height="$(image_height)"> \n
    <rect x="0" y="0" width="$(image_width)" height="$(image_height)" fill="white" /> \n """)

    # title
    println(f, """<text x="$(margin)" y="$(margin - margin/2)" font-size="14px" font-family="Helvetica-Bold">Color names in Colors.jl, sorted by luminance</text>\n""")

    # x and y track position
    x = margin
    y = margin

    for color_values in sort(collect(keys(synonyms)), lt = (x,y) -> compare_colors(x,y))
        color_synonyms = sort(synonyms[color_values])
        print(f, draw_swatch(color_synonyms[1], x, y, swatchwidth, swatchheight, color_values))
        oldy = y # save the current position during excursion
        for synonym in color_synonyms[2:end]
            # draw the other names for this color
            y += 3
            print(f, draw_synonym(string("also: " * synonym), x, y, swatchwidth, swatchheight))
        end
        y = oldy
        if x > (image_width - swatchwidth - margin - margin)
            x = margin # next row
            y += swatchheight + row_space # gap between rows
        else
            x += swatchwidth + col_space  # gap between columns
        end
    end
    println(f, "</svg>")
    close(f)
end


make_color_table(1400, 1400, "/tmp/color_names_sorted.svg")

# Conversions
# -----------

#=
`convert(C, c)` might be called as `convert(RGB, c)` or
`convert(RGB{Float32}, c)`.
This is handled in ColorTypes, which calls functions
```
    _convert(::Type{Cdest}, ::Type{Odest}, ::Type{Osrc}, c)
    _convert(::Type{Cdest}, ::Type{Odest}, ::Type{Osrc}, c, alpha)
```
Here are the argument types:
- `Cdest` may be any concrete `Colorant{T,N}` type. For parametric Color types
  it _always_ has the desired element type (e.g., `Float32`), so it's safe to
  dispatch on `Cdest <: Colorant{T}`.
- `Odest` and `Osrc` are opaque `Color` subtypes, i.e., things like `RGB` or
  `HSV`. They have no element type.
- `c` is the `Colorant` object you wish to convert.
- `alpha`, if present, is a user-supplied alpha value (to be used in place of
  any default alpha or alpha present in `c`).

The original motivation for this arrangement was that Julia "did not" support
"triangular dispatch", e.g.,
```
    convert(::Type{C{T}}, c) where {C, T}
```
On Julia v0.6 or later, parameter constraints can refer to previous parameters.
Therefore, we can use:
```
    convert(::Type{C}, c) where {T, C <: Colorant{T}}
```
However, the example above does not match `convert(RGB, c)`. Also, we should
catch all the various alpha variants (e.g. `ARGB`/`RGBA` with/without element
type).
The various arguments of `_convert` "peel off" element types (or guarantee them)
so that comparisons may be made via dispatch. Therefore, this arrangement is
still helpful.

Note that ColorTypes handles the cases where `Odest == Osrc`, or they are both
subtypes of `AbstractRGB` or `AbstractGray`. Therefore, here we only have to
deal with conversions between different spaces.
=#

function ColorTypes._convert(::Type{Cdest}, ::Type{Odest}, ::Type{Osrc}, p, alpha=alpha(p)) where {Cdest<:TransparentColor,Odest,Osrc}
    # Convert the base color
    c = cnvt(color_type(Cdest), color(p))
    # Append the alpha
    ColorTypes._convert(Cdest, Odest, Odest, c, alpha)
end

ColorTypes._convert(::Type{Cdest}, ::Type{Odest}, ::Type{Osrc}, c) where {Cdest<:Color,Odest,Osrc} = cnvt(Cdest, c)

# with the whitepoint `wp` as the third argument
convert(::Type{XYZ}, c, wp::XYZ) = cnvt(XYZ{eltype(wp)}, c, wp)
convert(::Type{Lab}, c, wp::XYZ) = cnvt(Lab{eltype(wp)}, c, wp)
convert(::Type{Luv}, c, wp::XYZ) = cnvt(Luv{eltype(wp)}, c, wp)

convert(::Type{XYZ{T}}, c, wp::XYZ) where {T} = cnvt(XYZ{T}, c, wp)
convert(::Type{Lab{T}}, c, wp::XYZ) where {T} = cnvt(Lab{T}, c, wp)
convert(::Type{Luv{T}}, c, wp::XYZ) where {T} = cnvt(Luv{T}, c, wp)

# FIXME: inference helpers for LCH <--> RGB conversions
convert(::Type{RGB},    c::Union{LCHab{T}, LCHuv{T}, Oklch{T}}) where {T} = cnvt(RGB{T}, cnvt(XYZ{T}, c))
convert(::Type{RGB{T}}, c::Union{LCHab{T}, LCHuv{T}, Oklch{T}}) where {T} = cnvt(RGB{T}, cnvt(XYZ{T}, c))
convert(::Type{Lab{T}}, c::RGB{T}) where {T} = cnvt(Lab{T}, cnvt(XYZ{T}, c))
convert(::Type{Luv{T}}, c::RGB{T}) where {T} = cnvt(Luv{T}, cnvt(XYZ{T}, c))
convert(::Type{Oklab{T}}, c::RGB{T}) where {T} = cnvt(Oklab{T}, cnvt(XYZ{T}, c))

# Fallback to catch undefined operations
cnvt(::Type{C}, c::TransparentColor) where {C<:Color} = cnvt(C, color(c))
cnvt(::Type{C}, c) where {C} = convert(C, convert(RGB{eltype(C)}, c)::RGB{eltype(C)})

# Conversions from grayscale
# --------------------------
function ColorTypes._convert(::Type{Cdest}, ::Type{O}, ::Type{O}, g) where {Cdest<:Color,O<:AbstractGray}
    cnvt(Cdest, g)
end
function ColorTypes._convert(::Type{Cdest}, ::Type{Odest}, ::Type{Osrc}, g) where {Cdest<:Color,Odest,Osrc<:AbstractGray}
    cnvt(Cdest, convert(RGB{eltype(Cdest)}, g))
end

# Everything to RGB
# -----------------

correct_gamut(c::CV) where {CV<:AbstractRGB} = CV(clamp01(red(c)), clamp01(green(c)), clamp01(blue(c)))
correct_gamut(c::CV) where {T<:Union{N0f8,N0f16,N0f32,N0f64},
                            CV<:Union{AbstractRGB{T},TransparentRGB{T}}} = c
correct_gamut(c::CV) where {CV<:TransparentRGB} =
    CV(clamp01(red(c)), clamp01(green(c)), clamp01(blue(c)), clamp01(alpha(c))) # for `hex`

@inline function srgb_compand(v::T) where T
    F = typeof(0.5f0v) === Float32 ? Float32 : promote_type(Float64, T)
    vf = F(v)
    vc = @fastmath max(vf, F(0.0031308))
    # `pow5_12` is an optimized function to get `v^(1/2.4)`
    vf > F(0.0031308) ? muladd(F(1.055), F(pow5_12(vc)), F(-0.055)) : F(12.92) * vf
end

function _hsx_to_rgb(im::UInt8, v, n, m)
    #=
    if     hue <  60; im = 0b000001 # ---------+
    elseif hue < 120; im = 0b000010 # --------+|
    elseif hue < 180; im = 0b000100 # -------+||
    elseif hue < 240; im = 0b001000 # ------+|||
    elseif hue < 300; im = 0b010000 # -----+||||
    else            ; im = 0b100000 # ----+|||||
    end                             #     ||||||
    (hue < 60 || hue >= 300) === ((im & 0b100001) != 0x0)
    =#
    r = ifelse((im & 0b100001) == 0x0, ifelse((im & 0b010010) == 0x0, m, n), v)
    g = ifelse((im & 0b000110) == 0x0, ifelse((im & 0b001001) == 0x0, m, n), v)
    b = ifelse((im & 0b011000) == 0x0, ifelse((im & 0b100100) == 0x0, m, n), v)
    return (r, g, b)
end
function _hsx_to_rgb(im::UInt8, v::T, n::T, m::T) where T <:Union{Float16, Float32, Float64}
    vu, nu, mu = reinterpret.(Unsigned, (v, n, m)) # prompt the compiler to use conditional moves
    r = ifelse((im & 0b100001) == 0x0, ifelse((im & 0b010010) == 0x0, mu, nu), vu)
    g = ifelse((im & 0b000110) == 0x0, ifelse((im & 0b001001) == 0x0, mu, nu), vu)
    b = ifelse((im & 0b011000) == 0x0, ifelse((im & 0b100100) == 0x0, mu, nu), vu)
    return reinterpret.(T, (r, g, b))
end

function cnvt(::Type{CV}, c::HSV) where {T, CV<:AbstractRGB{T}}
    F = promote_type(T, eltype(c))
    h, s, v = div60(F(c.h)), clamp01(F(c.s)), clamp01(F(c.v))
    hi = unsafe_trunc(Int32, h) # instead of floor
    i = h < 0 ? hi - one(hi) : hi
    f = i & one(i) == zero(i) ? 1 - (h - i) : h - i
    im = 0x1 << (mod6(UInt8, i) & 0x07)
    # use `@fastmath` just to reduce the estimated costs for inlining
    @fastmath m = v * (1 - s)
    @fastmath n = v * (1 - s * f)

    r, g, b = _hsx_to_rgb(im, v, n, m)
    T <: FixedPoint && typemax(T) >= 1 ? CV(r % T, g % T, b % T) : CV(r, g, b)
end

function cnvt(::Type{CV}, c::HSL) where {T, CV<:AbstractRGB{T}}
    F = promote_type(T, eltype(c))
    h, s, l = div60(F(c.h)), clamp01(F(c.s)), clamp01(F(c.l))
    a = @fastmath min(l, 1 - l) * s
    v = l + a
    hi = unsafe_trunc(Int32, h) # instead of floor
    i = h < 0 ? hi - one(hi) : hi
    f = i & one(i) == zero(i) ? 1 - (h - i) : h - i
    im = 0x1 << (mod6(UInt8, i) & 0x07)
    # use `@fastmath` just to reduce the estimated costs for inlining
    @fastmath m = l - a # v - 2 * a
    @fastmath n = v - 2 * a * f

    r, g, b = _hsx_to_rgb(im, v, n, m)
    T <: FixedPoint && typemax(T) >= 1 ? CV(r % T, g % T, b % T) : CV(r, g, b)
end

function cnvt(::Type{CV}, c::HSI) where {T, CV<:AbstractRGB{T}}
    F = promote_type(T, eltype(c))
    h, s, i = deg2rad(normalize_hue(F(c.h))), clamp01(F(c.s)), clamp01(F(c.i))
    is = i * s
    if h < F(2π/3)
        @fastmath cosr = cos(h) / cos(F(π/3)-h)
        r0, g0, b0 = muladd(is, cosr, i), muladd(is, 1-cosr, i), i - is
    elseif h < F(4π/3)
        @fastmath cosr = cos(h-F(2π/3)) / cos(F(π)-h)
        r0, g0, b0 = i - is, muladd(is, cosr, i), muladd(is, 1-cosr, i)
    else
        @fastmath cosr = cos(h-F(4π/3)) / cos(F(5π/3)-h)
        r0, g0, b0 = muladd(is, 1-cosr, i), i - is, muladd(is, cosr, i)
    end
    r, g, b = min(r0, oneunit(F)), min(g0, oneunit(F)), min(b0, oneunit(F))
    T <: FixedPoint && typemax(T) >= 1 ? CV(r % T, g % T, b % T) : CV(r, g, b)
end

# the following matrix is based on the sRGB color primaries in `xy` and D65 whitepoint in `XYZ`
const M_XYZ2RGB = Mat3x3([ 3.2404541621141054   -1.5371385127977166   -0.4985314095560162
                          -0.9692660305051868    1.8760108454466942    0.04155601753034984
                           0.05564343095911469  -0.20402591351675387   1.0572251882231791 ])
function xyz_to_linear_rgb(c::XYZ{T}) where T
    @mul3x3 RGB M_XYZ2RGB c.x c.y c.z
end
function cnvt(::Type{CV}, c::XYZ) where CV<:AbstractRGB
    rgb = xyz_to_linear_rgb(c)
    CV(clamp01(srgb_compand(rgb.r)),
       clamp01(srgb_compand(rgb.g)),
       clamp01(srgb_compand(rgb.b)))
end

const M_YIQ2RGB = Mat3x3([1.0   0.9563   0.621
                          1.0  -0.2721  -0.6474
                          1.0  -1.107    1.7046 ])
function cnvt(::Type{CV}, c::YIQ) where CV<:AbstractRGB
    cc = correct_gamut(c)
    rgb = @mul3x3 RGB M_YIQ2RGB cc.y cc.i cc.q
    CV(clamp01(rgb.r), clamp01(rgb.g), clamp01(rgb.b))
end

# FIXME
function cnvt(::Type{CV}, c::YCbCr) where CV<:AbstractRGB
    cc = correct_gamut(c)
    ny = cc.y - 16
    ncb = cc.cb - 128
    ncr = cc.cr - 128
    CV(clamp01(0.004567ny - 1.39135e-7ncb + 0.0062586ncr),
       clamp01(0.004567ny - 0.00153646ncb - 0.0031884ncr),
       clamp01(0.004567ny + 0.00791058ncb - 2.79201e-7ncr))
end

# To avoid stack overflow, the source types which do not support direct or
# indirect conversion to RGB should be rejected.
cnvt(::Type{CV}, c::Union{LMS, xyY}) where {CV<:AbstractRGB} = cnvt(CV, cnvt(XYZ{eltype(c)}, c))
cnvt(::Type{CV}, c::Union{Lab, Luv, Oklab, LCHab, LCHuv, Oklch}) where {CV<:AbstractRGB} = cnvt(CV, cnvt(XYZ{eltype(c)}, c))
cnvt(::Type{CV}, c::Union{DIN99d, DIN99o, DIN99}) where {CV<:AbstractRGB} = cnvt(CV, cnvt(XYZ{eltype(c)}, c))
@noinline function cnvt(::Type{CV}, @nospecialize(c::Color)) where {CV<:AbstractRGB}
    error("No conversion of ", c, " to ", CV, " has been defined")
end

# AbstractGray --> AbstractRGB conversions are implemented in ColorTypes.jl


# Everything to HSV
# -----------------

function cnvt(::Type{HSV{T}}, c::AbstractRGB) where T
    F = promote_type(T, eltype(c))
    r, g, b = F.((red(c), green(c), blue(c)))
    c_min = @fastmath min(min(r, g), b)
    c_max = @fastmath max(max(r, g), b)
    s0 = c_max - c_min
    s0 == zero(F) && return HSV{T}(zero(T), zero(T), T(c_max))
    s = @fastmath s0 / c_max

    # In general, it is dangerous to compare floating point numbers with `===`.
    diff = ifelse(c_max === r,  g - b,         ifelse(c_max === g,  b - r,  r - g))
    ofs  = ifelse(c_max === r, (g < b)*F(360), ifelse(c_max === g, F(120), F(240)))
    h0 = @fastmath diff * F(60) / s0

    HSV{T}(h0 + ofs, s, c_max)
end


cnvt(::Type{HSV{T}}, c::Color) where {T} = cnvt(HSV{T}, convert(RGB{T}, c)::RGB{T})


# Everything to HSL
# -----------------

function cnvt(::Type{HSL{T}}, c::AbstractRGB) where T
    F = promote_type(T, eltype(c))
    r, g, b = F(red(c)), F(green(c)), F(blue(c))
    c_min = @fastmath min(min(r, g), b)
    c_max = @fastmath max(max(r, g), b)
    l0 = c_max + c_min
    s0 = c_max - c_min
    l = l0 * F(0.5)
    s0 == zero(F) && return HSL{T}(zero(T), zero(T), T(l))
    s = @fastmath s0 / min(l0, F(2) - l0)

    # In general, it is dangerous to compare floating point numbers with `===`.
    diff = ifelse(c_max === r,  g - b,         ifelse(c_max === g,  b - r,  r - g))
    ofs  = ifelse(c_max === r, (g < b)*F(360), ifelse(c_max === g, F(120), F(240)))
    h0 = @fastmath diff * F(60) / s0

    HSL{T}(h0 + ofs, s, l)
end


cnvt(::Type{HSL{T}}, c::Color) where {T} = cnvt(HSL{T}, convert(RGB{T}, c)::RGB{T})


# Everything to HSI
# -----------------

# Since acosd() is slow, the following is "inline-worthy".
@inline function cnvt(::Type{HSI{T}}, c::AbstractRGB) where T
    rgb = correct_gamut(c)
    F = promote_type(T, eltype(c))
    r, g, b = F(red(rgb)), F(green(rgb)), F(blue(rgb))
    dnorm = @fastmath sqrt(((r-g)^2 + (r-b)^2 + (g-b)^2) * F(0.5))
    isum = r + g + b
    i = isum / F(3)
    dnorm == zero(F) && return HSI{T}(T(90), zero(T), T(i))
    val = muladd(g + b, F(-0.5), r) / dnorm
    h = @fastmath acosd(clamp(val, -oneunit(F), oneunit(F)))
    m = @fastmath min(min(r, g), b)
    s = oneunit(F) - m/i
    HSI{T}(b > g ? F(360) - h : h, s, i)
end

cnvt(::Type{HSI{T}}, c::Color) where {T} = cnvt(HSI{T}, convert(RGB{T}, c)::RGB{T})

# Everything to XYZ
# -----------------

@inline function invert_srgb_compand(v::T) where T
    F = typeof(0.5f0v) === Float32 ? Float32 : promote_type(Float64, T)
    vf = F(v)
    # `pow12_5` is an optimized function to get `x^2.4`
    vf > F(0.04045) ? pow12_5(muladd(F(1000/1055), vf, F(55/1055))) : F(100/1292) * vf
end

# lookup table for `N0f8` (the extra two elements are for `Float32` splines)
const invert_srgb_compand_n0f8 = Float32[invert_srgb_compand(v/255.0) for v = 0:257]

function invert_srgb_compand(v::N0f8)
    @inbounds invert_srgb_compand_n0f8[reinterpret(v) + 1]
end

function invert_srgb_compand(v::Float32)
    i = unsafe_trunc(Int32, v * 255)
    (i < 13 || i > 255) && return Float32(invert_srgb_compand(Float64(v)))
    @inbounds y = view(invert_srgb_compand_n0f8, i:i+3)
    dv = v * 255.0f0 - i
    dv == 0.0f0 && @inbounds return y[2]
    if v < 0.38857287f0
        return @fastmath(y[2]+0.5f0*dv*((-2/3f0*y[1]- y[2])+(2y[3]-1/3f0*y[4])+
                                    dv*((       y[1]-2y[2])+  y[3]-
                                    dv*(( 1/3f0*y[1]- y[2])+( y[3]-1/3f0*y[4]) ))))
    else
        return @fastmath(y[2]+0.5f0*dv*((4y[3]-3y[2])-y[4]+dv*((y[4]-y[3])+(y[2]-y[3]))))
    end
end

# the following matrix is based on the sRGB color primaries in `xy` and D65 whitepoint in `XYZ`
const M_RGB2XYZ = Mat3x3([0.4124564390896921    0.357576077643909  0.18043748326639894
                          0.21267285140562248   0.715152155287818  0.07217499330655958
                          0.019333895582329317  0.119192025881303  0.9503040785363677 ])

function linear_rgb_to_xyz(c::AbstractRGB{T}) where T
    @mul3x3 XYZ M_RGB2XYZ red(c) green(c) blue(c)
end
function cnvt(::Type{XYZ{T}}, c::AbstractRGB) where T
    r = invert_srgb_compand(red(c))
    g = invert_srgb_compand(green(c))
    b = invert_srgb_compand(blue(c))
    @mul3x3 XYZ{T} M_RGB2XYZ r g b
end


function cnvt(::Type{XYZ{T}}, c::xyY) where T
    X = c.Y*c.x/c.y
    Z = c.Y*(1-c.x-c.y)/c.y
    XYZ{T}(X, c.Y, Z)
end


const xyz_epsilon   = 216 / 24389 # (6/29)^3
const xyz_kappa     = 24389 / 27  # (29/6)^3*8
const xyz_kappa_inv = 27 / 24389

function lab2xyz(::Type{XYZ{T}}, c) where T
    F = promote_type(T, eltype(c))

    fy1 = c.l * F(0x1p-7)
    fy2 = muladd(c.l, F(3 / 3712), F(16 / 116))
    fy = fy1 + fy2 # (c.l + 16) / 116
    fx = fy1 + muladd(c.a, F( 0x1p-9), muladd(c.a, F(3 / 64000), fy2)) # fy + c.a / 500
    fz = fy1 + muladd(c.b, F(-0x1p-8), muladd(c.b, F(-7 / 6400), fy2)) # fy - c.b / 200

    fx3 = fx^3
    fy3 = fy^3
    fz3 = fz^3

    epsilon = oftype(fx3, xyz_epsilon)
    kappa_inv = oftype(fx3, xyz_kappa_inv)

    x = fx3 > epsilon ? fx3 : muladd(116, fx, -16) * kappa_inv
    y = fy3 > epsilon ? fy3 : c.l * kappa_inv
    z = fz3 > epsilon ? fz3 : muladd(116, fz, -16) * kappa_inv
    return XYZ{T}(x, y, z)
end

function cnvt(::Type{XYZ{T}}, c::Lab) where T
    xyz = lab2xyz(XYZ{T}, c)
    XYZ{T}(xyz.x * T(WP_DEFAULT.x), xyz.y * T(WP_DEFAULT.y), xyz.z * T(WP_DEFAULT.z))
end
function cnvt(::Type{XYZ{T}}, c::Lab, wp::XYZ) where T
    xyz = lab2xyz(XYZ{T}, c)
    XYZ{T}(xyz.x * T(wp.x), xyz.y * T(wp.y), xyz.z * T(wp.z))
end


function xyz_to_uv(c::XYZ)
    F = typeof(4c.x / oneunit(c.x))
    d = c.x + 15c.y + 3c.z
    d == zero(d) && return (zero(F), zero(F))
    return (4c.x, 9c.y) ./ d # (u, v)
end

@inline function luv2xyz(::Type{XYZ{T}}, c, y_wp::F, uv_wp::Tuple{F, F}) where {T, F}
    c.l == zero(c.l) && return XYZ{T}(zero(T), zero(T), zero(T))
    ls = c.l * F(xyz_kappa_inv)
    clc = @fastmath max(F(c.l), F(8))
    lc = muladd(clc, F(0x1p-7), muladd(clc, F(3 / 3712), F(16 / 116)))^3 # (c.l + 16) / 116)^3
    y = y_wp * ifelse(c.l > 8, lc, ls)
    u, v = (c.u, c.v) ./ (13c.l) .+ uv_wp
    ys = F(0.25) * y / v
    x = ys * 9u
    z = ys * (12 - 3u - 20v)
    XYZ{T}(x, y, z)
end
function cnvt(::Type{XYZ{T}}, c::Luv) where T
    F = promote_type(T, eltype(c))
    luv2xyz(XYZ{T}, c, F(WP_DEFAULT.y), F.(xyz_to_uv(WP_DEFAULT)))
end
function cnvt(::Type{XYZ{T}}, c::Luv, wp::XYZ) where T
    F = promote_type(T, eltype(c))
    luv2xyz(XYZ{T}, c, F(wp.y), F.(xyz_to_uv(wp)))
end

function cnvt(::Type{XYZ{T}}, c::DIN99d) where T

    # Go back to C-h space
    C = chroma(c)
    h = atan(c.b, c.a) - 50π/180

    # Intermediate terms
    G = (exp(C/22.5)-1)/0.06
    f, ee = G .* sincos(h)

    l = (exp(c.l/325.221)-1)/0.0036
    # a = ee*cosd(50) - f/1.14*sind(50)
    a = ee*0.6427876096865394 - f/1.14*0.766044443118978
    # b = ee*sind(50) - f/1.14*cosd(50)
    b = ee*0.766044443118978 + f/1.14*0.6427876096865394

    adj = convert(XYZ, Lab(l, a, b))

    XYZ{T}((adj.x + 0.12*adj.z)/1.12, adj.y, adj.z)
end


function cnvt(::Type{XYZ{T}}, c::LMS) where T
    @mul3x3 XYZ{T} CAT02_INV c.l c.m c.s
end


function cnvt(::Type{XYZ{T}}, c::Oklab) where T
    lmsp = @mul3x3 LMS{T} M_OKLMSP2OKLAB_INV c.l c.a c.b
    @mul3x3 XYZ{T} M_XYZ2OKLMS_INV lmsp.l^3 lmsp.m^3 lmsp.s^3
end

cnvt(::Type{XYZ{T}}, c::Oklch) where {T} = cnvt(XYZ{T}, cnvt(Oklab{T}, c))

cnvt(::Type{XYZ{T}}, c::Union{LCHab, DIN99, DIN99o}) where {T} = cnvt(XYZ{T}, cnvt(Lab{T}, c))
cnvt(::Type{XYZ{T}}, c::LCHuv) where {T} = cnvt(XYZ{T}, cnvt(Luv{T}, c))
cnvt(::Type{XYZ{T}}, c::Color) where {T} = cnvt(XYZ{T}, convert(RGB{T}, c)::RGB{T})

# Everything to xyY
# -----------------

function cnvt(::Type{xyY{T}}, c::XYZ) where T

    x = c.x/(c.x + c.y + c.z)
    y = c.y/(c.x + c.y + c.z)

    xyY{T}(x, y, oftype(x, c.y))
end

cnvt(::Type{xyY{T}}, c::Color) where {T} = cnvt(xyY{T}, convert(XYZ{T}, c)::XYZ{T})



# Everything to Lab
# -----------------

@inline function fxyz2lab(v)
    ka = oftype(v, 841 / 108) # (29/6)^2 / 3 = xyz_kappa / 116
    kb = oftype(v, 16 / 116) # 4/29
    vc = @fastmath max(v, oftype(v, xyz_epsilon))
    @fastmath min(cbrt01(vc), muladd(ka, v, kb))
end
@inline function xyz2lab(::Type{Lab{T}}, c::XYZ) where T
    f = XYZ(fxyz2lab(c.x), fxyz2lab(c.y), fxyz2lab(c.z)) # mapc(fxyz2lab, c)
    Lab{T}(116f.y - 16, 500(f.x - f.y), 200(f.y - f.z))
end
function cnvt(::Type{Lab{T}}, c::XYZ) where T
    wp = WP_DEFAULT
    F = promote_type(T, eltype(c))
    xyz2lab(Lab{T}, XYZ(c.x * F(1 / wp.x), c.y * F(1 / wp.y), c.z * F(1 / wp.z)))
end
function cnvt(::Type{Lab{T}}, c::XYZ, wp::XYZ) where T
    F = promote_type(T, eltype(c))
    xyz2lab(Lab{T}, XYZ(c.x / F(wp.x), c.y / F(wp.y), c.z / F(wp.z)))
end


function cnvt(::Type{Lab{T}}, c::LCHab) where T
    Lab{T}(c.l, polar_to_cartesian(c.c, c.h)...)
end


function cnvt(::Type{Lab{T}}, c::DIN99) where T

    # We assume the adjustment parameters are always 1; the standard recommends
    # that they not be changed from these values.
    kch = 1
    ke = 1

    # Calculate Chroma (C99) in the DIN99 space
    cc = chroma(c)

    # Temporary variable for chroma
    g = (exp(0.045*cc*kch*ke)-1)/0.045

    # Temporary redness
    ee = cc > 0 ? g * c.a / cc : zero(g)

    # Temporary yellowness
    f = cc > 0 ? g * c.b / cc : zero(g)

    # CIELAB a*b*
    # ciea = ee*cosd(16) - (f/0.7)*sind(16)
    ciea = ee*0.9612616959383189 - (f/0.7)*0.27563735581699916
    # cieb = ee*sind(16) + (f/0.7)*cosd(16)
    cieb = ee*0.27563735581699916 + (f/0.7)*0.9612616959383189

    # CIELAB L*
    ciel = (exp(c.l*ke/105.51)-1)/0.0158

    Lab{T}(ciel, ciea, cieb)
end


function cnvt(::Type{Lab{T}}, c::DIN99o) where T

    # We assume the adjustment parameters are always 1; the standard recommends
    # that they not be changed from these values.
    kch = 1
    ke = 1

    # Calculate Chroma (C99) in the DIN99o space
    co = chroma(c)

    # hue angle h99o
    h = atan(c.b, c.a) - 26π/180

    # revert logarithmic chroma compression
    g = (exp(co*kch*ke/23.0)-1)/0.075

    # Temporary yellowness and redness
    fo, eo = g .* sincos(h)

    # CIELAB a*b* (revert b* axis compression)
    # ciea = eo*cosd(26) - (fo/0.83)*sind(26)
    ciea = eo*0.898794046299167 - (fo/0.83)*0.4383711467890774
    # cieb = eo*sind(26) + (fo/0.83)*cosd(26)
    cieb = eo*0.4383711467890774 + (fo/0.83)*0.898794046299167

    # CIELAB L* (revert logarithmic lightness compression)
    ciel = (exp(c.l*ke/303.67)-1)/0.0039

    Lab{T}(ciel, ciea, cieb)
end


cnvt(::Type{Lab{T}}, c::Color) where {T} = cnvt(Lab{T}, convert(XYZ{T}, c)::XYZ{T})


# Everything to Luv
# -----------------
@inline function xyz2luv(::Type{Luv{T}}, c::XYZ, y::F, uv_wp::Tuple{F, F}) where {T, F}
    yc = @fastmath max(y, F(xyz_epsilon))
    l = @fastmath min(muladd(116, cbrt01(yc), -16), F(xyz_kappa) * y)
    uv = (13 * l) .* (xyz_to_uv(c) .- uv_wp)
    Luv{T}(l, uv...)
end

function cnvt(::Type{Luv{T}}, c::XYZ) where T
    F = promote_type(T, eltype(c))
    y = c.y * F(1 / WP_DEFAULT.y)
    xyz2luv(Luv{T}, c, F(y), F.(xyz_to_uv(WP_DEFAULT)))
end
function cnvt(::Type{Luv{T}}, c::XYZ, wp::XYZ) where T
    F = promote_type(T, eltype(c))
    y = c.y / F(wp.y)
    xyz2luv(Luv{T}, c, F(y), F.(xyz_to_uv(wp)))
end


function cnvt(::Type{Luv{T}}, c::LCHuv) where T
    Luv{T}(c.l, polar_to_cartesian(c.c, c.h)...)
end

cnvt(::Type{Luv{T}}, c::Color) where {T} = cnvt(Luv{T}, convert(XYZ{T}, c)::XYZ{T})


# Everything to LCHuv
# -------------------

function cnvt(::Type{LCHuv{T}}, c::Luv) where T
    LCHuv{T}(c.l, chroma(c), hue(c))
end


cnvt(::Type{LCHuv{T}}, c::Color) where {T} = cnvt(LCHuv{T}, convert(Luv{T}, c)::Luv{T})


# Everything to LCHab
# -------------------

function cnvt(::Type{LCHab{T}}, c::Lab) where T
    LCHab{T}(c.l, chroma(c), hue(c))
end


cnvt(::Type{LCHab{T}}, c::Color) where {T} = cnvt(LCHab{T}, convert(Lab{T}, c)::Lab{T})


# Everything to Oklab
# -------------------

# Matrices as specified in https://bottosson.github.io/posts/oklab/
const M_XYZ2OKLMS = Mat3x3([0.8189330101 0.3618667424 -0.1288597137
                            0.0329845436 0.9293118715  0.0361456387
                            0.0482003018 0.2643662691  0.6338517070])

const M_XYZ2OKLMS_INV = Mat3x3(inv(Float64.(M_XYZ2OKLMS)))

const M_OKLMSP2OKLAB = Mat3x3([0.2104542553  0.7936177850 -0.0040720468
                               1.9779984951 -2.4285922050  0.4505937099
                               0.0259040371  0.7827717662 -0.8086757660])

const M_OKLMSP2OKLAB_INV = Mat3x3(inv(Float64.(M_OKLMSP2OKLAB)))

function cnvt(::Type{Oklab{T}}, c::XYZ) where T
    lms = @mul3x3 LMS{T} M_XYZ2OKLMS c.x c.y c.z
    @mul3x3 Oklab{T} M_OKLMSP2OKLAB cbrt(lms.l) cbrt(lms.m) cbrt(lms.s)
end

function cnvt(::Type{Oklab{T}}, c::Oklch) where T
    Oklab{T}(c.l, polar_to_cartesian(c.c, c.h)...)
end

cnvt(::Type{Oklab{T}}, c::Color) where {T} = cnvt(Oklab{T}, convert(XYZ{T}, c)::XYZ{T})


# Everything to Oklch
# -------------------

function cnvt(::Type{Oklch{T}}, c::Oklab) where T
    Oklch{T}(c.l, chroma(c), hue(c))
end

cnvt(::Type{Oklch{T}}, c::Color) where {T} = cnvt(Oklch{T}, convert(Oklab{T}, c)::Oklab{T})


# Everything to DIN99
# -------------------

function cnvt(::Type{DIN99{T}}, c::Lab) where T

    # We assume the adjustment parameters are always 1; the standard recommends
    # that they not be changed from these values.
    kch = 1
    ke = 1

    # Calculate DIN99 L
    l99 = (1/ke)*105.51*log(1+0.0158*c.l)

    # Temporary value for redness and yellowness
    # ee = c.a*cosd(16) + c.b*sind(16)
    ee = c.a*0.9612616959383189 + c.b*0.27563735581699916
    # f = -0.7*c.a*sind(16) + 0.7*c.b*cosd(16)
    f = -0.7*c.a*0.27563735581699916 + 0.7*c.b*0.9612616959383189

    # Temporary value for chroma
    g = sqrt(ee^2 + f^2)

    # DIN99 chroma
    cc = log(1+0.045*g)/(0.045*kch*ke)

    # DIN99 chromaticities
    a99 = g > 0 ? convert(T, cc / g * ee) : zero(T)
    b99 = g > 0 ? convert(T, cc / g * f ) : zero(T)

    DIN99{T}(l99, a99, b99)

end


cnvt(::Type{DIN99{T}}, c::Color) where {T} = cnvt(DIN99{T}, convert(Lab{T}, c)::Lab{T})


# Everything to DIN99d
# --------------------

function cnvt(::Type{DIN99d{T}}, c::XYZ{T}) where T

    # Apply tristimulus-space correction term
    adj_c = XYZ(1.12*c.x - 0.12*c.z, c.y, c.z)

    # Apply L*a*b*-space correction
    lab = convert(Lab, adj_c)
    adj_L = 325.221*log(1+0.0036*lab.l)

    # Calculate intermediate parameters
    # ee = lab.a*cosd(50) + lab.b*sind(50)
    ee = lab.a*0.6427876096865394 + lab.b*0.766044443118978
    # f = 1.14*(lab.b*cosd(50) - lab.a*sind(50))
    f = 1.14*(lab.b*0.6427876096865394 - lab.a*0.766044443118978)
    G = sqrt(ee^2+f^2)

    # Calculate hue/chroma
    C = 22.5*log(1+0.06*G)
    h = atan(f, ee) + 50π/180

    b99, a99 = C .* sincos(h)

    DIN99d{T}(adj_L, a99, b99)

end


cnvt(::Type{DIN99d{T}}, c::Color) where {T} = cnvt(DIN99d{T}, convert(XYZ{T}, c)::XYZ{T})


# Everything to DIN99o
# -------------------

function cnvt(::Type{DIN99o{T}}, c::Lab) where T

    # We assume the adjustment parameters are always 1; the standard recommends
    # that they not be changed from these values.
    kch = 1
    ke = 1

    # Calculate DIN99o L (logarithmic compression)
    l99 = 303.67/ke*log(1+0.0039*c.l)

    # Temporary value for redness and yellowness
    # including rotation by 26°
    # eo = c.a*cosd(26) + c.b*sind(26)
    eo = c.a*0.898794046299167 + c.b*0.4383711467890774
    # compression along the yellowness (blue-yellow) axis
    # fo = 0.83 * (c.b*cosd(26) - c.a*sind(26))
    fo = 0.83 * (c.b*0.898794046299167 - c.a*0.4383711467890774)

    # Temporary value for chroma
    go = sqrt(eo^2 + fo^2)
    h = atan(fo, eo) + 26π/180

    # DIN99o chroma (logarithmic compression)
    cc = 23.0*log(1+0.075*go)/(kch*ke)

    # DIN99o chromaticities
    b99, a99 = cc .* sincos(h)

    DIN99o{T}(l99, a99, b99)

end


cnvt(::Type{DIN99o{T}}, c::Color) where {T} = cnvt(DIN99o{T}, convert(Lab{T}, c)::Lab{T})


# Everything to LMS
# -----------------

# Chromatic adaptation from CIECAM97s
const CAT97s = Mat3x3([ 0.8562  0.3372 -0.1934
                       -0.8360  1.8327  0.0033
                        0.0357 -0.0469  1.0112 ])

const CAT97s_INV = Mat3x3(inv(Float64.(CAT97s)))

# Chromatic adaptation from CIECAM02
const CAT02 = Mat3x3([ 0.7328 0.4296 -0.1624
                      -0.7036 1.6975  0.0061
                       0.0030 0.0136  0.9834 ])

const CAT02_INV = Mat3x3(inv(Float64.(CAT02)))


function cnvt(::Type{LMS{T}}, c::XYZ) where T
    @mul3x3 LMS{T} CAT02 c.x c.y c.z
end


cnvt(::Type{LMS{T}}, c::Color) where {T} = cnvt(LMS{T}, convert(XYZ{T}, c)::XYZ{T})

# Everything to YIQ
# -----------------

correct_gamut(c::YIQ{T}) where {T} = YIQ{T}(clamp(c.y, zero(T), one(T)),
                                     clamp(c.i, convert(T,-0.595716), convert(T,0.595716)),
                                     clamp(c.q, convert(T,-0.522591), convert(T,0.522591)))

const M_RGB2YIQ = Mat3x3([0.299      0.587      0.114
                          0.595716  -0.274453  -0.321263
                          0.211456  -0.522591   0.311135 ])
function cnvt(::Type{YIQ{T}}, c::AbstractRGB) where T
    rgb = correct_gamut(c)
    @mul3x3 YIQ{T} M_RGB2YIQ red(rgb) green(rgb) blue(rgb)
end

cnvt(::Type{YIQ{T}}, c::Color) where {T} = cnvt(YIQ{T}, convert(RGB{T}, c)::RGB{T})


# Everything to YCbCr
# -------------------
# FIXME
correct_gamut(c::YCbCr{T}) where {T} = YCbCr{T}(clamp(c.y, convert(T,16), convert(T,235)),
                                         clamp(c.cb, convert(T,16), convert(T,240)),
                                         clamp(c.cr, convert(T,16), convert(T,240)))
# FIXME
function cnvt(::Type{YCbCr{T}}, c::AbstractRGB) where T
    rgb = correct_gamut(c)
    YCbCr{T}(16+65.481*red(rgb)+128.553*green(rgb)+24.966*blue(rgb),
             128-37.797*red(rgb)-74.203*green(rgb)+112*blue(rgb),
             128+112*red(rgb)-93.786*green(rgb)-18.214*blue(rgb))
end

cnvt(::Type{YCbCr{T}}, c::Color) where {T} = cnvt(YCbCr{T}, convert(RGB{T}, c)::RGB{T})


# To Gray
# -------
# AbstractGray --> AbstractRGB conversions are implemented in ColorTypes.jl, but
# AbstractRGB --> AbstractGray conversions should be implemented here.

# Rec 601 luma conversion

function cnvt(::Type{G}, x::AbstractRGB{T}) where {G<:AbstractGray,T<:Normed}
    TU, Tf = FixedPointNumbers.rawtype(T), floattype(T)
    if sizeof(TU) < sizeof(UInt)
        val = Tf(0.001)*(299*reinterpret(red(x)) + 587*reinterpret(green(x)) + 114*reinterpret(blue(x)))
    else
        val = Tf(0.299)*reinterpret(red(x)) + Tf(0.587)*reinterpret(green(x)) + Tf(0.114)*reinterpret(blue(x))
    end
    return G(reinterpret(T, round(TU, val)))
end
cnvt(::Type{G}, x::AbstractRGB) where {G<:AbstractGray} =
    G(0.299f0*red(x) + 0.587f0*green(x) + 0.114f0*blue(x))

cnvt(::Type{G}, x::Color) where {G<:AbstractGray} = convert(G, convert(RGB, x))

using Colors, FixedPointNumbers, Test
using InteractiveUtils # for `subtypes`

@testset "Utilities" begin
    @testset "Mat3x3" begin
        M3x3 = Colors.Mat3x3([1 2 3; 4 5 6; 7 8 9])
        @test @inferred(M3x3[4]) === 2
        @test @inferred(M3x3[2,3]) === 6
        @test @inferred(M3x3[CartesianIndex(3, 2)]) === 8
    end

    @test Colors.cbrt01(0.6) ≈ cbrt(big"0.6") atol=eps(1.0)
    @test Colors.cbrt01(0.6f0) === cbrt(0.6f0)

    # issue #351
    xs = max.(rand(1000), 1e-4)
    @noinline l_pow_x_y() = for x in xs; x^2.4 end
    @noinline l_pow12_5() = for x in xs; Colors.pow12_5(x) end
    l_pow_x_y(); t_pow_x_y = @elapsed l_pow_x_y()
    l_pow12_5(); t_pow12_5 = @elapsed l_pow12_5()
    if t_pow12_5 > t_pow_x_y
        @warn "Optimization technique in `pow12_5` may have the opposite effect."
    end
    @noinline l_exp_y_log_x() = for x in xs; exp(1/2.4 * log(x)) end
    @noinline l_pow5_12() = for x in xs; Colors.pow5_12(x) end
    l_exp_y_log_x(); t_exp_y_log_x = @elapsed l_exp_y_log_x()
    l_pow5_12(); t_pow5_12 = @elapsed l_pow5_12()
    if t_pow5_12 > t_exp_y_log_x
        @warn "Optimization technique in `pow5_12` may have the opposite effect."
    end

    @test Colors.pow5_12(0.6) ≈ Colors.pow5_12(big"0.6") atol=1e-6
    @test Colors.pow5_12(0.6f0) ≈ Colors.pow5_12(big"0.6") atol=1e-6
    @test Colors.pow5_12(0.6N0f16) ≈ Colors.pow5_12(big"0.6") atol=1e-6
    @test Colors.pow12_5(0.6) ≈ Colors.pow12_5(big"0.6") atol=1e-6
    @test Colors.pow12_5(0.6N0f16) ≈ Colors.pow12_5(big"0.6") atol=1e-6

    # TODO: migrate to ColorTypes.jl
    @testset "atan360" begin
        for y in (-Inf, -0.0, +0.0, Inf, NaN), x in (-Inf, -0.0, +0.0, Inf, NaN)
            z0 = atand(y, x)
            z = signbit(z0) ? 360 + z0 : z0
            @test Colors.atan360(y, x) === z
            @test Colors.atan360(Float32(y), Float32(x)) === Float32(z)
        end
        for theta in 0.0:15.0:360.0
            yf64, xf64 = (sind(theta), cosd(theta)) .* 65.4321
            ybf, xbf = big(yf64), big(xf64)
            @test Colors.atan360(yf64, xf64) ≈ Colors.atan360(ybf, xbf) rtol=3eps(Float64)
            yf32, xf32 = Float32(yf64), Float32(xf64)
            ybf, xbf = big(yf32), big(xf32)
            @test Colors.atan360(yf32, xf32) ≈ Colors.atan360(ybf, xbf) rtol=3eps(Float32)
        end
    end

    @testset "polar_to_cartesian" begin
        @test Colors.polar_to_cartesian(50.0, NaN) === (NaN, NaN)
        @test Colors.polar_to_cartesian(0.0f0, Inf32) === (NaN32, NaN32)
        @test Float64.(Colors.polar_to_cartesian(big"2.0", big"120.0")) === (-1.0, sqrt(3.0))

        theta = -360.0:15.0:540.0
        yxbf = [sincos(deg2rad(big(t))) .* 64.5 for t in theta]
        xyf64 = Colors.polar_to_cartesian.(64.5, theta)
        xyf32 = Colors.polar_to_cartesian.(64.5f0, Float32.(theta))

        @test all(((a, b),) -> isapprox(a[1], b[2], atol=1e-14) &&
                               isapprox(a[2], b[1], atol=1e-14), zip(xyf64, yxbf))
        @test all(((a, b),) -> isapprox(a[1], b[2], atol=1e-6) &&
                               isapprox(a[2], b[1], atol=1e-6), zip(xyf32, yxbf))
    end

    @testset "hex" begin
        @test hex(RGB(1,0.5,0)) == "FF8000"
        @test hex(RGBA(1,0.5,0,0.25)) == "FF800040"
        @test hex(ARGB(1,0.5,0,0.25)) == "40FF8000"
        @test hex(HSV(30,1.0,1.0)) == "FF8000"

        @test hex(RGB(1,0.5,0), :AUTO) == "FF8000"
        @test hex(RGBA(1,0.5,0,0.25), :AUTO) == "FF800040"
        @test hex(ARGB(1,0.5,0,0.25), :AUTO) == "40FF8000"
        @test hex(HSV(30,1.0,1.0), :AUTO) == "FF8000"
        @test hex(RGB(1,0.5,0), :SomethingUnknown) == "FF8000"

        @test hex(RGB(1,0.5,0), :S) == "FF8000"
        @test hex(RGBA(1,0.5,0,0.25), :S) == "FF800040"
        @test hex(ARGB(1,0.5,0,0.25), :S) == "40FF8000"
        @test hex(RGB(1,0.533,0), :S) == "F80"
        @test hex(RGBA(1,0.533,0,0.267), :S) == "F804"
        @test hex(ARGB(1,0.533,0,0.267), :S) == "4F80"

        @test hex(RGB(1,0.5,0), :s) == "ff8000"
        @test hex(RGBA(1,0.5,0,0.25), :s) == "ff800040"
        @test hex(ARGB(1,0.5,0,0.25), :s) == "40ff8000"
        @test hex(RGB(1,0.533,0), :s) == "f80"
        @test hex(RGBA(1,0.533,0,0.267), :s) == "f804"
        @test hex(ARGB(1,0.533,0,0.267), :s) == "4f80"

        @test hex(RGB(1,0.5,0), :RGB) == "F80"
        @test hex(RGBA(1,0.5,0,0.25), :RGB) == "F80"
        @test hex(ARGB(1,0.5,0,0.25), :RGB) == "F80"
        @test hex(HSV(30,1.0,1.0), :RGB) == "F80"

        @test hex(RGB(1,0.5,0), :rgb) == "f80"
        @test hex(RGBA(1,0.5,0,0.25), :rgb) == "f80"
        @test hex(ARGB(1,0.5,0,0.25), :rgb) == "f80"
        @test hex(HSV(30,1.0,1.0), :rgb) == "f80"

        @test hex(RGB(1,0.5,0), :ARGB) == "FF80"
        @test hex(RGBA(1,0.5,0,0.25), :ARGB) == "4F80"
        @test hex(ARGB(1,0.5,0,0.25), :ARGB) == "4F80"
        @test hex(HSV(30,1.0,1.0), :ARGB) == "FF80"

        @test hex(RGB(1,0.5,0), :argb) == "ff80"
        @test hex(RGBA(1,0.5,0,0.25), :argb) == "4f80"
        @test hex(ARGB(1,0.5,0,0.25), :argb) == "4f80"
        @test hex(HSV(30,1.0,1.0), :argb) == "ff80"

        @test hex(RGB(1,0.5,0), :RGBA) == "F80F"
        @test hex(RGBA(1,0.5,0,0.25), :RGBA) == "F804"
        @test hex(ARGB(1,0.5,0,0.25), :RGBA) == "F804"
        @test hex(HSV(30,1.0,1.0), :RGBA) == "F80F"

        @test hex(RGB(1,0.5,0), :rgba) == "f80f"
        @test hex(RGBA(1,0.5,0,0.25), :rgba) == "f804"
        @test hex(ARGB(1,0.5,0,0.25), :rgba) == "f804"
        @test hex(HSV(30,1.0,1.0), :rgba) == "f80f"

        @test hex(RGB(1,0.5,0), :rrggbb) == "ff8000"
        @test hex(RGBA(1,0.5,0,0.25), :rrggbb) == "ff8000"
        @test hex(ARGB(1,0.5,0,0.25), :rrggbb) == "ff8000"
        @test hex(HSV(30,1.0,1.0), :rrggbb) == "ff8000"

        @test hex(RGB(1,0.5,0), :RRGGBB) == "FF8000"
        @test hex(RGBA(1,0.5,0,0.25), :RRGGBB) == "FF8000"
        @test hex(ARGB(1,0.5,0,0.25), :RRGGBB) == "FF8000"
        @test hex(HSV(30,1.0,1.0), :RRGGBB) == "FF8000"

        @test hex(RGB(1,0.5,0), :rrggbb) == "ff8000"
        @test hex(RGBA(1,0.5,0,0.25), :rrggbb) == "ff8000"
        @test hex(ARGB(1,0.5,0,0.25), :rrggbb) == "ff8000"
        @test hex(HSV(30,1.0,1.0), :rrggbb) == "ff8000"

        @test hex(RGB(1,0.5,0), :AARRGGBB) == "FFFF8000"
        @test hex(RGBA(1,0.5,0,0.25), :AARRGGBB) == "40FF8000"
        @test hex(ARGB(1,0.5,0,0.25), :AARRGGBB) == "40FF8000"
        @test hex(HSV(30,1.0,1.0), :AARRGGBB) == "FFFF8000"

        @test hex(RGB(1,0.5,0), :aarrggbb) == "ffff8000"
        @test hex(RGBA(1,0.5,0,0.25), :aarrggbb) == "40ff8000"
        @test hex(ARGB(1,0.5,0,0.25), :aarrggbb) == "40ff8000"
        @test hex(HSV(30,1.0,1.0), :aarrggbb) == "ffff8000"

        @test hex(RGB(1,0.5,0), :RRGGBBAA) == "FF8000FF"
        @test hex(RGBA(1,0.5,0,0.25), :RRGGBBAA) == "FF800040"
        @test hex(ARGB(1,0.5,0,0.25), :RRGGBBAA) == "FF800040"
        @test hex(HSV(30,1.0,1.0), :RRGGBBAA) == "FF8000FF"

        @test hex(RGB(1,0.5,0), :rrggbbaa) == "ff8000ff"
        @test hex(RGBA(1,0.5,0,0.25), :rrggbbaa) == "ff800040"
        @test hex(ARGB(1,0.5,0,0.25), :rrggbbaa) == "ff800040"
        @test hex(HSV(30,1.0,1.0), :rrggbbaa) == "ff8000ff"

        @test hex(Gray(0.5)) == "808080"
        @test hex(AGray(1.0, 0.5), :aarrggbb) == "80ffffff"
        @test hex(Gray{Bool}(1)) == "FFFFFF"

        # clamping
        @test hex(RGB(2.0,-1.0,0.5)) == "FF0080"
        @test hex(ARGB(2.0,-1.0,0.5,-10), :rrggbbaa) == "ff008000"
        @test hex(AHSV(30,1.0,1.0,-10), :RRGGBBAA) == "FF800000"
        @test hex(Gray(2.0)) == "FFFFFF"
        @test hex(AGray(1.0, -0.5), :rrggbbaa) == "ffffff00"
    end

    @testset "normalize_hue" begin
        function test_normalize_hue(h::T) where T<:AbstractFloat
            hn, he = normalize_hue(h), T(mod(h, BigFloat(360)))
            !signbit(hn) & (hn <= 360) || return false
            hn ≈ he || (hn == 360 && he == 0) || (hn == 0 && he == 360)
        end

        hues = -1500:1:1500
        @test all(h -> test_normalize_hue(Float64(h)), hues)
        @test all(h -> test_normalize_hue(prevfloat(Float64(h))), hues)
        @test all(h -> test_normalize_hue(nextfloat(Float64(h))), hues)

        @test all(h -> test_normalize_hue(Float32(h)), hues)
        @test all(h -> test_normalize_hue(prevfloat(Float32(h))), hues)
        @test all(h -> test_normalize_hue(nextfloat(Float32(h))), hues)

        @test all(h -> test_normalize_hue(Float16(h)), hues)
        @test all(h -> test_normalize_hue(prevfloat(Float16(h))), hues)
        @test all(h -> test_normalize_hue(nextfloat(Float16(h))), hues)

        @test normalize_hue(HSV{Float64}( 876.5, 0.4, 0.3)) === HSV{Float64}(156.5, 0.4, 0.3)
        @test normalize_hue(HSL{Float32}( 87.65, 0.4, 0.3)) === HSL{Float32}(87.65, 0.4, 0.3)
        @test normalize_hue(HSI{Float16}(-876.5, 0.4, 0.3)) === HSI{Float16}(203.5, 0.4, 0.3)

        @test normalize_hue(AHSV{Float32}(360.5, 0.4, 0.3, 0.2)) === AHSV{Float32}(0.5, 0.4, 0.3, 0.2)
        @test normalize_hue(HSLA{Float64}(360.5, 0.4, 0.3, 0.2)) === HSLA{Float64}(0.5, 0.4, 0.3, 0.2)

        @test normalize_hue(LCHab{Float64}(30, 40,  5.6e7)) === LCHab{Float64}(30, 40, 200)
        @test normalize_hue(LCHuv{Float32}(30, 40, -5.6e7)) === LCHuv{Float32}(30, 40, 160)

        @test normalize_hue(ALCHab{Float32}(30, 40, -0.5, 0.6)) === ALCHab{Float32}(30, 40, 359.5, 0.6)
        @test normalize_hue(LCHuvA{Float64}(30, 40, -0.5, 0.6)) === LCHuvA{Float64}(30, 40, 359.5, 0.6)
    end

    @testset "mean_hue" begin
        @test @inferred(mean_hue(0.0, 90.0)) === 45.0
        @test @inferred(mean_hue(90.0f0, 270.0f0)) === 180.0f0
        @test @inferred(mean_hue(90, 271)) === 0.5

        @test @inferred(mean_hue(HSV(50, 1, 1), HSV(100, 1, 0.5))) === 75.0
        @test @inferred(mean_hue(HSL(50, 1, 1), HSL(100, 0, 0.5))) === 50.0
        @test @inferred(mean_hue(Lab(50, 0, 10), Lab(50, 10, -10))) === 22.5f0
        @test @inferred(mean_hue(ALuv(50, 0, 0), ALuv(50, 0, 10))) === 90.0f0

        @test @inferred(mean_hue(LCHab(50, 60, 270), LCHab(90, 80, 80))) === 355.0f0
        @test @inferred(mean_hue(LCHuv(50, 60, 80), LCHuv(90, 0, 70))) === 80.0f0
        @test @inferred(mean_hue(LCHabA(90.0, 0, 70), LCHabA(50, 60, 80))) === 80.0

        @test_throws Exception mean_hue(RGB(0.1, 0.2, 0.3), RGB(0.4, 0.5, 0.6))
        @test_throws Exception mean_hue(LChab(10, 20, 30), LCHuv(10, 20, 30))
    end

    @testset "delta_h" begin
        @test @inferred(Colors.delta_h(LCHab(50, 60, 135.123f0), LCHab(90, 80, 135.123f0))) === 0.0f0
        @test @inferred(Colors.delta_h(LCHuv(50, 60, 80), LCHuv(90,  0, 70))) === 0.0f0
        @test @inferred(Colors.delta_h(LCHab(50, 60, 70), LCHab(90, 80, 190))) ≈ -120.0f0
        @test @inferred(Colors.delta_h(LCHab(90, 80, 70), LCHab(50, 60, 310.0))) ≈ 120.0
        @test_throws DomainError Colors.delta_h(LCHab(50, -1f-9, 70), LCHab(50, 60, 70))
        @test @inferred(Colors.delta_h(Lab(50, -10, 10), Lab(50, 10, -10))) ≈ 28.284271f0
        @test @inferred(Colors.delta_h(ALuv(50, 0, 0), ALuv(50, 0, 10))) === 0.0f0

        a, b = Lab(50, 4, 80), Lab(60, 5, 101)
        @test Colors.delta_h(a, b) ≈ -0.04444444f0 atol = 1f-4
        dhb = Colors.delta_h(Lab{BigFloat}(a), Lab{BigFloat}(b))
        @test Colors.delta_h(Lab{Float64}(a), Lab{Float64}(b)) ≈ dhb atol = 1e-13
    end

    @testset "delta_c" begin
        a, b = Lab(50, 40, -31), Lab(90, -30, 41)
        @test @inferred(Colors.delta_c(a, b)) ≈ -0.19721946f0 atol = 1f-7
        @test @inferred(Colors.delta_c(LCHab(a), LCHab(b))) ≈ -0.19721946f0 atol = 1f-6
    end

    # test utility function weighted_color_mean
    parametric2 = [GrayA,AGray32,AGray]
    parametric3 = ColorTypes.parametric3
    parametric4A = setdiff(subtypes(ColorAlpha),[GrayA])
    parametricA4 = setdiff(subtypes(AlphaColor),[AGray32,AGray])
    colortypes = vcat(parametric3,parametric4A,parametricA4)
    colorElementTypes = [Float16,Float32,Float64,BigFloat,N0f8,N6f10,N4f12,N2f14,N0f16]

    @testset "weighted_color_mean" begin
        for T in colorElementTypes
            c1 = Gray{T}(1)
            c2 = Gray{T}(0)
            @test weighted_color_mean(0.5,c1,c2) == Gray{T}(0.5)
        end
        gray_b1 = Gray{Bool}(1)
        gray_b0 = Gray{Bool}(0)
        @test @inferred(weighted_color_mean(0, gray_b1, gray_b0)) === gray_b0
        @test @inferred(weighted_color_mean(1, gray_b1, gray_b0)) === gray_b1
        @test @inferred(weighted_color_mean(0.5, gray_b1, gray_b1)) === gray_b1
        @test_throws InexactError weighted_color_mean(0.5, gray_b1, gray_b0)
        @test_throws DomainError weighted_color_mean(-1, gray_b1, gray_b0)

        for C in parametric2
            for T in colorElementTypes
                c1 = C(T(0), T(1))
                c2 = C(T(1), T(0))
                cx = C(T(0.5), T(0.5))
                @test @inferred(weighted_color_mean(0.5, c1, c2)) == cx
            end
        end

        for C in colortypes
            for T in (Float16,Float32,Float64,BigFloat)
                if C<:Color
                    c1 = C(T(1), T(1), T(0))
                    c2 = C(T(0), T(1), T(1))
                    cx = C(T(0.5), T(1.0), T(0.5))
                    @test @inferred(weighted_color_mean(0.5, c1, c2)) == cx
                else
                    c1 = C(T(1), T(1), T(0), T(0))
                    c2 = C(T(0), T(1), T(0), T(1))
                    cx = C(T(0.5), T(1.0), T(0.0), T(0.5))
                    @test @inferred(weighted_color_mean(0.5, c1, c2)) == cx
                end
            end
        end

        @test_throws DomainError weighted_color_mean(-0.01, RGB(1,1,0), RGB(0,1,1))
        @test_throws DomainError weighted_color_mean( 1.01, RGB(1,1,0), RGB(0,1,1))

        # promotion
        @test weighted_color_mean(0.5, RGB{N0f8}(1,1,0), RGB{Float32}(0,1,1)) === RGB{Float32}(0.5,1,0.5)
        @test_throws ArgumentError weighted_color_mean(0.5, RGB24(1,1,0), RGB{Float32}(0,1,1))

        @test weighted_color_mean(0.5, HSV(-360.0,1,0), HSV(180.0,0,1)) === HSV{Float64}(270,0.5,0.5)
        alchab1 = ALCHab{Float32}(0,100,-360,1)
        alchab2 = ALCHab{Float32}(100,0,-180,0)
        @test weighted_color_mean(0.5, alchab1, alchab2) === ALCHab{Float32}(50,50,90,0.5)
        lchuva1 = LCHuvA{Float16}(0,100, 90,1)
        lchuva2 = LCHuvA{Float16}(100,0,810,0)
        @test weighted_color_mean(0.5, lchuva1, lchuva2) === LCHuvA{Float16}(50,50,90,0.5)

        @testset "with collections" begin
            colors = [RGBA(1, 0, 0, 1) RGBA(0, 0, 1, 1)
                      RGBA(0, 1, 0, 1) RGBA(0, 0, 0, 0)]
            c = RGBA{N0f8}(0.1, 0.2, 0.3, 0.6)
            @test weighted_color_mean([0.1 0.3; 0.2 0.4],   colors) === c # matrix
            @test weighted_color_mean((0.1, 0.2, 0.3, 0.4), colors) === c # tuple
            @test weighted_color_mean(0.1:0.1:0.4,          colors) === c # range

            @test weighted_color_mean((0, 1), (Gray(1), Gray(0.0))) === Gray{N0f8}(0)
            @test weighted_color_mean((1, 0), (Gray(1.0), Gray(0))) === Gray{Float64}(1)

            @test_throws DimensionMismatch weighted_color_mean((0.1, 0.2, 0.3), colors)
            @test_throws Exception weighted_color_mean((0.1, 0.2), (RGB(1, 1, 1), HSV(0, 1, 1)))
        end
    end

    @testset "range" begin
        # `range` uses `weighted_color_mean` which is extensively tested.
        # Therefore it suffices to test the function using gray colors.
        for T in colorElementTypes
            c1 = Gray(T(1))
            c2 = Gray(T(0))
            linc1c2 = range(c1,stop=c2,length=43)
            @test length(linc1c2) == 43
            @test linc1c2[1] == c1
            @test linc1c2[end] == c2
            @test linc1c2[22] == Gray(T(0.5))
            @test typeof(linc1c2) == Array{Gray{T},1}
            if VERSION >= v"1.1"
                @test range(c1,c2,length=43) == range(c1,stop=c2,length=43)
            end
        end
    end
end

module ColorDiffCharts

using Colors

struct ColorDiffChartSVG <: Main.SVG
    buf::IOBuffer
end

const c = Lab.((Colors.JULIA_LOGO_COLORS.green,
                Colors.JULIA_LOGO_COLORS.red,
                Colors.JULIA_LOGO_COLORS.purple))

function ColorDiffChartSVG(metric::Colors.DifferenceMetric)
    io = IOBuffer()

    id = nameof(typeof(metric))

    d12 = colordiff(c[1], c[2], metric=metric)
    d23 = colordiff(c[2], c[3], metric=metric)
    d31 = colordiff(c[3], c[1], metric=metric)

    dn = 2*d31^2 - d23^2 + 2*d12^2
    ds0 = -(d31-d23-d12) * (d31-d23+d12) * (d31+d23-d12) * (d31+d23+d12)
    # `ds0` should be non-negative in metric systems.
    # However, DE_CMC is not metric but quasimetric.
    ds = max(ds0, 0)

    x = [0,
         -sqrt(ds/dn)/2,
          sqrt(ds/dn)/2]

    y = [-sqrt(dn) / 3,
         (( -d31^2 - d23^2 + 5*d12^2) * sqrt(dn)) / 6dn,
         ((5*d31^2 - d23^2 -   d12^2) * sqrt(dn)) / 6dn]

    # verification
    if ds0 >= 0
        d12 ≈ hypot(x[1] - x[2], y[1] - y[2]) || error("distance mismatch: d12")
        d23 ≈ hypot(x[2] - x[3], y[2] - y[3]) || error("distance mismatch: d23")
        d31 ≈ hypot(x[3] - x[1], y[3] - y[1]) || error("distance mismatch: d31")
    end

    scale = 7.5 / abs(y[1])

    sx = scale .* x
    sy = scale .* y
    r = scale * 20

    mx12, my12 = (sx[1] + sx[2]) * 0.5, (sy[1] + sy[2]) * 0.5
    mx23, my23 = (sx[2] + sx[3]) * 0.5, (sy[2] + sy[3]) * 0.5
    mx31, my31 = (sx[3] + sx[1]) * 0.5, (sy[3] + sy[1]) * 0.5

    a = atan(sy[2] - sy[3], sx[2] - sx[3])
    dy23, dx23 = 8 .* sincos(a)

    simplify(x) = replace(string(round(x, sigdigits=3)), r"\.0+$"=>"")
    rd12, rd23, rd31 = simplify.((d12, d23, d31))

    write(io,
        """
        <svg xmlns="http://www.w3.org/2000/svg" version="1.1"
             viewBox="-15 -12 30 30" width="30mm" height="30mm"
             stroke="none" stroke-linejoin="round"
             style="display:inline; margin-left:2em; margin-bottom:2em">
        <defs>
          <marker id="marker_s_$id" orient="auto" style="overflow:visible">
            <path d="M 7,-30 l -7,4 7,4 M 0,-26 h 9 M 0,-3 v -27"
                  style="fill:none;stroke:currentColor;stroke-opacity:0.7;" />
          </marker>
          <marker id="marker_e_$id" orient="auto" style="overflow:visible">
            <path d="M -7,-30 l 7,4 -7,4 M 0,-26 h -9 M 0,-3 v -27"
                  style="fill:none;stroke:currentColor;stroke-opacity:0.7;" />
          </marker>
        </defs>
        <g>
          <circle cx="$(sx[3])" cy="$(sy[3])" fill="#$(hex(c[3]))" r="$r" />
          <circle cx="$(sx[2])" cy="$(sy[2])" fill="#$(hex(c[2]))" r="$r" />
          <circle cx="$(sx[1])" cy="$(sy[1])" fill="#$(hex(c[1]))" r="$r" />
        </g>
        <g style="stroke:currentColor;stroke-width:0.2;stroke-opacity:0.4;
           marker-start:url(#marker_s_$id);marker-end:url(#marker_e_$id)">
          <path d="M$(sx[3]),$(sy[3]) L$(sx[2]),$(sy[2])"/>
          <path d="M$(sx[2]),$(sy[2]) L$(sx[1]),$(sy[1])"/>
          <path d="M$(sx[1]),$(sy[1]) L$(sx[3]),$(sy[3])"/>
        </g>
        <g fill="currentColor" style="font-size:2.8px;">
          <text x="$(mx12-3)" y="$my12" text-anchor="end">$rd12</text>
          <text x="$(mx23+dy23)" y="$(my23-dx23+1)" text-anchor="middle">$rd23</text>
          <text x="$(mx31+3)" y="$my31" text-anchor="start">$rd31</text>
          <text x="-14" y="17" style="font-size:2.5px;">$id</text>
        </g>
        </svg>""")
    ColorDiffChartSVG(io)
end

end

using Colors, Test

@testset "Colormatch" begin
    @test colormatch(500) === colormatch(CIE1931_CMF, 500)

    cmfs = (CIE1931_CMF, CIE1964_CMF, CIE1931J_CMF, CIE1931JV_CMF, CIE2006_2_CMF, CIE2006_10_CMF)
    @testset "$cmf" for cmf in cmfs
        @test colormatch(cmf, 350.0) === XYZ(0.0, 0.0, 0.0)
        @test colormatch(cmf, 850.0) === XYZ(0.0, 0.0, 0.0)
        xyz450 = colormatch(cmf, 450.0)
        @test xyz450.y < xyz450.x < xyz450.z
        xyz550 = colormatch(cmf, 550.0)
        @test xyz550.z < xyz550.x < xyz550.y
        xyz600 = colormatch(cmf, 600.0)
        @test xyz600.z < xyz600.y < xyz600.x
        xyz551 = colormatch(cmf, 551.0)
        @test colormatch(cmf, 550.5) ≈ (xyz550 + colormatch(cmf, 551)) / 2
    end
end

# Helper data for color parsing
include("names_data.jl")


# Color Parsing
# -------------

const col_pat_func3 = r"^\s*(?:rgba?|hsla?)
                               \(\s*([^\s,/\)]+)\s*
                            [,\s]\s*([^\s,/\)]+)\s*
                            [,\s]\s*([^\s,/\)]+)\s*
                            (?:[,/]\s*([^\s,/\)]+)\s*)?\)\s*$"ix
const col_pat_hex = r"^\s*(?:#|0x)([[:xdigit:]]{3,8})\s*$"
const col_pat_unitful = r"^([+-]?(?:\d+\.?\d*|\.\d+)(?:e[+-]?\d+)?)(.*)$"i

chop1(x) = SubString(x, 1, lastindex(x) - 1) # `chop` is slightly slow

function parse_hex(hex::SubString{String}) # It is guaranteed to be a valid hex string.
    digits = UInt32(0)
    for d in codeunits(hex)
        dl = d | 0x20
        digits = (digits << 0x4) + dl - (dl < UInt8('a') ? UInt8('0') : UInt8('a') - 0xa)
    end
    return digits
end

function tryparse_dec(dec::SubString{String})
    de = 0
    for d in codeunits(dec)
        dx = d - UInt8('0')
        0x0 <= dx <= 0x9 || return nothing
        de = de * 10 + dx
    end
    return de
end

function parse_f32(dec::SubString{String})
    v = tryparse_dec(dec)
    v === nothing && return parse(Float32, dec)
    Float32(v)
end

# Parse a number used in the "rgb()" or "hsl()" color.

function parse_rgb(num::SubString{String})
    @inbounds num[end] == '%' && throw_rgb_unification_error()
    v = tryparse_dec(num)
    if v === nothing
        v = round(Int, parse(Float32, num))
    end
    return reinterpret(N0f8, unsafe_trunc(UInt8, clamp(v, 0, 255)))
end

function parse_rgb_pc(num::SubString{String})
    @inbounds num[end] == '%' || throw_rgb_unification_error()
    v = round(Int, parse_f32(chop1(num)) * 2.55f0)
    return reinterpret(N0f8, unsafe_trunc(UInt8, clamp(v, 0, 255)))
end

function throw_rgb_unification_error()
    throw(ArgumentError("RGB values should be unified in numbers in [0,255] or percentages."))
end

function parse_hue(num::SubString{String})
    vi = tryparse_dec(num)
    vi !== nothing && return Float32(vi)
    mat = match(col_pat_unitful, num)
    if mat !== nothing
        v0, unit0 = mat.captures
        v = parse_f32(v0)
        isempty(unit0) && return v
        unit = lowercase(unit0)
        if unit == "deg"
            return v
        elseif unit == "turn"
            return v * 360f0
        elseif unit == "rad"
            return rad2deg(v)
        elseif unit == "grad"
            return v * 0.9f0
        end
    end
    throw(ArgumentError("invalid hue notation: $num"))
end

function parse_hsl_pc(num::SubString{String})
    if @inbounds num[end] != '%'
        throw(ArgumentError("saturation and lightness must end in %"))
    end
    return clamp(parse_f32(chop1(num)) / 100f0, 0.0f0, 1.0f0)
end

# Parse a number used in the alpha field of "rgba()" and "hsla()".
function parse_alpha(num::SubString{String})
    if @inbounds num[end] == '%'
        v = parse_f32(chop1(num)) / 100f0
    else
        v = parse(Float32, num)
    end
    return clamp(v, 0.0f0, 1.0f0)
end

function _parse_colorant(desc::String)
    n0f8(x) = reinterpret(N0f8, unsafe_trunc(UInt8, x))
    mat = match(col_pat_hex, desc)
    if mat !== nothing
        len = ncodeunits(mat[1])
        digits = parse_hex(mat[1])
        if len == 6
            return convert(RGB{N0f8}, reinterpret(RGB24, digits))
        elseif len == 3
            return RGB(n0f8((digits>>8) & 0xF * 0x11),
                       n0f8((digits>>4) & 0xF * 0x11),
                       n0f8((digits>>0) & 0xF * 0x11))
        elseif len == 8
            if occursin('#', desc)
                return RGBA{N0f8}(n0f8(digits>>24),
                                  n0f8(digits>>16),
                                  n0f8(digits>> 8),
                                  n0f8(digits>> 0))
            else
                return ARGB{N0f8}(n0f8(digits>>16),
                                  n0f8(digits>> 8),
                                  n0f8(digits>> 0),
                                  n0f8(digits>>24))
            end
        elseif len == 4
            if occursin('#', desc)
                return RGBA{N0f8}(n0f8((digits>>12) & 0xF * 0x11),
                                  n0f8((digits>> 8) & 0xF * 0x11),
                                  n0f8((digits>> 4) & 0xF * 0x11),
                                  n0f8((digits>> 0) & 0xF * 0x11))
            else
                return ARGB{N0f8}(n0f8((digits>> 8) & 0xF * 0x11),
                                  n0f8((digits>> 4) & 0xF * 0x11),
                                  n0f8((digits>> 0) & 0xF * 0x11),
                                  n0f8((digits>>12) & 0xF * 0x11))
            end
        end
    end
    mat = match(col_pat_func3, desc)
    if mat !== nothing #&& mat[1] !== nothing && mat[2] !== nothing && mat[3] !== nothing
        if occursin(r"^\s*rgb"i, desc)
            return _parse_colorant_rgb(mat[1], mat[2], mat[3], mat[4])
        else # occursin(r"^\s*hsl"i, desc)
            return _parse_colorant_hsl(mat[1], mat[2], mat[3], mat[4])
        end
    end

    sdesc = strip(desc)
    c = get(color_names, sdesc, nothing)
    c !== nothing && return RGB{N0f8}(n0f8(c[1]), n0f8(c[2]), n0f8(c[3]))

    # since `lowercase` is slightly slow, it is applied only when needed
    ldesc = lowercase(sdesc)
    c = get(color_names, ldesc, nothing)
    c !== nothing && return RGB{N0f8}(n0f8(c[1]), n0f8(c[2]), n0f8(c[3]))

    ldesc == "transparent" && return RGBA{N0f8}(0,0,0,0)

    wo_spaces = replace(ldesc, r"(?<=[^bfptuv ][^p ][adeghk-rtwy]) (?=[^efinq ][aeh-mo-rtuy][^kw \d][a-y]{0,7}\b)" => "")
    c = get(color_names, wo_spaces, nothing)
    if c !== nothing && sizeof(wo_spaces) > 6
        return RGB{N0f8}(n0f8(c[1]), n0f8(c[2]), n0f8(c[3]))
    end

    throw(ArgumentError("Unknown color: $desc"))
end

function _parse_colorant_rgb(p1, p2, p3, alpha)
    if @inbounds p1[end] == '%'
        r, g, b = parse_rgb_pc(p1), parse_rgb_pc(p2), parse_rgb_pc(p3)
    else
        r, g, b = parse_rgb(p1), parse_rgb(p2), parse_rgb(p3)
    end
    if alpha === nothing
        return RGB{N0f8}(r, g, b)
    else
        return RGBA{N0f8}(r, g, b, parse_alpha(alpha) % N0f8)
    end
end

function _parse_colorant_hsl(p1, p2, p3, alpha)
    h, s, l = parse_hue(p1), parse_hsl_pc(p2), parse_hsl_pc(p3)
    if alpha === nothing
        return typeof(HSL(0,0,0))(h, s, l)
    else
        return typeof(HSLA(0,0,0))(h, s, l, parse_alpha(alpha))
    end
end

"""
    parse(Colorant, desc)

Parse a color description.

This parses a subset of HTML/CSS color specifications. In particular, everything
is supported but: `currentColor`.

It does support named colors (though it uses X11 named colors, which are
slightly different than W3C named colors in some cases), `rgb()`, `hsl()`,
`#RGB`, and `#RRGGBB` syntax.

# Arguments

- `Colorant`: literal Colorant
- `desc`: color name or description

A literal Colorant will parse according to the `desc` string (usually returning
an `RGB`); any more specific choice will return a color of the specified type.

# Returns

- an `RGB{N0f8}` color, or

- an `HSL` color if `hsl(h, s, l)` was used

- an `RGBA` color if `rgba(r, g, b, a)` was used

- an `HSLA` color if `hsla(h, s, l, a)` was used

- an `ARGB{N0f8}` color if `0xAARRGGBB`/`0xARGB` was used

- a specific `Colorant` type as specified in the first argument

!!! note "Note for X11 named colors"
    The X11 color names with spaces (e.g. "sea green") are not recommended
    because they are not allowed in the SVG/CSS.

!!! note "Note for hex notations"
    You can parse not only the CSS-style hex notations `#RRGGBB`/`#RGB`, but
    also `0xRRGGBB`/`0xRGB`.

    You can also parse the 8-digit or 4-digit hex notation into an RGB color
    with alpha. However, the result depends on the prefix (i.e. `#` or `0x`).
    ```julia-repl
    julia> parse(Colorant, "#FF8800AA") # transparent orange
    RGBA{N0f8}(1.0,0.533,0.0,0.667)

    julia> parse(Colorant, "0xFF8800AA") # opaque purple
    ARGB{N0f8}(0.533,0.0,0.667,1.0)
    ```
"""
function Base.parse(::Type{C}, desc::AbstractString) where {C<:Colorant}
    c = _parse_colorant(String(desc))
    C === Colorant && return c
    c = convert(C, c)
    return isconcretetype(C) ? c::C : c
end

Base.parse(::Type{C}, desc::Symbol) where {C<:Colorant} = parse(C, string(desc))

@noinline function Base.parse(::Type{C}, c::Colorant) where {C<:Colorant}
    Base.depwarn("""
        `parse(::Type, ::Colorant)` is deprecated.
          Do not call `parse` if the object does not need to be parsed.""", :parse)
    c
end

"""
    @colorant_str(ex)

Parse a literal color name as a Colorant.
See [`Base.parse(Colorant, desc)`](@ref).
"""
macro colorant_str(ex)
    isa(ex, AbstractString) || error("colorant requires literal strings")
    col = parse(Colorant, ex)
    :($col)
end

# Displaying color swatches
# -------------------------

const max_width = 180
const max_height = 150
const max_swatch_size = 25
const default_max_swatches = 128 * 128

_isfinite(c::Colorant) = mapreducec(isfinite, &, true, c)

Base.showable(::MIME"image/svg+xml", c::Colorant) = _isfinite(c)
# Note that ImageShow.jl overloads `showable` for `AbstractMatrix{<:Color}`
function Base.showable(::MIME"image/svg+xml", cs::Union{AbstractVector{<:Colorant},
                                                        AbstractMatrix{<:Color}})
    all(_isfinite, cs)
end

function Base.show(io::IO, mime::MIME"image/svg+xml", c::Color)
    write_declaration(io, mime)
    write(io,
        """
        <svg xmlns="http://www.w3.org/2000/svg" version="1.1"
             width="25mm" height="25mm" viewBox="0 0 1 1">
            <rect width="1" height="1" fill="#$(hex(c))" stroke="none"/>
        </svg>
        """)
    flush(io) # return nothing
end

function Base.show(io::IO, mime::MIME"image/svg+xml", c::TransparentColor)
    show(io, mime, [c], max_swatches=default_max_swatches)
end


function Base.show(io::IO, mime::MIME"image/svg+xml", cs::AbstractVector{T};
                   max_swatches::Integer=0) where T <: Color
    mat = Base.ReshapedArray(cs, (1, length(cs)), ())
    show(io, mime, mat, max_swatches=max_swatches)
end

function Base.show(io::IO, mime::MIME"image/svg+xml",cs::AbstractVector{T};
                   max_swatches::Integer=0) where T <: TransparentColor

    # use random id to avoid id collision when the SVG is embedded inline
    id = "pat_" * string(rand(UInt32), base=62)
    n = length(cs)
    actual_max_swatches = max_swatches > 0 ? max_swatches : default_max_swatches
    # When `max_swatches` is specified, the following warning is suppressed.
    if max_swatches == 0 && n > actual_max_swatches
        trunc = n - actual_max_swatches
        @warn """Last $trunc swatches (of $n-element Array) are truncated."""
        yield()
    end
    w = min(n * max_swatch_size, max_width)

    scale = n * max_swatch_size / w # 1 for square, >1 for portrait
    rscale = round(scale, digits=3)
    pat_scale = rscale == 1 ? "" : """patternTransform="scale($rscale,1)" """

    # the following are with the assumption that scale >= 1 (i.e. not landscape)
    if rscale == 1
        shape = "0v1h-1z" # triangle
    else # rscale > 1
        simplify(x) = replace(string(round(x, digits=2)), r"^0"=>"")
        d1 = simplify((1 - 1 / scale) / 2)
        d2 = simplify((1 + 1 / scale) / 2)
        shape = """$(d1)V1h-1V$(d2)z""" # trapezoid
    end
    write_declaration(io, mime)
    write(io,
        """
        <svg xmlns="http://www.w3.org/2000/svg" version="1.1"
             width="$(w)mm" height="25mm" viewBox="0 0 $n 1" stroke="none"
             preserveAspectRatio="none" shape-rendering="crispEdges">
        <defs>
            <pattern id="$id" width=".2" height=".2"
                     patternUnits="userSpaceOnUse" $pat_scale>
                <path d="M.1,0h.1v.1h-.2v.1h.1z" fill="#999" opacity=".5" />
            </pattern>
        </defs>
        <rect width="$n" height="1" fill="url(#$id)" />
        """)
    for (i, c) in enumerate(cs)
        i > actual_max_swatches && break
        hexc = hex(color(c))
        opacity = string(round(float(alpha(c)), digits=4))
        op = replace(opacity, r"(^0(?!\.0$))|(\.0$)"=>"")
        write(io,
            """
            <path d="M$i,$shape" fill="#$hexc" />
            <path d="M$(i-1),0h1v1h-1z" fill="#$hexc" fill-opacity="$op" />
            """)
    end
    write(io, "</svg>")
    flush(io) # return nothing
end


function Base.show(io::IO, mime::MIME"image/svg+xml", cs::AbstractMatrix{T};
                   max_swatches::Integer=0) where T <: Color
    m, n = size(cs)
    actual_max_swatches = max_swatches > 0 ? max_swatches : default_max_swatches
    if m * n > actual_max_swatches
        return show_strokes(io, mime, cs, max_swatches=max_swatches)
    end
    w = min(n * max_swatch_size, max_width)
    h = min(m * max_swatch_size, max_height)
    if max_width * m > max_height * n
        w = max(h * n / m, max_swatch_size)
    else
        h = max(w * m / n, max_swatch_size)
    end

    simplify(x) = replace(string(round(x, digits=2)), r"(^0(?=\.))|(.0+$)"=>"")
    sw = simplify(1 - (w / n < 3.6 ? 0 : n / w))
    sh = simplify(1 - (h / m < 3.6 ? 0 : m / h))
    if sw == "1" && sh == "1"
        return show_strokes(io, mime, cs, max_swatches=max_swatches)
    end

    comp(x) = round(x)==round(x, digits=2) ? Int(round(x)) : round(x, digits=2)
    write_declaration(io, mime)
    write(io,
        """
        <svg xmlns="http://www.w3.org/2000/svg" version="1.1"
             width="$(comp(w))mm" height="$(comp(h))mm"
             viewBox="0 0 $n $m" preserveAspectRatio="none"
             shape-rendering="crispEdges" stroke="none">
        """)

    i1, j1 = firstindex(cs, 1), firstindex(cs, 2)
    for i in 0:m-1, j in 0:n-1
        c = hex(cs[i1 + i, j1 + j])
        write(io,
            """
            <rect width="$sw" height="$sh" x="$j" y="$i" fill="#$c" />
            """)
    end

    write(io, "</svg>")
    flush(io) # return nothing
end

# TODO: add `show` method for `AbstractMatrix{T} where T<:TransparentColor`
# Unlike the case of opaque `Color`, hasty generalization has some problems:
#  - Large matrices (i.e. images) may cause performance (size or speed) issue
#  - User may expect a raster image to be displayed instead of swatches
#  - ImageShow.jl(v0.2.0) suppresses only the SVG matrices of opaque `Color`
#  - Checker pattern is less useful when each swatch is smaller than the checker
#  - Area-average as reduction method is perceptually meaningless for alpha


function show_strokes(io::IO, mime::MIME"image/svg+xml", cs::AbstractMatrix{T};
                      max_swatches::Integer=0) where T <: Color
    m, n = size(cs)
    actual_max_swatches = max_swatches > 0 ? max_swatches : default_max_swatches
    # When `max_swatches` is specified, the following warning is suppressed.
    if max_swatches == 0 && m * n > actual_max_swatches
        @warn """
            Output swatches are reduced due to the large size ($m×$n).
            Load the ImageShow package for large images."""
        yield()
    end
    w = max_width
    h = max_height
    if max_width * m > max_height * n
        w = n / m * h
    else
        h = m / n * w
    end

    # decimation factor `d` is rounded to integer to simplify the SVG document
    d = Int(ceil(sqrt(m * n / actual_max_swatches)))

    comp(x) = round(x)==round(x, digits=2) ? Int(round(x)) : round(x, digits=2)
    write_declaration(io, mime)
    write(io,
        """
        <svg xmlns="http://www.w3.org/2000/svg" version="1.1"
             width="$(comp(w))mm" height="$(comp(h))mm"
             viewBox="0 -$(comp(d/2)) $n $m" stroke-width="$d"
             stroke-linecap="butt" shape-rendering="crispEdges">
        """)

    i1, j1 = firstindex(cs, 1), firstindex(cs, 2)
    for i in 0:d:m-1, j in 0:d:n-1
        # since there is no universal way,
        # calculate the mean color in "RGB space"
        csum = RGB{Float32}(0, 0, 0)
        u = min(n - j, d) # cell width
        v = min(m - i, d) # cell height
        for x in j:j+u-1, y in i:i+v-1
            rgb = convert(RGB, cs[i1 + y, j1 + x])
            csum = mapc((s, a) -> s + Float32(a), csum, rgb)
        end
        c = hex(mapc(s -> s / (u * v), csum))
        write(io,
            """
            <path d="M$j,$(i)h$d" stroke="#$c" />
            """)
    end

    write(io, "</svg>")
    flush(io) # return nothing
end

function write_declaration(io::IO, ::MIME"image/svg+xml")
    write(io,
        """
        <?xml version="1.0" encoding="UTF-8"?>
        <!DOCTYPE svg PUBLIC "-//W3C//DTD SVG 1.1//EN"
         "http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd">
        """)
    flush(io) # return nothing
end

using Colors, Test
@test isempty(detect_ambiguities(Colors))

include("algorithms.jl")
include("conversion.jl")
include("colormaps.jl")
include("colormatch.jl")
include("colordiff.jl")
include("din99.jl")
include("display.jl")
include("parse.jl")
include("utilities.jl")

using AbstractTrees
@test isempty(detect_ambiguities(Colors))

module ColormapParams

using Colors
using Main.PNG16x16

struct ColormapParamSVG <: Main.SVG
    buf::IOBuffer
end

function ColormapParamSVG(target::Symbol)
    io = IOBuffer()
    write(io,
        """
        <svg xmlns="http://www.w3.org/2000/svg"
             xmlns:xlink="http://www.w3.org/1999/xlink"
             version="1.1"
             width="45mm" height="45mm"
             viewBox="0 0 270 270" preserveAspectRatio="none"
             shape-rendering="crispEdges" stroke="none" stroke-width="1">
        """)
    write(io,
        """
        <rect width="270" height="270" fill="#aaa" opacity="0.2" />
        """)
    if target in (:c, :s, :b)
        write_chart_csb(io, target)
    elseif target in (:w, :d)
        write_chart_wd(io, target)
    end
    write(io, "</svg>")
    ColormapParamSVG(io)
end

function write_chart_csb(io, target::Symbol)
    pp = (0.1, 0.5, 0.9)
    pc = map(_ -> 0.88, pp)
    ps = map(_ -> 0.60, pp)
    pb = map(_ -> 0.75, pp)
    markers = ("m -5,-5 v 10 h 10 v -10 z",
               "m 0,-5 l -5,9 h 10 z",
               "m 0,-4 l -4,4 4,4 4,-4 z")
    if target === :c
        col = Colors.JULIA_LOGO_COLORS.purple
        label = "contrast"
        pc = pp
    elseif target === :s
        col = Colors.JULIA_LOGO_COLORS.red
        label = "saturation"
        ps = pp
    elseif target === :b
        col = Colors.JULIA_LOGO_COLORS.green
        label = "brightness"
        pb = pp
    end
    h = round(Int, hue(convert(Luv, col)))
    n = 16
    ls = (100/2/n):(100/n):100
    cs = (175/2/n):(175/n):175
    mc(l) = Colors.find_maximum_chroma(LCHuv(l, 0.0, h))
    plane = [LCHuv(100.0 - l, min(c, mc(l)), h) for l in ls, c in cs]
    write(io,
        """
        <g transform="translate(80, 20)" fill="none" stroke-width="1.5"
           style="font-size: 18px; font-style: italic;">
            <image width="100" height="100" transform="scale(1.75, 2)" xlink:href=\"""")
    write_png_as_data(io, plane)
    write(io, "\" />\n")
    mc_coords = join(string(round(Int, mc(100 - l)), ",", 2l, " ") for l = 0:2:100)
    write(io,
        """
            <path d="m 175,0 L $mc_coords 175,200 z" fill="#aaa" />
            <path d="m 0,200 v -215 l 5,10 m -10,0 l 5,-10" stroke="currentColor" />
            <path d="m 0,200 h  185 l -10,5 m 0,-10 l 10,5" stroke="currentColor" />
            <text fill="currentColor" x="150" y="220">C*</text>
            <text fill="currentColor" x="-25" y="10" >L*</text>
        """)
    write(io, "</g>")
    for i = 1:3
        colors= sequential_palette(h, 7, c=pc[i], s=ps[i], b=pb[i], w=0, d=0)
        write_colormap(io, 25 * i - 20, pp[i], colors, markers[i])
    end
    tcolors = (sequential_palette(h, 25, c=pc[i], s=ps[i], b=pb[i], w=0, d=0) for i = 1:3)
    write_stroke(io, tcolors, markers)
    write(io,
        """
        <text fill="currentColor" y="260" style="font-size: 18px;">
            <tspan x="70" style="font-style: italic;">$target</tspan>
            <tspan x="90">- $label [0,1]</tspan>
        </text>
        """)
end

function write_chart_wd(io, target::Symbol)
    pp = 0.0:0.2:1.0
    pw = map(_ -> 0.15, pp)
    pd = map(_ -> 0.0, pp)

    if target === :w
        col = Colors.JULIA_LOGO_COLORS.blue
        cy = 40
        pw = pp
        kcol = "#ff0"
    elseif target === :d
        col = Colors.JULIA_LOGO_COLORS.green
        cy = 200
        pd = pp
        kcol = "#00f"
    end
    h = round(Int, hue(convert(Luv, col)))
    for i in eachindex(pp)
        colors = sequential_palette(h, 9, w=pw[i], d=pd[i])
        write_colormap(io, 30 * i - 10, pp[i], colors)
    end
    write(io,
        """
        <rect x="205" y="$cy" width="20" height="20" fill="$kcol" />
        """)
    write(io,
        """
        <text fill="currentColor" y="260" style="font-size: 18px;">
            <tspan x="20" style="font-style: italic;">$target</tspan>
            <tspan x="40">- strength of $(target)color [0,1]</tspan>
            <tspan x="195" y="$(cy-5)" style="font-style: italic;">$(target)color</tspan>
        </text>
        """)
end

function write_colormap(io, x, p, colors, marker="")
    y = 0
    write(io,
        """
        <g transform="translate($x, 40)" stroke-opacity="0.5">
        """)
    for col in colors
        write(io,
            """
                <rect x="0" y="$y" width="20" height="20" fill="#$(hex(col))" />
            """)
        y += 20
    end
    if !isempty(marker)
        y += 10
        write(io,
            """
                <path d="m 10,$y $marker" fill="#$(hex(last(colors)))" stroke="white" />
            """)
    end
    y += 20
    write(io,
        """
            <text x="0" y="$y" fill="currentColor" style="font-size: 15px;">$p</text>
        """)
    write(io, "</g>")
end

function write_stroke(io, tcolors, markers)
    write(io,
        """
        <g transform="translate(80, 20)" stroke="white" stroke-opacity="0.5">
        """)
    coord(c) = string(round(Int, c.c), ",", round(Int, 2 * (100 - c.l)), " ")
    for (i, colors) in enumerate(tcolors)
        coords = join(map(coord, LCHuv.(colors)))
        op = (0.4, 0.6, 1.0)[i]
        sw = (10, 4, 1)[i]
        write(io,
            """
                <path d="M $coords" fill="none" stroke-opacity="$op" stroke-width="$sw" />
            """)
    end
    for (i, colors) in enumerate(tcolors)
        mk = markers[i]
        hx = hex(last(colors))
        write(io,
            """
            <path d="M $(coord(LCHuv(first(colors))))$mk" fill="#$hx" />
            <path d="M $(coord(LCHuv(last( colors))))$mk" fill="#$hx" />
            """)
    end
    write(io, "</g>")
end

end # module

module Colors

using FixedPointNumbers
using Reexport

@reexport using ColorTypes
# remove deprecated bindings 
# see discussion https://github.com/JuliaIO/ImageMagick.jl/issues/235
# Base.@deprecate_binding RGB1 XRGB
# Base.@deprecate_binding RGB4 RGBX


import Base: ==, +, -, *, /
import Base: convert, eltype, isless, range, show, showable, typemin, typemax

# Additional exports, not exported by ColorTypes
export weighted_color_mean,
       hex, @colorant_str,
       protanopic, deuteranopic, tritanopic,
       distinguishable_colors, whitebalance,
       colordiff, DE_2000, DE_94, DE_JPC79, DE_CMC, DE_BFD, DE_AB, DE_DIN99, DE_DIN99d, DE_DIN99o,
       MSC, sequential_palette, diverging_palette, colormap,
       normalize_hue, mean_hue,
       colormatch, CIE1931_CMF, CIE1964_CMF, CIE1931J_CMF, CIE1931JV_CMF, CIE2006_2_CMF, CIE2006_10_CMF

# Early utilities
include("utilities.jl")

# Include other module components
include("conversions.jl")
include("algorithms.jl")
include("parse.jl")
include("differences.jl")
include("colormaps.jl")
include("display.jl")
include("colormatch.jl")

"""
Colors used in the Julia logo as a `NamedTuple`.

The keys are approximate descriptions of the hue and do not include black.

Not exported, use as `JULIA_LOGO_COLORS.red` etc.
"""
const JULIA_LOGO_COLORS = (red = RGB{N0f8}(0.796, 0.235, 0.2),  # colorant"#cb3c33" blocks precompilation
                           green = RGB{N0f8}(0.22, 0.596, 0.149),
                           blue = RGB{N0f8}(0.251, 0.388, 0.847),
                           purple = RGB{N0f8}(0.584, 0.345, 0.698))

if VERSION >= v"1.1"   # work around https://github.com/JuliaLang/julia/issues/34121
    include("precompile.jl")
    _precompile_()
end

end # module

# Support Data for color maps
include("maps_data.jl")

# color scale generation
# ----------------------

@noinline function _generate_lab(l::Float32, c::Float32, h::Float32)
    lab = convert(Lab{Float32}, LCHab{Float32}(l, c, h))
    rgb = xyz_to_linear_rgb(convert(XYZ{Float32}, lab))
    convert(Lab{Float32}, linear_rgb_to_xyz(correct_gamut(rgb)))
end

"""
    colors = distinguishable_colors(n, seed=RGB{N0f8}[];
                                    dropseed=false,
                                    transform=identity,
                                    lchoices=range(0, stop=100, length=15),
                                    cchoices=range(0, stop=100, length=15),
                                    hchoices=range(0, stop=342, length=20))

Generate `n` maximally distinguishable colors.

This uses a greedy brute-force approach to choose `n` colors that are maximally
distinguishable. Given seed color(s), and a set of possible hue, chroma, and
lightness values (in LCHab space), it repeatedly chooses the next color as the
one that maximizes the minimum pairwise distance to any of the colors already
in the palette.

# Arguments

- `n`: Number of colors to generate.
- `seed`: Initial color(s) included in the palette.

# Keyword arguments

- `dropseed`: if true, the `seed` values will be dropped. This provides an easy
  mechanism to ensure that the chosen colors are distinguishable from the seed value(s).
  When true, `n` does not include the seed color(s).
- `transform`: Transform applied to colors before measuring distance. Default is `identity`;
  other choices include `deuteranopic` to simulate color-blindness.
- `lchoices`: Possible lightness values
- `cchoices`: Possible chroma values
- `hchoices`: Possible hue values

Returns a `Vector` of colors of length `n`, of the type specified in `seed`.
"""
function distinguishable_colors(n::Integer,
        @nospecialize(seed::AbstractVector{<:Color});
        dropseed::Bool = false,
        transform::Function = identity,
        lchoices::AbstractVector{<:Real} = range(0.0f0, stop=100.0f0, length=15),
        cchoices::AbstractVector{<:Real} = range(0.0f0, stop=100.0f0, length=15),
        hchoices::AbstractVector{<:Real} = range(0.0f0, stop=342.0f0, length=20))
    if n <= length(seed) && !dropseed
        i₀ = firstindex(seed)
        return seed[i₀:n+i₀-1]
    end

    # Candidate colors
    N = length(lchoices) * length(cchoices) * length(hchoices)
    candidate = Vector{Lab{Float32}}(undef, N)
    j = 0
    for h in hchoices, c in cchoices, l in lchoices
        @inbounds candidate[j+=1] = _generate_lab(Float32(l), Float32(c), Float32(h))
    end

    _distinguishable_colors(Int(n), seed, dropseed, transform, candidate)
end

function _distinguishable_colors(n::Int,
        @nospecialize(seed::AbstractVector{<:Color}),
        dropseed::Bool,
        @nospecialize(transform::Function),
        candidate::Vector{Lab{Float32}})

    N = length(candidate)
    colors = Vector{eltype(seed)}(undef, n)

    # Transformed colors
    if transform === identity
        candidate_t = candidate
    else
        candidate_t = convert.(Lab{Float32}, transform.(candidate))::Vector{Lab{Float32}}
    end

    # Start with the seed colors, unless `dropseed`
    dropseed || copyto!(colors, seed)

    # Minimum distances of the current color to each previously selected color.
    ds = fill(Inf32, N)
    @inbounds for s in seed
        ts = convert(Lab{Float32}, transform(s))::Lab{Float32}
        for k = 1:N
            ds[k] = @fastmath min(ds[k], colordiff(ts, candidate_t[k]))
        end
    end

    n1 = dropseed ? 1 : length(seed) + 1
    @inbounds for i in n1:n
        j = argmax(ds)
        colors[i] = candidate[j]
        tc = candidate_t[j]
        ds[j] = 0.0f0
        for k = 1:N
            ds[k] == 0.0f0 && continue # already selected
            ds[k] = @fastmath min(ds[k], colordiff(tc, candidate_t[k]))
        end
    end

    return colors
end

distinguishable_colors(n::Integer, seed::Color; kwargs...) = distinguishable_colors(n, [seed]; kwargs...)
distinguishable_colors(n::Integer; kwargs...) = distinguishable_colors(n, Vector{RGB{N0f8}}(); kwargs...)

@deprecate distinguishable_colors(n::Integer,
                                transform::Function,
                                seed::Color,
                                ls::Vector{Float64},
                                cs::Vector{Float64},
                                hs::Vector{Float64})    distinguishable_colors(n, [seed], transform = transform, lchoices = ls, cchoices = cs, hchoices = hs)

"""
    sequential_palette(h, N::Int=100; <keyword arguments>)

Implements the color palette creation technique by
[Wijffelaars, M., et al. (2008)](https://dl.acm.org/doi/10.1111/j.1467-8659.2008.01203.x).

Colormaps are formed using Bézier curves in LCHuv colorspace
with some constant hue. In addition, start and end points can be given
that are then blended to the original hue smoothly.

# Arguments

- `N`        - number of colors
- `h`        - the main hue [0,360]
- `c`        - the overall lightness contrast [0,1]
- `s`        - saturation [0,1]
- `b`        - brightness [0,1]
- `w`        - cold/warm parameter, i.e. the strength of the starting color [0,1]
- `d`        - depth of the ending color [0,1]
- `wcolor`   - starting color (warmness)
- `dcolor`   - ending color (depth)
- `logscale` - `true`/`false` for toggling logspacing
"""
function sequential_palette(h,
                            N::Int=100;
                            w=0.15,
                            d=0.0,
                            c=0.88,
                            s=0.6,
                            b=0.75,
                            wcolor=RGB(1.0, 1.0, 0.0),
                            dcolor=RGB(0.0, 0.0, 1.0),
                            logscale::Bool=false)
    F = Float64
    return _sequential_palette(N, logscale, F(h), F(w), F(d), F(c), F(s), F(b),
                               RGB{F}(wcolor), RGB{F}(dcolor))
end

mix_hue(h0::Float64, h1::Float64, w) = h0 + w * (normalize_hue(180.0 + h1 - h0) - 180.0)
mix_linearly(a::Float64, b::Float64, w) = (1.0 - w) * a + w * b
function mix_linearly(a::LCHuv{Float64}, b::LCHuv{Float64}, w)
    l = mix_linearly(a.l, b.l, w)
    c = mix_linearly(a.c, b.c, w)
    h = mix_hue(a.h, b.h, w)
    LCHuv{Float64}(l, c, h) # without hue normalization
end

function _sequential_palette(N, logscale, h, w, d, c, s, b, wcolor, dcolor)
    function term_point(pb, l1, l2, weight)
        pl = mix_linearly(l1, l2, weight)
        ph = mix_hue(h, pb.h, weight)
        mc = find_maximum_chroma(LCHuv{Float64}(pl, 0.0, ph))
        pc = min(mc, weight * s * pb.c)
        LCHuv{Float64}(pl, pc, ph)
    end

    pstart0 = convert(LCHuv{Float64}, wcolor)
    pend0   = convert(LCHuv{Float64}, dcolor)
    # Modify the hue of gray
    pstart = LCHuv{Float64}(pstart0.l, pstart0.c, pstart0.c < 1e-4 ? h : pstart0.h)
    pend   = LCHuv{Float64}(pend0.l,   pend0.c,   pend0.c   < 1e-4 ? h : pend0.h)

    p2 = term_point(pstart, 100.0, pstart.l, w) # multi-hue start point
    p1 = MSC(h)
    p0 = term_point(pend, 0.0, 20.0, d) # multi-hue ending point

    q0 = mix_linearly(p0, p1, s)
    q2 = mix_linearly(p2, p1, s)
    q1 = mix_linearly(q0, q2, 0.5)

    pal = Vector{RGB{Float64}}(undef, N)

    step = 1.0 / (N - 1.0)
    for i = 0:N-1
        if logscale
            u = 1.0 - exp10(2.0 * i * step - 2.0)
        else
            u = 1.0 - i * step
        end

        # Change grid to favor light colors and to be uniform along the curve
        lt = 125.0 - 125.0 * 0.2^mix_linearly(b, u, c)
        tt = inv_bezier(lt, p0.l, p2.l, q0.l, q1.l, q2.l)

        # Get color components from Bezier curves
        ll = bezier(tt, p0.l, p2.l, q0.l, q1.l, q2.l)
        cc = bezier(tt, p0.c, p2.c, q0.c, q1.c, q2.c)
        hh = bezier(tt, p0.h, p2.h, q0.h, q1.h, q2.h)

        @inbounds pal[i + 1] = convert(RGB{Float64}, LCHuv{Float64}(ll, cc, hh))
    end
    pal
end

"""
    diverging_palette(h1, h2, N::Int=100; <keyword arguments>)

Create diverging palettes by combining 2 sequential palettes.

# Arguments

- `N`        - number of colors
- `mid`      - the position of the midpoint (0,1)
- `h1`       - the main hue of the first part [0,360]
- `h2`       - the main hue of the latter part [0,360]
- `c`        - the overall lightness contrast [0,1]
- `s`        - saturation [0,1]
- `b`        - brightness [0,1]
- `w`        - cold/warm parameter, i.e. the strength of the starting color [0,1]
- `d1`       - depth of the ending color in the first part [0,1]
- `d2`       - depth of the ending color in the latter part [0,1]
- `wcolor`   - starting color, i.e. the middle color (warmness)
- `dcolor1`  - ending color of the first part (depth)
- `dcolor2`  - ending color of the latter part (depth)
- `logscale` - `true`/`false` for toggling logspacing
"""
function diverging_palette(h1,
                           h2,
                           N::Int=100;
                           mid=0.5,
                           w=0.15,
                           d1=0.0,
                           d2=0.0,
                           c=0.88,
                           s=0.6,
                           b=0.75,
                           wcolor =RGB(1.0, 1.0, 0.0),
                           dcolor1=RGB(1.0, 0.0, 0.0),
                           dcolor2=RGB(0.0, 0.0, 1.0),
                           logscale::Bool=false)
    F = Float64
    return _diverging_palette(N, F(mid), logscale,
                              F(h1), F(h2), F(w), F(d1), F(d2), F(c), F(s), F(b),
                              RGB{F}(wcolor), RGB{F}(dcolor1), RGB{F}(dcolor2))
end
function _diverging_palette(N, mid, logscale, h1, h2, w, d1, d2, c, s, b, wcolor, dcolor1, dcolor2)
    n = isodd(N) ? (N - 1) : N
    N1 = max(ceil(Int, mid * n), 1)
    N2 = max(n - N1, 1)

    pal1 = _sequential_palette(N1 + 1, logscale, h1, w, d1, c, s, b, wcolor, dcolor1)
    pal2 = _sequential_palette(N2 + 1, logscale, h2, w, d2, c, s, b, wcolor, dcolor2)

    pal = Vector{RGB{Float64}}(undef, N1 + N2 + isodd(N))
    # concatenation without `vcat`, which is not precompilable
    @inbounds pal2[1] = weighted_color_mean(0.5, pal1[1], pal2[1])
    @inbounds for i in eachindex(pal)
        pal[i] = i <= N1 ? pal1[end - i + 1] : pal2[i - N1 + iseven(N)]
    end
    pal
end


# Colormap
# ----------------------
# Main function to handle different predefined colormaps
#
"""
    colormap(cname, N=100; logscale=false, <keyword arguments>)

Returns a predefined sequential or diverging colormap computed using
the algorithm by Wijffelaars, M., et al. (2008).

Sequential colormaps `cname` choices are:

- `"Blues"`
- `"Grays"`
- `"Greens"`
- `"Oranges"`
- `"Purples"`
- `"Reds"`

Diverging colormap choices are `"RdBu"`.

Optionally, you can specify the number of colors `N` (default 100).

Extra control is provided by keyword arguments.
- `mid` sets the position of the midpoint for diverging colormaps.
- `logscale=true` uses logarithmically-spaced steps in the colormap.
You can also use keyword argument names that match the argument names in
[`sequential_palette`](@ref) or [`diverging_palette`](@ref).
"""
function colormap(cname::AbstractString, N::Integer=100; kvs...)
    _colormap(String(cname), Int(N), kvs)
end

function _colormap(cname::String, N::Int, kvs)
    logscale = get(kvs, :logscale, false)::Bool
    lcname = lowercase(cname)
    F = Float64
    if haskey(colormaps_sequential, lcname)
        keys_s = (:h, :w, :d, :c, :s, :b, :wcolor, :dcolor)
        Ts = Tuple{F,  F,  F,  F,  F,  F,  RGB{F},  RGB{F}}
        pbs = colormaps_sequential[lcname]::Ts
        for k in keys(kvs)
            k === :logscale && continue
            k in keys_s || throw(ArgumentError("Unknown keyword argument: $k"))
        end
        ps(i) = oftype(pbs[i], get(kvs, keys_s[i], pbs[i]))
        return _sequential_palette(N, logscale, (ps(i) for i in eachindex(pbs))...)
    end
    if haskey(colormaps_diverging, lcname)
        keys_d = (:h1, :h2, :w, :d1, :d2, :c, :s, :b, :wcolor, :dcolor1, :dcolor2)
        Td = Tuple{F,   F,   F,  F,   F,   F,  F,  F,  RGB{F},  RGB{F},   RGB{F}}
        pbd = colormaps_diverging[lcname]::Td
        for k in keys(kvs)
            k === :logscale && continue
            k === :mid && continue
            k in keys_d || throw(ArgumentError("Unknown keyword argument: $k"))
        end
        mid = Float64(get(kvs, :mid, 0.5))
        pd(i) = oftype(pbd[i], get(kvs, keys_d[i], pbd[i]))
        return _diverging_palette(N, mid, logscale, (pd(i) for i in eachindex(pbd))...)
    end
    throw(ArgumentError(string("Unknown colormap: ", cname)))
end

function _precompile_()
    ccall(:jl_generating_output, Cint, ()) == 1 || return nothing
    eltypes = (N0f8, N0f16, Float32, Float64)        # eltypes of parametric colors
    feltypes = (Float32, Float64)                    # floating-point eltypes
    pctypes = (Gray, RGB, AGray, GrayA, ARGB, RGBA)  # parametric colors
    cctypes = (Gray24, AGray32, RGB24, ARGB32)       # non-parametric colors
    # conversions
    ## from/to XYZ
    for T in feltypes, C in (HSV,LCHab,LCHuv,Lab,Luv,Oklab,Oklch)
        precompile(Tuple{typeof(convert),Type{C{T}},XYZ{T}})
        precompile(Tuple{typeof(convert),Type{XYZ{T}},C{T}})
    end
    for T in feltypes, F in eltypes
        precompile(Tuple{typeof(convert),Type{RGB{F}},XYZ{T}})
        precompile(Tuple{typeof(convert),Type{XYZ{T}},RGB{F}})
    end
    ## to RGB
    for T in eltypes, F in feltypes, C in (HSV,LCHab,LCHuv,Lab,Luv,Oklab,Oklch)
        precompile(Tuple{typeof(convert),Type{RGB{T}},C{F}})
    end
    # parse
    precompile(Tuple{typeof(parse),Type{ColorTypes.Colorant},String})
    precompile(Tuple{typeof(parse),Type{RGB{N0f8}},String})
    precompile(Tuple{typeof(parse),Type{RGBA{N0f8}},String})
    # colordiff
    for T in eltypes
        # Currently, there is a problem with `Float64` related to `cos`/`sin`.
        T === Float64 && continue
        precompile(Tuple{typeof(colordiff),RGB{T},RGB{T}})
    end
    precompile(Tuple{typeof(colormap),String})
    precompile(Tuple{typeof(colormap),String,Int})
    precompile(Tuple{typeof(distinguishable_colors),Int})
end

module SampleImages

using Colors
using Base64
using WebP

struct BeadsImageSVG <: Main.SVG
    buf::IOBuffer
end

const beads = WebP.read_webp(joinpath(@__DIR__, "src", "assets", "figures", "beads.webp"))

# The following code is ad-hoc and highly depends on "beads.svg".
# Be careful when modifying the svg file or its code.
function BeadsImageSVG(caption::String; filter=nothing, width="64mm", height="36mm")
    io = IOBuffer()

    write(io, """<svg version="1.1" viewBox="0 0 1920 1080" """)
    write(io, """xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" """)
    write(io, """width="$width" height="$height" image-rendering="optimizeQuality" """)
    write(io, """style="display:inline; margin-left:1em; margin-bottom:1em">\n""")

    img = filter === nothing ? beads : filter.(beads)
    webp = WebP.encode(img, lossy=true, quality=85)

    write(io, """<image width="1920" height="1080" xlink:href="data:image/webp;base64,""")

    b64enc = Base64EncodePipe(io)
    write(b64enc, webp)
    close(b64enc)

    write(io, """" />\n""")

    for style in ("fill:white;stroke:white;stroke-width:20;opacity:0.2", "fill:black;opacity:0.9")
        write(io,"""<text x="16" y="1000" style="$style;font-size:80px;">$caption</text>\n""")
    end

    write(io, """</svg>\n""")

    BeadsImageSVG(io)
end

end

using Colors

@testset "din99" begin
    # Test data from the DIN 6176 specification
    testdata = [
        ((50,  10,  10), (61.43,   9.70,   3.76)),
        ((50,  50,  50), (61.43,  28.64,  11.11)),
        ((50, -10,  10), (61.43,  -5.57,   7.03)),
        ((50, -50,  50), (61.43, -17.22,  21.75)),
        ((50, -10, -10), (61.43,  -9.70,  -3.76)),
        ((50, -50, -50), (61.43, -28.64, -11.11)),
        ((50,  10, -10), (61.43,   5.57,  -7.03)),
        ((50,  50, -50), (61.43,  17.22, -21.75)),
        (( 0,   0,   0), ( 0,      0,      0)),
        ((100,  0,   0), (100,     0,      0))]

    # A high error threshold has been chosen because converting from DIN99
    # to CIELAB with only two decimal places of accuracy yields fairly inaccurate
    # results due to the exponentiation.
    conveps = 0.05
    diffeps = 0.01
    let a, b, metric
        for (i, (a, b)) in enumerate(testdata)
            converted = convert(DIN99, Lab(a...))
            test = DIN99(b...)

            @test (abs(converted.l - test.l) < conveps)
            @test (abs(converted.a - test.a) < conveps)
            @test (abs(converted.b - test.b) < conveps)

            converted = convert(Lab, DIN99(b...))
            test = Lab(a...)

            @test (abs(converted.l - test.l) < conveps)
            @test (abs(converted.a - test.a) < conveps)
            @test (abs(converted.b - test.b) < conveps)

            # This is not a real test of the color difference metric, but at least
            # makes sure it isn't doing anything really crazy.
            metric = DE_DIN99()
            @test (abs(colordiff(convert(DIN99, Lab(a...)), DIN99(b...); metric=metric)) < diffeps)
        end
    end

    # From #256
    for c in (RGB(1, 0.5, 0),)
        @test colordiff(convert(RGB,convert(DIN99d, c)), c) < 1e-3
    end
    for c in (RGBA(1,0.5,0,0.4),)
        cc = convert(RGBA,convert(DIN99dA, c))
        @test colordiff(color(cc), color(c)) < 1e-3
        @test cc.alpha ≈ c.alpha atol=1e-3
    end
end  # @testset

# Color Differences

The [`colordiff`](@ref) function gives an approximate value for the difference between two colors.

```jldoctest example; setup = :(using Colors), filter = r"19.4859087377853\d*" => s"19.48590873778533"
julia> colordiff(colorant"red", colorant"darkred")
23.754143f0

julia> colordiff(colorant"red", colorant"blue")
52.881363f0

julia> colordiff(HSV(0, 0.75, 0.5), HSL(0, 0.75, 0.5))
19.48590873778533
```

```julia
    colordiff(a::Color, b::Color; metric=DE_2000())
```

Evaluate the [CIEDE2000](http://en.wikipedia.org/wiki/Color_difference#CIEDE2000) color difference formula by default. This gives an approximate measure of the perceptual difference between two colors to a typical viewer. A larger number is returned for increasingly distinguishable colors.

Options for `metric` are as follows:

| Metric             | Summary                                                                       |
|:-------------------|:------------------------------------------------------------------------------|
|[`DE_2000`](@ref)   | The color difference using the recommended CIE Delta E 2000 equation.         |
|[`DE_94`](@ref)     | The color difference using the recommended CIE Delta E 94 equation.           |
|[`DE_JPC79`](@ref)  | McDonald's "JP Coates Thread Company" color difference formula.               |
|[`DE_CMC`](@ref)    | The color difference using the CMC l:c equation.                              |
|[`DE_BFD`](@ref)    | The color difference using the BFD equation.                                  |
|[`DE_AB`](@ref)     | The original ΔE*, Euclidean color difference equation in the `Lab` colorspace.|
|[`DE_DIN99`](@ref)  | The Euclidean color difference equation applied in the `DIN99` colorspace.    |
|[`DE_DIN99d`](@ref) | The Euclidean color difference equation applied in the `DIN99d` colorspace.   |
|[`DE_DIN99o`](@ref) | The Euclidean color difference equation applied in the `DIN99o` colorspace.   |


The following charts show the differences between the three colors for each
metric with the default parameters:
```@example diff
using Colors # hide
using Main: ColorDiffCharts # hide
ColorDiffCharts.ColorDiffChartSVG(DE_2000()) # hide
```
```@example diff
ColorDiffCharts.ColorDiffChartSVG(DE_94()) # hide
```
```@example diff
ColorDiffCharts.ColorDiffChartSVG(DE_JPC79()) # hide
```
```@example diff
ColorDiffCharts.ColorDiffChartSVG(DE_CMC()) # hide
```
```@example diff
ColorDiffCharts.ColorDiffChartSVG(DE_BFD()) # hide
```
```@example diff
ColorDiffCharts.ColorDiffChartSVG(DE_AB()) # hide
```
```@example diff
ColorDiffCharts.ColorDiffChartSVG(DE_DIN99()) # hide
```
```@example diff
ColorDiffCharts.ColorDiffChartSVG(DE_DIN99d()) # hide
```
```@example diff
ColorDiffCharts.ColorDiffChartSVG(DE_DIN99o()) # hide
```
The difference in the size of circles in the charts above represents the
difference in the scale. The radii of the circles are all 20 in their scale
units, so larger circles mean that the metric returns smaller values. Therefore,
we should not compare the color differences between different metrics.

```@docs
colordiff
DE_2000()
DE_94()
DE_JPC79()
DE_CMC()
DE_BFD()
DE_AB()
DE_DIN99()
DE_DIN99d()
DE_DIN99o()
```

# Named Colors

The names of available colors are stored in alphabetical order in the dictionary
[`Colors.color_names`](https://github.com/JuliaGraphics/Colors.jl/blob/master/src/names_data.jl):

```julia
color_names = Dict(
    "aliceblue"            => (240, 248, 255),
    "antiquewhite"         => (250, 235, 215),
    "antiquewhite1"        => (255, 239, 219),
    ...
```


```@example chart
using Main: NamedColorCharts # hide
NamedColorCharts.ColorChartSVG("whites") # hide
```

```@example chart
NamedColorCharts.ColorChartSVG("reds") # hide
```

```@example chart
NamedColorCharts.ColorChartSVG("oranges") # hide
```

```@example chart
NamedColorCharts.ColorChartSVG("yellows") # hide
```

```@example chart
NamedColorCharts.ColorChartSVG("greens") # hide
```

```@example chart
NamedColorCharts.ColorChartSVG("cyans") # hide
```

```@example chart
NamedColorCharts.ColorChartSVG("blues") # hide
```

```@example chart
NamedColorCharts.ColorChartSVG("purples") # hide
```

```@example chart
NamedColorCharts.ColorChartSVG("pinks") # hide
```

```@example chart
NamedColorCharts.ColorChartSVG("browns") # hide
```

```@example chart
NamedColorCharts.ColorChartSVG("grays") # hide
```

!!! info
    Colors.jl supports the CSS/SVG named colors and the X11 named colors. The
    CSS/SVG named colors come from the 16 colors defined in HTML3.2 and the X11
    named colors. There are some unnatural definitions due to the different
    origins. For example, "LightGray" is lighter than "Gray", but "DarkGray" is
    also lighter than "Gray".

## Julia logo colors
[`Colors.JULIA_LOGO_COLORS`](@ref) is a `NamedTuple` containing the julia logo
colors defined in the [julia-logo-graphics](https://github.com/JuliaLang/julia-logo-graphics#color-definitions).
```@example julialogo
using Colors # hide
logocolors = Colors.JULIA_LOGO_COLORS
showable(::MIME"text/plain", ::AbstractVector{C}) where {C<:Colorant} = false # hide
[logocolors.blue, logocolors.red, logocolors.green, logocolors.purple]
```
```@docs
Colors.JULIA_LOGO_COLORS
```

# Introduction

This package provides a wide array of functions for dealing with color.

[Available colorspaces](@ref) include:

- `RGB`, `BGR`, `XRGB`, `RGBX`, `RGB24`
- `HSV`, `HSL`, `HSI`
- `XYZ`, `xyY`, `LMS`
- `Lab`, `Luv`, `LCHab`, `LCHuv`
- `DIN99`, `DIN99d`, `DIN99o`
- `YIQ`, `YCbCr`
- `Gray`, `Gray24`
- and their transparent variants: `ARGB`, `RGBA`, `ARGB32`, `AHSV`, `HSVA`, and so on

## Package Features

- [Color Parsing](@ref)
- [Color Conversions](@ref)
- [Color Differences](@ref)
- [Colormaps and Colorscales](@ref)
- [Simulation of color deficiency](@ref color_deficiency)


## Installation

The package can be installed with the Julia package manager. From the Julia
REPL, type `]` to enter the Pkg REPL mode and run:
```julia
pkg> add Colors
```

## Reexport

Note that Colors is used within other packages (e.g. [Images](https://github.com/JuliaImages/Images.jl))
and may have been [reexport](https://github.com/simonster/Reexport.jl)ed by them.
In addition, the color types used by Colors are defined in [ColorTypes](https://github.com/JuliaGraphics/ColorTypes.jl)
package. Colors reexports the types and functions exported by ColorTypes.
For example, that means:
```julia
julia> using Images; # instead `using Colors`

julia> RGB # You can use the types and functions (re-)exported by Colors.
RGB

julia> RGB === Images.RGB === Colors.RGB === ColorTypes.RGB
true
```

# Construction and Conversion


## Available colorspaces

The colorspaces used by Colors are defined in [ColorTypes](https://github.com/JuliaGraphics/ColorTypes.jl). Briefly, the defined spaces are:

- Red-Green-Blue spaces: `RGB`, `BGR`, `XRGB`, `RGBX`, `RGB24`, plus transparent versions `ARGB`, `RGBA`, `ABGR`, `BGRA`, and `ARGB32`.

- `HSV`, `HSL`, `HSI`, plus all 6 transparent variants (`AHSV`, `HSVA`, `AHSL`, `HSLA`, `AHSI`, `HSIA`)
```@example cross
using Colors # hide
using Main: CrossSectionalCharts # hide
CrossSectionalCharts.crosssection(HSV) # hide
```
```@example cross
CrossSectionalCharts.crosssection(HSL) # hide
```
```@example cross
CrossSectionalCharts.crosssection(HSI) # hide
```
- `XYZ`, `xyY`, `LMS` and all 6 transparent variants

- `Lab`, `Luv`, `LCHab`, `LCHuv` and all 8 transparent variants
```@example cross
CrossSectionalCharts.crosssection(Lab) # hide
```
```@example cross
CrossSectionalCharts.crosssection(Luv) # hide
```
```@example cross
CrossSectionalCharts.crosssection(LCHab) # hide
```
```@example cross
CrossSectionalCharts.crosssection(LCHuv) # hide
```
- `Oklab`, `Oklch` and their transparent variants
```@example cross
CrossSectionalCharts.crosssection(Oklab) # hide
```
```@example cross
CrossSectionalCharts.crosssection(Oklch) # hide
```
- `DIN99`, `DIN99d`, `DIN99o` and all 6 transparent variants

- Storage formats `YIQ`, `YCbCr` and their transparent variants
```@example cross
CrossSectionalCharts.crosssection(YIQ) # hide
```
```@example cross
CrossSectionalCharts.crosssection(YCbCr) # hide
```
- `Gray`, `Gray24`, and the transparent variants `AGray`, `GrayA`, and `AGray32`.


## Color Parsing

You can parse any [CSS color specification](https://developer.mozilla.org/en-US/docs/CSS/color)
with the exception of `currentColor`. You can construct colors from strings
using the [`@colorant_str`](@ref) macro and the [`parse`](@ref) function.

```jldoctest example
julia> using Colors

julia> colorant"red" # named color
RGB{N0f8}(1.0, 0.0, 0.0)

julia> parse(Colorant, "DeepSkyBlue") # color names are case-insensitive
RGB{N0f8}(0.0, 0.749, 1.0)

julia> colorant"#FF0000" # 6-digit hex notation
RGB{N0f8}(1.0, 0.0, 0.0)

julia> colorant"#f00" # 3-digit hex notation
RGB{N0f8}(1.0, 0.0, 0.0)

julia> colorant"rgb(255,0,0)" # rgb() notation with integers in [0, 255]
RGB{N0f8}(1.0, 0.0, 0.0)

julia> colorant"rgba(255,0,0,0.6)" # with alpha in [0, 1]
RGBA{N0f8}(1.0, 0.0, 0.0, 0.6)

julia> colorant"rgba(100%,80%,0.0%,0.6)" # with percentages
RGBA{N0f8}(1.0, 0.8, 0.0, 0.6)

julia> parse(ARGB, "rgba(255,0,0,0.6)") # you can specify the return type
ARGB{N0f8}(1.0, 0.0, 0.0, 0.6)

julia> colorant"hsl(120, 100%, 25%)" # hsl() notation
HSL{Float32}(120.0, 1.0, 0.25)

julia> colorant"hsla(120, 100%, 25%, 60%)" # hsla() notation
HSLA{Float32}(120.0, 1.0, 0.25, 0.6)

julia> colorant"transparent" # transparent "black"
RGBA{N0f8}(0.0, 0.0, 0.0, 0.0)
```

All CSS/SVG named colors are supported, in addition to X11 named colors, when their definitions do not clash with SVG.
You can find all names and their color swatches in [Named Colors](@ref) page.

When writing functions the `colorant"red"` version is preferred, because the slow step runs when the code is parsed (i.e., during compilation rather than run-time).

The element types of the return types depend on the colorspaces, i.e. the `hsl()`
and `hsla()` notations return `HSL`/`HSLA` colors with `Float32` elements, and
other notations return `RGB`/`RGBA` colors with `N0f8` elements. The result
colors can be converted to `RGB{N0f16}` (for example) using:

```jldoctest example
julia> using FixedPointNumbers

julia> RGB{N0f16}(colorant"indianred")
RGB{N0f16}(0.80392, 0.36078, 0.36078)
```
or
```jldoctest example
julia> parse(RGB{N0f16}, "indianred")
RGB{N0f16}(0.80392, 0.36078, 0.36078)
```


You can convert colors to hexadecimal strings using the [`hex`](@ref) function.
Note that the conversion result does not have the prefix `"#"`.

```jldoctest example
julia> col = colorant"#C0FFEE"
RGB{N0f8}(0.753, 1.0, 0.933)

julia> hex(col)
"C0FFEE"
```

## Color Conversions

Colors.jl allows you to convert from one colorspace to another using the `convert` function.

For example:

```jldoctest example
julia> convert(RGB, HSL(270, 0.5, 0.5)) # without the element type
RGB{Float64}(0.5, 0.25, 0.75)

julia> convert(RGB{N0f8}, HSL(270, 0.5, 0.5)) # with the element type
RGB{N0f8}(0.502, 0.251, 0.749)
```

Depending on the source and destination colorspace, this may not be perfectly lossless.

## Transparent - Opaque Conversions

Colors.jl allows you to convert colors to transparent or opaque types.

```jldoctest example
julia> col = colorant"yellow"
RGB{N0f8}(1.0, 1.0, 0.0)

julia> transparent = alphacolor(col, 0.5)  # or coloralpha(col)
ARGB{N0f8}(1.0, 1.0, 0.0, 0.502)

julia> opaque = color(transparent)
RGB{N0f8}(1.0, 1.0, 0.0)
```

---

```@docs
@colorant_str
parse
hex
normalize_hue
mean_hue
```

# Colormaps and Colorscales

## Color interpolation

### Generating a range of colors

The [`range()`](@ref) function has a method that accepts colors:

```julia
    Base.range(start::T; stop::T, length=100) where T<:Colorant
```

This generates N (=`length`) colors in a linearly interpolated ramp from `start`
to `stop`, inclusive, returning an `Array` of colors.

```jldoctest example
julia> using Colors

julia> c1 = colorant"red"
RGB{N0f8}(1.0, 0.0, 0.0)

julia> c2 = colorant"green"
RGB{N0f8}(0.0, 0.502, 0.0)

julia> range(c1, stop=c2, length=15)
15-element Vector{RGB{FixedPointNumbers.N0f8}}:
 RGB(1.0, 0.0, 0.0)
 RGB(0.929, 0.035, 0.0)
 RGB(0.859, 0.071, 0.0)
 RGB(0.784, 0.106, 0.0)
 RGB(0.714, 0.145, 0.0)
 RGB(0.643, 0.18, 0.0)
 RGB(0.573, 0.216, 0.0)
 RGB(0.502, 0.251, 0.0)
 RGB(0.427, 0.286, 0.0)
 RGB(0.357, 0.322, 0.0)
 RGB(0.286, 0.357, 0.0)
 RGB(0.216, 0.396, 0.0)
 RGB(0.141, 0.431, 0.0)
 RGB(0.071, 0.467, 0.0)
 RGB(0.0, 0.502, 0.0)
```
If you use Julia through VSCode or IJulia, you can get the following color swatches.
```@example range
using Colors # hide
showable(::MIME"text/plain", ::AbstractVector{C}) where {C<:Colorant} = false # hide
range(colorant"red", stop=colorant"green", length=15)
```
The intermediate colors depend on their colorspace. For example:
```@example range
range(HSL(colorant"red"), stop=HSL(colorant"green"), length=15)
```
The [`range`](@ref) and [`weighted_color_mean`](@ref) described below support
colors with hues which are out of the range [0, 360]. The hues of generated
colors are normalized into [0, 360].
```@example range
range(HSV(0,1,1), stop=HSV(-360,1,1), length=90) # inverse rotation
```
```@example range
range(LCHab(70,70,0), stop=LCHab(70,70,720), length=90) # multiple rotations
```
While sometimes useful in particular circumstances, typically it is recommended
that the hue be within [0, 360]. See [`normalize_hue`](@ref).

```@docs
Base.range
```
### Weighted color means

The [`weighted_color_mean()`](@ref) function returns a color that is the weighted mean of `c1` and `c2`, where `c1` has a weight 0 ≤ `w1` ≤ 1.

For example:

```jldoctest example
julia> weighted_color_mean(0.8, colorant"red", colorant"green")
RGB{N0f8}(0.8, 0.102, 0.0)
```
You can also get the weighted mean of three or more colors by passing the
collections of weights and colors. The following is an example of bilinear
interpolation.

```@example mean
using Colors # hide
[weighted_color_mean([(1-s)*(1-t), s*(1-t), (1-s)*t, s*t], # collection of weights
                     Colors.JULIA_LOGO_COLORS)             # collection of colors
                            for s = 0:0.2:1, t = 0:0.05:1]
```

```@docs
weighted_color_mean
```

## Colormaps

This package provides some pre-defined colormaps (described below). There are also several other packages which provide colormaps:

- [ColorSchemes](https://github.com/JuliaGraphics/ColorSchemes.jl)
- [PerceptualColourMaps](https://github.com/peterkovesi/PerceptualColourMaps.jl)
- [ColorBrewer](https://github.com/timothyrenner/ColorBrewer.jl)
- [NoveltyColors](https://github.com/randyzwitch/NoveltyColors.jl)


### Predefined sequential and diverging colormaps

The [`colormap()`](@ref) function returns a predefined sequential or diverging
colormap computed using the algorithm by Wijffelaars, M., et al. (2008).

```julia
colormap(cname::String [, N::Int=100; mid=0.5, logscale=false, <keyword arguments>])
```

The `cname` specifies the name of colormap. The currently supported names are:

#### Sequential

- "Blues"
```@example colormap
using Colors # hide
using Main: Colormaps, ColormapParams # hide
Colormaps.ColormapSVG(colormap("Blues", 32)) # hide
```

- "Greens"
```@example colormap
Colormaps.ColormapSVG(colormap("Greens", 32)) # hide
```

- "Grays"
```@example colormap
Colormaps.ColormapSVG(colormap("Grays", 32)) # hide
```

- "Oranges"
```@example colormap
Colormaps.ColormapSVG(colormap("Oranges", 32)) # hide
```

- "Purples"
```@example colormap
Colormaps.ColormapSVG(colormap("Purples", 32)) # hide
```

- "Reds"
```@example colormap
Colormaps.ColormapSVG(colormap("Reds", 32)) # hide
```

#### Diverging

- "RdBu" (from red to blue)
```@example colormap
Colormaps.ColormapSVG(colormap("RdBu", 32)) # hide
```

###

The optional arguments of `colormap()` are:

- the number of colors `N`
- position of the middle point `mid` for diverging colormaps
- the use of logarithmic scaling with the `logscale` keyword

Colormaps computed by this algorithm are guaranteed to have an increasing
perceived depth or saturation making them ideal for data visualization.
This also means that they are (in most cases) color-blind friendly and suitable
for black-and-white printing.

```@docs
colormap
```

### Sequential and diverging color palettes

You can create your own color palettes by using [`sequential_palette()`](@ref):

```julia
sequential_palette(h, [N::Int=100; c=0.88, s=0.6, b=0.75, w=0.15, d=0.0,
                   wcolor=RGB(1,1,0), dcolor=RGB(0,0,1), logscale=false])
```
which creates a sequential map for a hue `h` (defined in LCHuv space).

Other possible parameters that you can fine tune are:

* `N` - number of colors
* `c` - the overall lightness contrast [0,1]
* `s` - saturation [0,1]
* `b` - brightness [0,1]
* `w` - cold/warm parameter, i.e. the strength of the starting color [0,1]
* `d` - depth of the ending color [0,1]
* `wcolor` - starting color (usually defined to be yellow)
* `dcolor` - ending color (depth)
* `logscale` - `true`/`false` for toggling logspacing

```@example colormap
ColormapParams.ColormapParamSVG(:c) # hide
```
```@example colormap
ColormapParams.ColormapParamSVG(:s) # hide
```
```@example colormap
ColormapParams.ColormapParamSVG(:b) # hide
```
```@example colormap
ColormapParams.ColormapParamSVG(:w) # hide
```
```@example colormap
ColormapParams.ColormapParamSVG(:d) # hide
```

Two sequential maps can also be combined into a diverging colormap by using
[`diverging_palette()`](@ref):

```julia
diverging_palette(h1, h2 [, N::Int=100; mid=0.5, c=0.88, s=0.6, b=0.75, w=0.15, d1=0.0, d2=0.0,
                  wcolor=RGB(1,1,0), dcolor1=RGB(1,0,0), dcolor2=RGB(0,0,1), logscale=false])
```

where the arguments are:

* `h1`, `h2` - the main hue of the first/latter part [0,360]

and the optional arguments are:

* `N` - number of colors
* `mid` - the position of the midpoint (0,1)
* `c`, `s`, `b` - contrast, saturation, brightness [0,1]
* `w` - cold/warm parameter, i.e. the strength of the middle color [0,1]
* `d1`, `d2` - depth of the ending color in the first/latter part [0,1]
* `wcolor` - starting color i.e. the middle color
* `dcolor1`, `dcolor2` - ending color of the first/latter part (depth)
* `logscale` - `true`/`false` for toggling logspacing

For examples:
```@example colormap
diverging_palette(0, 200, 32)
Colormaps.ColormapSVG(diverging_palette(0, 200, 32)) # hide
```
```@example colormap
diverging_palette(0, 200, 32, mid=0.3)
Colormaps.ColormapSVG(diverging_palette(0, 200, 32, mid=0.3)) # hide
```
```@example colormap
diverging_palette(0, 200, 32, mid=0.3, logscale=true)
Colormaps.ColormapSVG(diverging_palette(0, 200, 32, mid=0.3, logscale=true)) # hide
```

```@docs
sequential_palette
diverging_palette
```

## Generating distinguishable colors

[`distinguishable_colors()`](@ref) generates `n` maximally distinguishable colors in LCHab space. A seed color or array of seed colors can be provided, and the remaining colors will be chosen to be maximally distinguishable from the seed colors and each other.

```julia
distinguishable_colors(n::Integer, seed::Color)
distinguishable_colors(n::Integer, seed::AbstractVector{<:Color})
```

By default, `distinguishable_colors` chooses maximally distinguishable colors from the outer product of lightness, chroma, and hue values specified by `lchoices`, `cchoices`, and `hchoices`. The set of colors that `distinguishable_colors` chooses from can be specified by passing different choices as keyword arguments.

```julia
distinguishable_colors(n::Integer, seed::AbstractVector{<:Color};
    dropseed = false,
    transform::Function = identity,
    lchoices::AbstractVector = range(0, stop=100, length=15),
    cchoices::AbstractVector = range(0, stop=100, length=15),
    hchoices::AbstractVector = range(0, stop=342, length=20)
)
```

Distinguishability is maximized with respect to the CIEDE2000 color difference formula (see `colordiff` in [Color Differences](@ref)). If a `transform` function is specified, color difference is instead maximized between colors `a` and `b` according to `colordiff(transform(a), transform(b))`.

Color arrays generated by `distinguishable_colors` are particularly useful for improving the readability of multiple trace plots.
Here’s an example using [`PyPlot`](https://github.com/JuliaPy/PyPlot.jl):

```julia
using PyPlot, Colors
vars = 1:10
cols = distinguishable_colors(length(vars), [RGB(1,1,1), RGB(0,0,0)], dropseed=true)
pcols = map(col -> (red(col), green(col), blue(col)), cols)
xs = 0:12
for i in vars
    plot(xs, map(x -> rand() + 0.1x - 0.5i, xs), c = pcols[i])
end
legend(vars, loc="upper right", bbox_to_anchor=[1.1, 1.])
```
```@setup pyplot
using Colors
cols = distinguishable_colors(10, [RGB(1,1,1), RGB(0,0,0)], dropseed=true) # see above
src_cols = ["c721dd", "d14a00", "008c00", "007fb1", "d1ac00",
            "870036", "ff8fa1", "00008b", "2eff71", "675200"]
patterns = Dict(zip(src_cols, hex.(cols, :rrggbb)))
path = joinpath("assets", "figures")
open(joinpath(path, "pyplot-seed-dcols.svg"), "w") do out
    for line in eachline(joinpath(path, "pyplot-seed-dcols-src.svg"))
        m = match(r"^(.+stroke:#)(.{6})(.+)$", line)
        if m === nothing || !(m.captures[2] in src_cols)
            println(out, line)
        else
            println(out, m.captures[1], patterns[m.captures[2]], m.captures[3])
        end
    end
end
```
![pyplot seed ex](assets/figures/pyplot-seed-dcols.svg)

To ensure that the generated colors stand out against the default white
background and black texts, `white` and `black`
(`[RGB(1,1,1), RGB(0,0,0)]`) were used as seed colors to `distinguishable_colors()`,
then dropped from the resulting array with `dropseed=true`.

The `distinguishable_colors` returns a vector of length `n` regardless of the
`dropseed` option. If `dropseed` is `true`, the leading seed colors will be
dropped, and the succeeding values ​​of `length(seed)` will be appended to the
end.
```@example dropseed;
using Colors #hide
showable(::MIME"text/plain", ::AbstractMatrix{C}) where {C<:Colorant} = false # hide

permutedims(hcat(
    distinguishable_colors(10, [RGB(1,1,1), RGB(0,0,0)], dropseed=false),
    distinguishable_colors(10, [RGB(1,1,1), RGB(0,0,0)], dropseed=true),
    distinguishable_colors(12, [RGB(1,1,1), RGB(0,0,0)])[3:end] # manually drop the seed colors
))
```
!!! compat "Colors v0.10"
    `dropseed` requires at least Colors v0.10. If you use an older version, drop
    the seed manually.

```@docs
distinguishable_colors
```

# References

What perceptually uniform colorspaces are and why you should be using them:

* Ihaka, R. (2003). [Colour for Presentation Graphics](http://www.stat.auckland.ac.nz/~ihaka/downloads/DSC-Color.pdf). In K Hornik, F Leisch, A Zeileis (eds.),  Proceedings of the 3rd International Workshop on Distributed Statistical Computing, Vienna, Austria. ISSN 1609-395X

* Zeileis, A., Hornik, K., and Murrell, P. (2009). [Escaping RGBland: Selecting colors for statistical graphics](http://epub.wu.ac.at/1692/1/document.pdf). Computational Statistics and Data Analysis, 53(9), 3259–3270. doi:10.1016/j.csda.2008.11.033

Functions in this library were mostly implemented according to:

* Schanda, J., ed. [Colorimetry: Understanding the CIE system](http://books.google.com/books?id=uZadszSGe9MC). Wiley-Interscience, 2007.

* Sharma, G., Wu, W., and Dalal, E. N. (2005). [The CIEDE2000 color‐difference formula](http://www.ece.rochester.edu/~gsharma/ciede2000/ciede2000noteCRNA.pdf): Implementation notes, supplementary test data, and mathematical observations. Color Research & Application, 30(1), 21–30. doi:10.1002/col

* Ihaka, R., Murrel, P., Hornik, K., Fisher, J. C., and Zeileis, A. (2013). [colorspace: Color Space Manipulation](http://CRAN.R-project.org/package=colorspace). R package version 1.2-1.

* Lindbloom, B. (2013).
  [Useful Color Equations](http://www.brucelindbloom.com/index.html?ColorCalculator.html)

* Wijffelaars, M., Vliegen, R., van Wijk, J., van der Linden, E-J. (2008). [Generating Color Palettes using Intuitive Parameters](https://dl.acm.org/doi/10.1111/j.1467-8659.2008.01203.x)

* Georg A. Klein [Industrial Color Physics](http://books.google.com/books?id=WsKOAVCrLnwC). Springer Series in Optical Sciences, 2010. ISSN 0342-4111, ISBN 978-1-4419-1197-1.

# Advanced Functions


## Color match for CIE Standard Observer

The `colormatch()` function returns an XYZ color corresponding to a wavelength specified in nanometers.

`colormatch(wavelen::Real)`

The CIE defines a *standard observer*, defining a typical frequency response curve for each of the three human eye cones.

For instance, conversion from optical wavelength to RGB can be achieved with:

```@example
using Colors # hide
showable(::MIME"text/plain", ::AbstractVector{C}) where {C<:Colorant} = false # hide
RGB.(colormatch.(350:10:750))
```

```@docs
colormatch
```

## Chromatic Adaptation (white balance)

The `whitebalance()` function converts a color according to a reference white point.

`whitebalance{T <: Color}(c::T, src_white::Color, ref_white::Color)`

Convert a color `c` viewed under conditions with a given source whitepoint `src_whitepoint` to appear the same under different conditions specified by a reference whitepoint `ref_white`.

```@docs
whitebalance
```


## [Simulation of color deficiency ("color blindness")](@id color_deficiency)

Three functions are provided that map colors to a reduced gamut to simulate different types of *dichromacy*, the loss of one of the three types of human photopigments.

*Protanopia*, *deuteranopia*, and *tritanopia* are the loss of long, middle, and short wavelength photopigment, respectively.

These functions take a color and return a new, altered color in the same colorspace.

```julia
protanopic(c::Color, p::Float64)
deuteranopic(c::Color, p::Float64)
tritanopic(c::Color, p::Float64)
```

Also provided are versions of these functions with an extra parameter `p` in `[0, 1]`, giving the degree of photopigment loss, where `1.0` is a complete loss, and `0.0` is no loss at all. The partial loss simulates the anomalous trichromacy, i.e. *protanomaly*, *deuteranomaly* and *tritanomaly*.

```@example deficiency
using Colors #hide
using Main: SampleImages # hide
SampleImages.BeadsImageSVG("Normal") # hide
```
```@example deficiency
SampleImages.BeadsImageSVG("Protanomaly (p=0.7)", filter=(c->protanopic(c, 0.7))) # hide
```
```@example deficiency
SampleImages.BeadsImageSVG("Deuteranomaly (p=0.7)", filter=(c->deuteranopic(c, 0.7))) # hide
```
```@example deficiency
SampleImages.BeadsImageSVG("Tritanomaly (p=0.7)", filter=(c->tritanopic(c, 0.7))) # hide
```

```@docs
protanopic
deuteranopic
tritanopic
```

## Most saturated color

The `MSC(h)` function returns the most saturated color for a given hue `h` (defined in LCHuv space, i.e. in range [0, 360]). Optionally the lightness `l` can also be given, as `MSC(h, l)`. The function calculates the color by finding the edge of the LCHuv space for a given angle (hue).

```@docs
MSC
```
